/***************************************************************************
MainScreen_Impl.cpp  -  description
-------------------
begin                : Mon Sep 23 2002
copyright            : (C) 2002 by David Rokhvarg
email                : drokhvarg@sangoma.com
***************************************************************************/

/***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
***************************************************************************/

#include "MainScreen_Impl.h"

#include <qpixmap.h>

#if defined(WIN32)
#include "..\include\common\tester.h"
#include "..\include\common\TesterDefines.h" //debug macros
#elif defined(BUILD_FOR_UNIX)
#include "TesterDefines.h" //debug macros
#endif

//this is the application icon in the top-left corner
static const char* const image0_data[] = { 
		"58 58 9 1",
		". c #212084",
		"a c #422084",
		"c c #424184",
		"# c #634184",
		"d c #636184",
		"f c #848284",
		"g c #c6dfc6",
		"e c #fffbf7",
		"b c #ffffff",
		"..........................................................",
		".....................#abbbbbbbbbbbcd......................",
		"..................cbbbbbbbbbbbbbbbbbba....................",
		"................cbbbbbbbbbbbbbbbbbbbbbbbc.................",
		"..............cbbbbbbbbbbbbbbbbbbbbbbbbbbb#...............",
		"............dbbbbbbbbbbbbbbbbbbbbbbbbbbbbbba..............",
		"...........cbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbc............",
		"..........abbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbc...........",
		".........bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbba..........",
		"........abbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbba.........",
		".......abbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbc........",
		"......cbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbc.......",
		".....cbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbd......",
		".....bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb......",
		"....abbbbbbe.............ebbbbbbbbbbbbbbbbbbbbbbbbbbc.....",
		"...dbbbbbbb..............ebbbbbbbbbbbbbbbbbbbbbbbbbbb.....",
		"...bbbbbbbb...............bbbbbbbbbbbbbbbbbbbbbbbbbbba....",
		"..dbbbbbbbe...ffffffff....bbbbbbbbbbbbbbbbbbbbbbbbbbbbd...",
		"..abbbbbbb....fffffffff...bbbbbbbbbbbbbbbbbbbbbbbbbbbbb...",
		"..bbbbbbbb...ffffffffff...bbbbbbbbbbbbbbbbbbbbbbbbbbbbb...",
		".#bbbbbbbb...ffffffffff...ebbbbbbbbbbbbbbbbbbbbbbbbbbbbb..",
		".abbbbbbb....fffffffffff...bbbbbbbbbbbbbbbbbbbbbbbbbbbbb..",
		".bbbbbbbb...ffffffffffff...bbbbbbbbbbbbbbbbbbbbbbbbbbbbbb.",
		".bbbbbbbb...ffffffffffff...ebbbbbbbbbbbbbbbbbbbbbbbbbbbbb.",
		".bbbbbbb....ffffffffffff....bbbbbbbbbbbbbbbbbbbbbbbbbbbbb.",
		".bbbbbbb...fffffffffffff....bbbbbbbbbbbbbbbbbbbbbbbbbbbbb.",
		".eeeeee....ffffffffffffff...bbbbbbbbbbbbbbbbbbbbbbbbbbbbb.",
		"...........ffffffffffffff...bbbbbbbbbbbbbbbbbbbbbbbbbbbbb.",
		"..........fffffffffffffff...ebbbbbbbbbbbbbbbbbbbbbbbbbbbb.",
		"..........fffffffffffffff....bbbbbbbbbbbbbbbbb............",
		".fffffffffffffffffffffffff...bbbbbbbbbbbbbbbb.............",
		".fffffffffffffffffffffffff...bbbbbbbbbbbbbbbb.............",
		".fffffffffffffffffffffffff...ebbbbbbbbbbbbbbb...fffffffff.",
		".fffffffffffffffffffffffff....bbbbbbbbbbbbbb....fffffffff.",
		".fffffffffffffffffffffffff....bbbbbbbbbbbbbb...ffffffffff.",
		".ffffffffffffffffffffffffff...bbbbbbbbbbbbbe...ffffffffff.",
		".ffffffffffffffffffffffffff...bbbbbbbbbbbbb....ffffffffff.",
		".ffffffffffffffffffffffffff...ebbbbbbbbbbbb...fffffffffff.",
		".ffffffffffffffffffffffffff....bbbbbbbbbbbe...ffffffffff..",
		".fffffffffffffffffffffffffff...bbbbbbbbbbb....ffffffffff..",
		"..ffffffffffffffffffffffffff...bbbbbbbbbbb...ffffffffff...",
		"...fffffffffffffffffffffffff...ebbbbbbbbbg...ffffffffff...",
		"...fffffffffffffffffffffffff...ebbbbbbbbb....fffffffff....",
		"....fffffffffffffffffffffffff...bbbbbbbbb...ffffffffff....",
		"....fffffffffffffffffffffffff...eeeeeeee....fffffffff.....",
		".....ffffffffffffffffffffffff...............ffffffff......",
		"......fffffffffffffffffffffff..............fffffffff......",
		".......ffffffffffffffffffffff..............ffffffff.......",
		".......fffffffffffffffffffffffffffffffffffffffffff........",
		"........fffffffffffffffffffffffffffffffffffffffff.........",
		".........fffffffffffffffffffffffffffffffffffffff..........",
		"..........fffffffffffffffffffffffffffffffffffff...........",
		"...........ffffffffffffffffffffffffffffffffff.............",
		".............fffffffffffffffffffffffffffffff..............",
		"..............ffffffffffffffffffffffffffff................",
		"................fffffffffffffffffffffffff.................",
		"..................ffffffffffffffffffffff..................",
		".........................................................."};
	
#define DBG_MAIN_SCREEN 0
	
char * question_str = "Are you sure you want to quit the Tester?";
	
int action_confirmation(char * question);
	
MainScreen_Impl::MainScreen_Impl(
								 QWidget* parent,
								 const char* name,
								 bool modal, WFlags fl ):QtMainScreenDialogBase(
								 parent,
								 name,
								 modal,
								 fl)
{
	monitor_process1 = NULL;
	monitor_process2 = NULL;
	wait_condition = new QWaitCondition();
	
	//On MS Windows it is possible to get this executable's full path!!
	//
	//For UNIX compilation it is hardcoded because :when shortcut
	//is used to start this application the current directory is always user's home directory!!
	//e.g. /root
#if defined(BUILD_FOR_UNIX)
	path = "/usr/local/bin/tester";
#elif defined(WIN32)
	
	char unitester_fname[MAX_PATH];
	char temp_buff[MAX_PATH];
	
	//form path to the UNITESTER.EXE file
	GetCurrentDirectory(MAX_PATH, unitester_fname);
	
	//Double quotes in case there are spaces in the path	
	sprintf(temp_buff, "\"%s%s\"", unitester_fname, "\\UNITESTER.EXE");
	
	DbgPrint2(DBG_MAIN_SCREEN,
		"MainScreen_Impl::MainScreen_Impl(): temp_buff : %s\n", temp_buff);
	
	//put into file name buffer
	path.sprintf("%s", temp_buff);
	
	DbgPrint2(DBG_MAIN_SCREEN,
		"MainScreen_Impl::MainScreen_Impl(): %s\n", (const char *)path);
#endif
	
	monitor_process1 = NULL;
	monitor_process2 = NULL;	
	
	//set the application icon in the top-left corner
	setIcon(( const char** ) image0_data);
}
	
MainScreen_Impl::~MainScreen_Impl()
{
	DbgPrint1(DBG_MAIN_SCREEN, "MainScreen_Impl::~MainScreen_Impl()\n");
	
	if(wait_condition)    delete wait_condition;
	if(monitor_process1)  delete monitor_process1;
	if(monitor_process2)  delete monitor_process2;
}
	
	
void MainScreen_Impl::on_btn_X25()
{
	QByteArray barr();
	QString crap;
	
	monitor_process1 = new QProcess();
	monitor_process1->addArgument( (const char *)path );
	
	monitor_process2 = new QProcess();
	monitor_process2->addArgument( (const char *)path );
	
	
	monitor_process1->addArgument( "0" );//card 0
	monitor_process1->addArgument( "0" );//x.25
	
	if (monitor_process1->launch(crap, 0) == FALSE)
	{	// error handling
		messages.sprintf("Please check that 'tester' file is in %s directory.", (const char *)path);
		QMessageBox::warning(	0, tr("Error Starting Tester 1."), tr((const char *)messages));
		done(0);
	}
	
#if defined(BUILD_FOR_UNIX)
	//wait for first application initialization!!
	wait_condition->wait(2000);
#endif
	
	monitor_process2->addArgument( "1" );//card 1
	monitor_process2->addArgument( "0" );//x.25
	
	if (monitor_process2->launch(crap, 0) == FALSE)
	{	// error handling
		messages.sprintf("Please check that 'tester' file is in %s directory.", (const char *)path);
		QMessageBox::warning(	0, tr("Error Starting Tester 2."), tr((const char *)messages));
	}
	
	connect( monitor_process1, SIGNAL(processExited()), this, SLOT(monitor1_exited()) );
	connect( monitor_process2, SIGNAL(processExited()), this, SLOT(monitor2_exited()) );
	
	showMinimized ();
	//hide();//do not use it - will terminate the application

	enable_disable_buttons(FALSE);
}

void MainScreen_Impl::on_btn_FrameRelay()
{
	QByteArray barr();
	QString crap;
	
	monitor_process1 = new QProcess();
	monitor_process1->addArgument( (const char *)path );
	
	monitor_process2 = new QProcess();
	monitor_process2->addArgument( (const char *)path );
	
	monitor_process1->addArgument( "0" );//card 0
	monitor_process1->addArgument( "1" );//frame relay
	
	if (monitor_process1->launch(crap, 0) == FALSE)
	{ // error handling
		messages.sprintf("Please check that 'tester' file is in %s directory.", (const char *)path);
		QMessageBox::warning(	0, tr("Error Starting Tester 1."), tr((const char *)messages));
		done(0);
	}
	
#if defined(BUILD_FOR_UNIX)
	//wait for first application initialization!!
	wait_condition->wait(2000);
#endif
	
	monitor_process2->addArgument( "1" );//card 1
	monitor_process2->addArgument( "1" );//frame relay
	
	if (monitor_process2->launch(crap, 0) == FALSE)
	{ // error handling
		messages.sprintf("Please check that 'tester' file is in %s directory.", (const char *)path);
		QMessageBox::warning(	0, tr("Error Starting Tester 2."), tr((const char *)messages));
	}
	
	connect( monitor_process1, SIGNAL(processExited()), this, SLOT(monitor1_exited()) );
	connect( monitor_process2, SIGNAL(processExited()), this, SLOT(monitor2_exited()) );
	
	showMinimized ();
	//hide();//do not use it - will terminate the application

	enable_disable_buttons(FALSE);
}
	
void MainScreen_Impl::on_btn_ATM()
{
	QByteArray barr();
	QString crap;
	
	monitor_process1 = new QProcess();
	monitor_process1->addArgument( (const char *)path );
	
	monitor_process2 = new QProcess();
	monitor_process2->addArgument( (const char *)path );
	
	monitor_process1->addArgument( "0" );//card 0
	monitor_process1->addArgument( "3" );//ATM
	
	if (monitor_process1->launch(crap, 0) == FALSE)
	{ // error handling
		messages.sprintf("Please check that 'tester' file is in %s directory.", (const char *)path);
		QMessageBox::warning(	0, tr("Error Starting Tester 1."), tr((const char *)messages));
		done(0);
	}
	
#if defined(BUILD_FOR_UNIX)
	//wait for first application initialization!!
	wait_condition->wait(2000);
#endif
	
	monitor_process2->addArgument( "1" );//card 1
	monitor_process2->addArgument( "3" );//ATM
	
	if (monitor_process2->launch(crap, 0) == FALSE)
	{ // error handling
		messages.sprintf("Please check that 'tester' file is in %s directory.", (const char *)path);
		QMessageBox::warning(	0, tr("Error Starting Tester 2."), tr((const char *)messages));
	}
	
	connect( monitor_process1, SIGNAL(processExited()), this, SLOT(monitor1_exited()) );
	connect( monitor_process2, SIGNAL(processExited()), this, SLOT(monitor2_exited()) );
	
	showMinimized ();
	//hide();//do not use it - will terminate the application

	enable_disable_buttons(FALSE);
}

void MainScreen_Impl::monitor1_exited()
{
	DbgPrint1(DBG_MAIN_SCREEN, "MainScreen_Impl::monitor1_exited()\n");
	
	if(monitor_process2 != NULL && monitor_process2->isRunning() == TRUE)
	{	
		monitor_process2->tryTerminate();
		delete monitor_process2;
		monitor_process2 = NULL;
		
		showNormal();

		enable_disable_buttons(TRUE);
	}
}

void MainScreen_Impl::monitor2_exited()
{
	DbgPrint1(DBG_MAIN_SCREEN, "MainScreen_Impl::monitor2_exited()\n");
	
	if(monitor_process1 != NULL && monitor_process1->isRunning() == TRUE)
	{	
		monitor_process1->tryTerminate();
		delete monitor_process1;
		monitor_process1 = NULL;
		
		showNormal();
			
		enable_disable_buttons(TRUE);
	}
}
	
	
void MainScreen_Impl::on_btn_Close()
{
	DbgPrint1(DBG_MAIN_SCREEN, "MainScreen_Impl::on_btn_Close()\n");

  close();
}

void MainScreen_Impl::closeEvent(QCloseEvent * e)
{
	DbgPrint1(DBG_MAIN_SCREEN, "MainScreen_Impl::closeEvent\n");
/*
	QMessageBox::information(NULL,
		"", "Please use \"Close\" button to exit the application.");
*/
	if(!action_confirmation(question_str))
	{	monitor1_exited();
  	monitor2_exited();
	  e->accept();
	}
}

void MainScreen_Impl::showEvent(QShowEvent * ev)
{
	DbgPrint1(DBG_MAIN_SCREEN, "MainScreen_Impl::showEvent()\n");
	
	//put the main window in the middle of the screen
	QDesktopWidget screen;
	
	setGeometry(
		(screen.width() - width())/2,
		(screen.height() - height())/2,
		width(), height()
		);
}

int action_confirmation(char * question)
{
	return QMessageBox::warning(NULL, "", question, "Yes", "No", 0, 0, 1);
}

void MainScreen_Impl::enable_disable_buttons(bool flag)
{
	btn_X25->setEnabled ( flag );
	btn_FrameRelay->setEnabled ( flag );
	btn_ATM->setEnabled ( flag );
}
