/***************************************************************************
MainScreen_Impl.h  -  description
-------------------
begin                : Mon Sep 23 2002
copyright            : (C) 2002 by David Rokhvarg
email                : drokhvarg@sangoma.com
***************************************************************************/

/***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
***************************************************************************/

#ifndef MAINSCREEN_IMPL_H
#define MAINSCREEN_IMPL_H


#define BUILD_FOR_UNIX

//
//////// QT library Header Files ////////
//
#include <qapplication.h>

#include <qpushbutton.h>
#include <qstring.h>
#include <qmessagebox.h>
#include <qlabel.h>
#include <qprocess.h>
#include <qwaitcondition.h>

#include "qtmainscreendialogbase.h"

/**
*@author David Rokhvarg
*/

class MainScreen_Impl : public QtMainScreenDialogBase  {
public: 
	MainScreen_Impl(QWidget* parent = 0,
					const char* name = 0,
					bool modal = TRUE,
					WFlags fl = 
						WStyle_Customize | WStyle_DialogBorder |
						WStyle_Title | WStyle_SysMenu |
						Qt::WType_TopLevel | Qt::WShowModal	|
						Qt::WStyle_MinMax
						);

	~MainScreen_Impl();
	
	void on_btn_X25();
	void on_btn_FrameRelay();
	void on_btn_ATM();
	void on_btn_Close();
	void monitor1_exited();
	void monitor2_exited();
	
	QProcess * monitor_process1;
	QProcess * monitor_process2;
	
	QString messages;
	QWaitCondition * wait_condition;
	QString path;
	
	void enable_disable_buttons(bool flag);

public slots:
	void closeEvent(QCloseEvent * e);
	void showEvent(QShowEvent * ev);
};

#endif
