/***************************************************************************
                          DataEntryImpl.cpp  -  description
                             -------------------
    begin                : Thu Oct 4 2001
    copyright            : (C) 2001 by DavidR
    email                : drokhvarg@sangoma.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "MainWizardImpl.h"

extern TesterWizardImpl * globalTesterWizPtr;

#define DBG_X25_DATA_ENTRY      0

DataEntryImpl::DataEntryImpl( 	QWidget* parent,
								const char* name,
								bool modal,
								WFlags fl) : DataEntry(	parent, name, modal, fl)
{
	lc = 0;
	set_widget_caption(this);
}

DataEntryImpl::~DataEntryImpl()
{
}

void DataEntryImpl::on_Cancel_clicked()
{	done(IDCANCEL);
}

void DataEntryImpl::on_OK_clicked()
{
	bool	ok = false;
	int		i_tmp, n;
	QString s_tmp;
	
	s_tmp = m_Data_101->text();
	strcpy((char *)globalTesterWizPtr->xcb.data, s_tmp.latin1());

	globalTesterWizPtr->xcb.buffer_length = s_tmp.length();

	s_tmp = m_LCN_102->text();
	i_tmp = s_tmp.toUShort(&ok, 10);
	globalTesterWizPtr->xcb.logical_channel = i_tmp;

	s_tmp = m_Cause_103->text();
	i_tmp = s_tmp.toUShort(&ok, 10);
	globalTesterWizPtr->xcb.cause = (BYTE)i_tmp;

	s_tmp = m_Diag_104->text();
	i_tmp = s_tmp.toUShort(&ok, 10);
	globalTesterWizPtr->xcb.diagnostic = (BYTE)i_tmp;

	qdm = 0;
	if (m_Qbit_105->isChecked() == true) qdm |= MASK_QBIT;
	if (m_Dbit_106->isChecked() == true) qdm |= MASK_DBIT;
	if (m_Mbit_107->isChecked() == true) qdm |= MASK_MBIT;

	globalTesterWizPtr->xcb.Q_D_M_bits = qdm;
	lc = globalTesterWizPtr->xcb.logical_channel;
	
	//this is for viewing the data in different formats
	if (m_ViewInASCII->isChecked() == true)
		globalTesterWizPtr->view_in_ascii = 1;
	else
		globalTesterWizPtr->view_in_ascii = 0;

	
	globalTesterWizPtr->xcb.command = command_type;

	if (m_SendHexData->isChecked() == true)
	{	
		//set to one, so next time the box is opened it's checked
		globalTesterWizPtr->send_hex_data = 1;
				
		//if data is to be sent in hex, save it first in 'tx_buffer',
		//parce it, and then copy to the control block buffer
		s_tmp = m_Data_101->text();
		strcpy((char *)globalTesterWizPtr->tx_buffer, s_tmp.latin1());
		n = s_tmp.length();

		DbgPrint2(DBG_X25_DATA_ENTRY, "read %d bytes\n", n);
		DbgPrint2(DBG_X25_DATA_ENTRY, "%s\n", globalTesterWizPtr->tx_buffer);

		//parse the string
		n=ParseTextToHex(n);
		if(n == 0)
		{	//parsing errors - put message and refuse to send and close the dialog
			return;
		}else
		{	globalTesterWizPtr->xcb.buffer_length = n;
		}
	}

	done(IDOK);
}

int DataEntryImpl::ParseTextToHex(int l)
{
	int i, j;
	DWORD v = 0;

	if(!IsValidString(l))
		return 0;

	i=0; j=0;
	while (i < l) {
		sscanf(&globalTesterWizPtr->tx_buffer[i], "%2lx", &v);
		globalTesterWizPtr->xcb.data[j] = (BYTE)v;
		v = 0;
		j++;
		//move to next two
		i+=2;
	}

	return(j);
}

int DataEntryImpl::IsValidString(int l)
{
	int i = 0;
	UCHAR tmp = 0;

	strupr(&globalTesterWizPtr->tx_buffer[0]);
	DbgPrint2(DBG_X25_DATA_ENTRY, "IsValidString() : %s\n", globalTesterWizPtr->tx_buffer);

	if((l < 2) || (l % 2))
	{	QMessageBox::warning(	0, "Invalid Input.",
			"Number of characters in data string is not even.");
		return 0;
	}

	while(i < l)
	{	tmp = globalTesterWizPtr->tx_buffer[i];

		//check it's alphanumeric char
		if(!isalnum(tmp) )
		{	QMessageBox::warning(	0, "Invalid Input.",
				"Not an alphanumeric character in data string.");
			return 0;
		}

		//check it's digit
		if(	!isdigit(tmp))
		{	//check it's a hex digit
			if(tmp < 'A' || tmp > 'F')
			{	QMessageBox::warning(	0, "Invalid Input.",
									"Not a hex digit in data string.");

				return 0;
			}
		}
		i++;
	}

	//passed all checks
	return 1;
}

//converts string to upper case
void DataEntryImpl::strupr(char * str)
{
	int len = strlen(str);

	for(int i = 0; i < len; i++)
		*(str+i) = (char)toupper(*(str+i));
}

void DataEntryImpl::showEvent(QShowEvent * ev)
{
	char s[100];
	QString tmp;

	set_widget_position_on_screen(this);

	//always uncheck QDM
	m_Qbit_105->setChecked(false);
	m_Dbit_106->setChecked(false);
	m_Mbit_107->setChecked(false);

	//always clear all edit fields
	m_Data_101->clear();
	m_LCN_102->clear();
	m_Cause_103->clear();
	m_Diag_104->clear();


	DbgPrint2(DBG_X25_DATA_ENTRY, "globalTesterWizPtr->xcb.command : 0x%x\n",
															 globalTesterWizPtr->xcb.command);
	command_type = globalTesterWizPtr->xcb.command;

	
	switch(globalTesterWizPtr->xcb.command)
	{
	case X25_READ:
		strcpy(s, "Receive Packet ");
		m_Data_101->setEnabled(false);

		m_LCN_102->setText(tmp.sprintf("%d", lc));
		m_LCN_102->setEnabled(true);

		m_Cause_103->setEnabled(false);
		m_Diag_104->setEnabled(false);

		m_Qbit_105->setEnabled(false);
		m_Dbit_106->setEnabled(false);
		m_Mbit_107->setEnabled(false);
		break;

	case X25_WRITE:
		strcpy(s, "Send Packet ");
		m_Data_101->setEnabled(true);

		if(lc==0)
			m_LCN_102->setText("1");
		else
			m_LCN_102->setText(tmp.sprintf("%d", lc));

		m_LCN_102->setEnabled(true);

		m_Cause_103->setEnabled(false);
		m_Diag_104->setEnabled(false);

		m_Qbit_105->setEnabled(true);
		m_Dbit_106->setEnabled(true);
		m_Mbit_107->setEnabled(true);

		globalTesterWizPtr->send_hex_data = 1;
		//initialize with Hex data
		tmp = "010203";
		m_Data_101->setText(tmp);
		break;

	case X25_PLACE_CALL:
		strcpy(s, "Place Call ");
		m_Data_101->setEnabled(true);

		m_LCN_102->setText("0");
		m_LCN_102->setEnabled(false);

		m_Cause_103->setEnabled(false);
		m_Diag_104->setEnabled(false);

		m_Qbit_105->setEnabled(false);
		m_Dbit_106->setEnabled(true);
		m_Mbit_107->setEnabled(false);
		break;

	case X25_ACCEPT_CALL:
		strcpy(s, "Accept Call ");

		m_LCN_102->setText(tmp.sprintf("%d", lc));
		m_LCN_102->setEnabled(true);

		m_Cause_103->setEnabled(false);
		m_Diag_104->setEnabled(false);

		m_Qbit_105->setEnabled(false);
		m_Dbit_106->setEnabled(true);
		m_Mbit_107->setEnabled(false);
		break;

	case X25_CLEAR_CALL:
		strcpy(s, "Clear Call ");

		//m_LCN_102->setText("0");
		m_LCN_102->setText(tmp.sprintf("%d", lc));
		m_LCN_102->setEnabled(true);

		m_Cause_103->setEnabled(true);
		m_Diag_104->setEnabled(true);

		m_Qbit_105->setEnabled(false);
		m_Dbit_106->setEnabled(false);
		m_Mbit_107->setEnabled(false);
		break;

	case X25_CONFIRM_CLEAR:
		strcpy(s, "Confirm Clear ");
		m_Data_101->setEnabled(true);

		//m_LCN_102->setText("0");
		m_LCN_102->setText(tmp.sprintf("%d", lc));
		m_LCN_102->setEnabled(true);

		m_Cause_103->setEnabled(true);
		m_Diag_104->setEnabled(true);

		m_Qbit_105->setEnabled(false);
		m_Dbit_106->setEnabled(false);
		m_Mbit_107->setEnabled(false);
		break;

	case X25_RESET_LOGICAL_CHANNEL:
		strcpy(s, "Reset Call ");
		m_Data_101->setEnabled(false);

		m_LCN_102->setText("1");
		m_LCN_102->setEnabled(true);

		m_Cause_103->setEnabled(true);
		m_Diag_104->setEnabled(true);

		m_Qbit_105->setEnabled(false);
		m_Dbit_106->setEnabled(false);
		m_Mbit_107->setEnabled(false);
		break;

	case X25_CONFIRM_RESET:
		strcpy(s, "Confirm Reset ");
		m_Data_101->setEnabled(true);

		m_LCN_102->setText("1");
		m_LCN_102->setEnabled(true);

		m_Cause_103->setEnabled(true);
		m_Diag_104->setEnabled(true);

		m_Qbit_105->setEnabled(false);
		m_Dbit_106->setEnabled(false);
		m_Mbit_107->setEnabled(false);
		break;

	case X25_RESTART:
		strcpy(s, "Restart ");
		m_Data_101->setEnabled(false);

		m_LCN_102->setText("0");
		m_LCN_102->setEnabled(false);

		m_Cause_103->setEnabled(true);
		m_Diag_104->setEnabled(true);

		m_Qbit_105->setEnabled(false);
		m_Dbit_106->setEnabled(false);
		m_Mbit_107->setEnabled(false);
		break;

	case X25_CONFIRM_RESTART:
		strcpy(s, "Confirm Restart ");
		m_Data_101->setEnabled(false);

		m_LCN_102->setText("0");
		m_LCN_102->setEnabled(false);

		m_Cause_103->setEnabled(false);
		m_Diag_104->setEnabled(false);

		m_Qbit_105->setEnabled(false);
		m_Dbit_106->setEnabled(false);
		m_Mbit_107->setEnabled(false);
		break;

	case X25_INTERRUPT:
		strcpy(s, "Send Interrupt Packet ");
		m_Data_101->setEnabled(true);

		m_LCN_102->setText("1");
		m_LCN_102->setEnabled(true);

		m_Cause_103->setEnabled(false);
		m_Diag_104->setEnabled (false);

		m_Qbit_105->setEnabled(false);
		m_Dbit_106->setEnabled(true);
		m_Mbit_107->setEnabled(false);
		break;

	case X25_CONFIRM_INTERRUPT:
		strcpy(s, "Confirm Interrupt ");
		m_Data_101->setEnabled(false);

		m_LCN_102->setText(tmp.sprintf("%d", lc));
		m_LCN_102->setEnabled  (true);

		m_Cause_103->setEnabled(false);
		m_Diag_104->setEnabled (false);

		m_Qbit_105->setEnabled(false);
		m_Dbit_106->setEnabled(false);
		m_Mbit_107->setEnabled(false);
		break;

	case X25_REGISTRATION_REQUEST:
		strcpy(s, "REGISTRATION_REQUEST ");
		break;
	case X25_REGISTRATION_CONFIRMATION:
		strcpy(s, "REGISTRATION_CONFIRMATION ");
		break;
	case X25_IS_DATA_AVAILABLE:
		strcpy(s, "IS_DATA_AVAILABLE ");
		break;
	case X25_INCOMING_CALL_CONTROL:
		strcpy(s, "INCOMING_CALL_CONTROL ");
		break;
	case X25_CONFIGURE_PVC:
		strcpy(s, "CONFIGURE_PVC ");
		break;
	case X25_READ_ACTIVE_CHANNELS:
		strcpy(s, "READ_ACTIVE_CHANNELS ");
		break;
	case X25_READ_CHANNEL_CONFIGURATION:
		strcpy(s, "READ_CHANNEL_CONFIGURATION ");
		break;
	case 	X25_FLUSH_X25_DATA_BUFFERS:
		strcpy(s, "Flush X25 Data Buffers ");
		m_Data_101->setEnabled(false);

		m_LCN_102->setEnabled  (true);
		m_Cause_103->setEnabled(false);
		m_Diag_104->setEnabled (false);

		m_Qbit_105->setEnabled(false);
		m_Dbit_106->setEnabled(false);
		m_Mbit_107->setEnabled(false);
		break;

	case X25_READ_X25_HISTORY_TABLE:
		strcpy(s, "READ_X25_HISTORY_TABLE ");
		break;
	case 	X25_HISTORY_TABLE_CONTROL:
		strcpy(s, "X25_HISTORY_TABLE_CONTROL ");
		break;
	case X25_READ_X25_STATISTICS:
		strcpy(s, "READ_X25_STATISTICS ");
		break;
	case X25_FLUSH_X25_STATISTICS:
		strcpy(s, "FLUSH_X25_STATISTICS ");
		break;
	case X25_READ_HDLC_X25_CONFIGURATION:
		strcpy(s, "READ_HDLC_X25_CONFIGURATION ");
		break;
	case X25_SET_HDLC_X25_CONFIGURATION:
		strcpy(s, "SET_HDLC_X25_CONFIGURATION ");
		break;
	default:
		strcpy(s, "Unknown Command ");
		break;
	}

	strcat(s, " Transaction Data");
	//Set caption of the dialog
	setCaption( tr( s ) );

	//always disable and uncheck these two first
	m_ViewInASCII->setEnabled(false);
	m_ViewInASCII->setChecked(false);
	m_SendHexData->setEnabled(false);
	m_SendHexData->setChecked(false);

	//if this is Send enable SEND_HEX_DATA check box.
	if(command_type == X25_WRITE)//0x5)
	{	m_SendHexData->setEnabled(true);
		
		if(globalTesterWizPtr->send_hex_data)
			m_SendHexData->setChecked(true);
	}
	
	//if this is Receive or Receive Many enable VIEW_IN_ASCII check box.
	if(command_type == X25_READ)//0x7 || command_type == 0x08)
	{	m_ViewInASCII->setEnabled(true);

		if(globalTesterWizPtr->view_in_ascii)
			m_ViewInASCII->setChecked(true);
	}
}
