/***************************************************************************
                          FrDlciCommands_Impl.cpp  -  description
                             -------------------
    begin                : Thu Sep 26 2002
    copyright            : (C) 2002 by David Rokhvarg
    email                : drokhvarg@sangoma.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "MainWizardImpl.h"

#define DBG_FR_DLCI_CMDS 0

extern char dlci_list[MAX_DLCIS+1];

FrDlciCommands_Impl::FrDlciCommands_Impl( QWidget* parent,
																          const char* name,
																          bool modal, WFlags fl ):FrDlciCommands(parent,
																																		 name,
																																		 modal,
																																		 fl)
{
  btn_Reserved->hide();
}

FrDlciCommands_Impl::~FrDlciCommands_Impl(){
}

int FrDlciCommands_Impl::my_show(char reason_for_showing)
{
  switch(reason_for_showing)
  {
    case SHOW_ADD_DLCI_AT_NODE:
      setCaption(tr("Add DLCIs (Access Node)"));
      break;

    case SHOW_ACTIVATE_DLCI_AT_NODE:
      setCaption(tr("Activate DLCIs (Access Node)"));
      break;

    case SHOW_DELETE_DLCI_AT_NODE:
      setCaption(tr("Delete DLCIs (Access Node)"));
      break;

    case SHOW_DEACTIVATE_DLCI_AT_NODE:
      setCaption(tr("Deactivate DLCIs (Access Node)"));
      break;
  }

  return exec();
}

void FrDlciCommands_Impl::on_Cancel()
{
  done(IDCANCEL);
}

void FrDlciCommands_Impl::on_OK()
{
  sprintf(dlci_list, "%s", (const char *)(LineEdit_Dlci_List->text()));

  done(IDOK);
}

void FrDlciCommands_Impl::closeEvent(QCloseEvent * e)
{
  DbgPrint1(DBG_FR_DLCI_CMDS, "FrDlciCommands_Impl::closeEvent\n");
  setResult(IDCANCEL);
  e->accept();
}

