// Fr_Comms_Err_Stats_Impl.cpp: implementation of the Fr_Comms_Err_Stats_Impl class.
//
//////////////////////////////////////////////////////////////////////

#include "MainWizardImpl.h"

extern TesterWizardImpl * globalTesterWizPtr;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Fr_Comms_Err_Stats_Impl::Fr_Comms_Err_Stats_Impl(QWidget* parent, const char* name,
								WFlags fl):Fr_Comms_Err_Stats(parent, name, fl)

{
	set_widget_caption(this);

	comesdata[0] = FLD_OVR;
	comesdata[1] = FLD_CRC;
	comesdata[2] = FLD_ABORTR;
	comesdata[3] = FLD_RDISC;
	comesdata[4] = (QLabel *)0xffff;
	comesdata[5] = FLD_ABORTT;
	comesdata[6] = FLD_UIM;
	comesdata[7] = (QLabel *)0xffff;
	comesdata[8] = FLD_DCD;
	comesdata[9] = FLD_CTS;
	comesdata[10] = (QLabel *)0;
}

Fr_Comms_Err_Stats_Impl::~Fr_Comms_Err_Stats_Impl()
{

}

void Fr_Comms_Err_Stats_Impl::showEvent(QShowEvent * ev)
{
	set_widget_position_on_screen(this);
}

void Fr_Comms_Err_Stats_Impl::closeEvent(QCloseEvent * e)
{
	globalTesterWizPtr->fr_menu_link_monitor->
		setItemChecked(globalTesterWizPtr->fr_menu_link_monitor->idAt(3), FALSE );
	hide();
}

void Fr_Comms_Err_Stats_Impl::timerEvent(QTimerEvent * e)
{
	globalTesterWizPtr->ResetCB(&globalTesterWizPtr->fcb);

	globalTesterWizPtr->fcb.command = FR_READ_COMMS_ERR_STATS;
	globalTesterWizPtr->fcb.buffer_length = 0;
	globalTesterWizPtr->fcb.dlci = 0;
	globalTesterWizPtr->Fr_DoCommand();

	if (!globalTesterWizPtr->CompCB(&lastcb, &globalTesterWizPtr->fcb))
	{
		if (globalTesterWizPtr->fcb.return_code == 0) 
		{
			globalTesterWizPtr->SaveCB(&lastcb, &globalTesterWizPtr->fcb);

			int c=0;
			while(comesdata[c] != 0)
			{
				if (comesdata[c] != (QLabel *)0xffff)
				{	txt.sprintf("%d", 
						globalTesterWizPtr->fcb.data[c]);
					comesdata[c]->setText(txt);
				}
				c++;
			}
		}
	}
}


void Fr_Comms_Err_Stats_Impl::on_Flush_clicked()
{
	DbgPrint1(_DEBUG, "Fr_Comms_Err_Stats_Impl::on_Flush_clicked()");

	globalTesterWizPtr->fcb.command = FR_FLUSH_COMMS_ERR_STATS;
	globalTesterWizPtr->fcb.buffer_length = 1;
	globalTesterWizPtr->fcb.dlci = 0;
	globalTesterWizPtr->fcb.data[0] = 1;
	globalTesterWizPtr->Fr_DoCommand();
}

