// Fr_ConfiguredDlcis_Impl.cpp: implementation of the Fr_ConfiguredDlcis_Impl class.
//
//////////////////////////////////////////////////////////////////////

#include "MainWizardImpl.h"

extern TesterWizardImpl * globalTesterWizPtr;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Fr_ConfiguredDlcis_Impl::Fr_ConfiguredDlcis_Impl(QWidget* parent, const char* name,
									   WFlags fl):Fr_ConfiguredDlcis(parent, name, fl)

{
	set_widget_caption(this);

	per_dlci_stats = new Fr_DLCI_Statistics_Impl(0, 0, 0);
}

Fr_ConfiguredDlcis_Impl::~Fr_ConfiguredDlcis_Impl()
{
	delete per_dlci_stats;
}

void Fr_ConfiguredDlcis_Impl::showEvent(QShowEvent * ev)
{
	set_widget_position_on_screen(this);
}

void Fr_ConfiguredDlcis_Impl::closeEvent(QCloseEvent * e)
{
	per_dlci_stats->hide();

	globalTesterWizPtr->fr_menu_dlci_monitor->
		setItemChecked(globalTesterWizPtr->fr_menu_dlci_monitor->idAt(0), FALSE );
	hide();
}

void Fr_ConfiguredDlcis_Impl::timerEvent(QTimerEvent * e)
{
	globalTesterWizPtr->ResetCB(&globalTesterWizPtr->fcb);

	globalTesterWizPtr->fcb.command = FR_READ_DLC_STATUS;
	globalTesterWizPtr->fcb.buffer_length = 0;
	globalTesterWizPtr->fcb.dlci = 0;
	globalTesterWizPtr->Fr_DoCommand();

	if (!globalTesterWizPtr->CompCB(&lastcb, &globalTesterWizPtr->fcb))
	{
		if (globalTesterWizPtr->fcb.return_code == 0) 
		{
			globalTesterWizPtr->SaveCB(&lastcb, &globalTesterWizPtr->fcb);

			ListBox_Inactive->clear();
			ListBox_Active->clear();

			for (c = 0; c < (lastcb.buffer_length/3); c++) 
			{
				dlci = globalTesterWizPtr->GetDUI((BYTE *)(lastcb.data+(c*3)+1));

				txt.sprintf("%u   ", dlci);
				x = *(lastcb.data+(c*3)+3);
				if (x & 0x01) txt += " D";
				if (x & 0x04) txt += " W";
				if (x & 0x08) txt += " N";
				if (x & 0x40) txt += " Inc";

				if(x & 0x02)
				{	ADDSTR(ListBox_Active, (const char *)txt);
				}else
				{	ADDSTR(ListBox_Inactive, (const char *)txt);
				}
			}
		}
	}
}

void Fr_ConfiguredDlcis_Impl::on_active_double_clicked()
{
	if(ListBox_Active->currentItem() == -1)
	{	QMessageBox::warning(0, "", "No DLCI was selected");
	}

	dlci = atoi((const char *)(ListBox_Active->currentText()));

	DbgPrint2(_DEBUG, "active dlci : %d\n", dlci);

	per_dlci_stats->set_dlci_to_poll(dlci);
	per_dlci_stats->show();
}

void Fr_ConfiguredDlcis_Impl::on_inactive_double_clicked()
{
	if(ListBox_Inactive->currentItem() == -1)
	{	QMessageBox::warning(0, "", "No DLCI was selected");
	}

	dlci = atoi((const char *)(ListBox_Inactive->currentText()));

	DbgPrint2(_DEBUG, "inactive dlci : %d\n", dlci);

	per_dlci_stats->set_dlci_to_poll(dlci);
	per_dlci_stats->show();
}

