// Fr_CpeSpecificStats_Impl.cpp: implementation of the Fr_CpeSpecificStats_Impl class.
//
//////////////////////////////////////////////////////////////////////

#include "MainWizardImpl.h"

extern TesterWizardImpl * globalTesterWizPtr;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Fr_CpeSpecificStats_Impl::Fr_CpeSpecificStats_Impl(QWidget* parent, const char* name,
									   WFlags fl):Fr_CpeSpecificStats(parent, name, fl)
{
	window_closed = TRUE;

	memset(&lastcb, 0x00, sizeof(FCBLOCK));

	//Init the array to NULLs, only the ones which are not NULLs will be used.
	for(int i=0; i < NUM_OPSTATS_OPS; i++)
		fr_stats_data[i] = NULL;

	//now init those which will be used
	fr_stats_data[18] = txt_218;
	fr_stats_data[24] = txt_224;
	fr_stats_data[15] = txt_215;

	fr_stats_data[6] = txt_206;
	fr_stats_data[7] = txt_207;

	fr_stats_data[8] = txt_208;
	fr_stats_data[9] = txt_209;
}

Fr_CpeSpecificStats_Impl::~Fr_CpeSpecificStats_Impl()
{

}

void Fr_CpeSpecificStats_Impl::showEvent(QShowEvent * ev)
{
	set_widget_position_on_screen(this);
}

void Fr_CpeSpecificStats_Impl::closeEvent(QCloseEvent * e)
{
	globalTesterWizPtr->fr_menu_link_monitor->
		setItemChecked(globalTesterWizPtr->fr_menu_link_monitor->idAt(2), FALSE );

	window_closed = TRUE;

	e->accept();
}

void Fr_CpeSpecificStats_Impl::timerEvent(QTimerEvent * e)
{
	globalTesterWizPtr->ResetCB(&globalTesterWizPtr->fcb);

	globalTesterWizPtr->fcb.command = FR_READ_DLC_STATISTICS;
	globalTesterWizPtr->fcb.buffer_length = 0;
	globalTesterWizPtr->fcb.dlci = 0;
	globalTesterWizPtr->Fr_DoCommand();

	if (!globalTesterWizPtr->CompCB(&lastcb, &globalTesterWizPtr->fcb))
	{
		if (globalTesterWizPtr->fcb.return_code == 0) 
		{
			globalTesterWizPtr->SaveCB(&lastcb, &globalTesterWizPtr->fcb);
			for (int c = 0; c < NUM_OPSTATS_OPS; c++)
			{
				if(fr_stats_data[c] != NULL)
				{
					txt.sprintf("%d",
  						globalTesterWizPtr->
	  						GetDUI((BYTE *)(globalTesterWizPtr->fcb.data+(c*2))));

					fr_stats_data[c]->setText(txt);
				}
			}
		}
	}
}

void Fr_CpeSpecificStats_Impl::on_flush_clicked()
{
	DbgPrint1(_DEBUG, "Fr_CpeSpecificStats_Impl::on_flush_clicked()");

	globalTesterWizPtr->fcb.command = FR_FLUSH_DLC_STATISTICS;
	globalTesterWizPtr->fcb.buffer_length = 1;
	globalTesterWizPtr->fcb.dlci = 0;
	globalTesterWizPtr->fcb.data[0] = 1;
	globalTesterWizPtr->Fr_DoCommand();
}

BOOL Fr_CpeSpecificStats_Impl::my_isVisible()
{
	return (window_closed == FALSE) ? TRUE : FALSE;
}

BOOL Fr_CpeSpecificStats_Impl::my_show()
{
	window_closed = FALSE;
	show();
	return TRUE;
}
