// Fr_DLCI_Statistics_Impl.cpp: implementation of the Fr_DLCI_Statistics_Impl class.
//
//////////////////////////////////////////////////////////////////////

#include "MainWizardImpl.h"

extern TesterWizardImpl * globalTesterWizPtr;

#define	NUM_DLCISPEC_OPS	12

typedef union {
	struct {
		BYTE x1, x2, x3, x4;
	} b;
	DWORD v;
} DW_V;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Fr_DLCI_Statistics_Impl::Fr_DLCI_Statistics_Impl(QWidget* parent, const char* name,
									   WFlags fl):Fr_DLCI_Statistics(parent, name, fl)

{
	set_widget_caption(this);

	memset(stats_data, 0x00, NUM_DLCI_STATS);

	stats_data[0] = txt_200;
	stats_data[1] = txt_201;

	stats_data[2] = txt_202;
	stats_data[3] = txt_203;

	stats_data[4] = txt_204;
	stats_data[5] = txt_205;

	stats_data[6] = txt_206;
	stats_data[7] = txt_207;
}

Fr_DLCI_Statistics_Impl::~Fr_DLCI_Statistics_Impl()
{

}

void Fr_DLCI_Statistics_Impl::showEvent(QShowEvent * ev)
{
	set_widget_position_on_screen(this);
}

void Fr_DLCI_Statistics_Impl::closeEvent(QCloseEvent * e)
{
	hide();
}

void Fr_DLCI_Statistics_Impl::timerEvent(QTimerEvent * e)
{
	int c, d;
	DW_V dv;

	//DbgPrint1(_DEBUG, "Fr_DLCI_Statistics_Impl::timerEvent()\n");

	globalTesterWizPtr->ResetCB(&globalTesterWizPtr->fcb);

	globalTesterWizPtr->fcb.command = FR_READ_DLC_STATISTICS;
	globalTesterWizPtr->fcb.buffer_length = 1;
	globalTesterWizPtr->fcb.dlci = dlci;
	globalTesterWizPtr->fcb.data[0] = 0;
	globalTesterWizPtr->Fr_DoCommand();

	if (globalTesterWizPtr->fcb.return_code == 0) 
	{
		globalTesterWizPtr->SaveCB(&lastcb, &globalTesterWizPtr->fcb);

		d = NUM_DLCISPEC_OPS-4;

		for (c = 0; c < d; c++) 
		{
			if(stats_data[c])
			{
				dv.b.x1 = lastcb.data[c*4];
				dv.b.x2 = lastcb.data[(c*4)+1];
				dv.b.x3 = lastcb.data[(c*4)+2];
				dv.b.x4 = lastcb.data[(c*4)+3];

				txt.sprintf("%lu", dv.v);
				stats_data[c]->setText(txt);
			}
		}
	}
}

void Fr_DLCI_Statistics_Impl::on_flush_clicked()
{
	globalTesterWizPtr->fcb.command = FR_FLUSH_DLC_STATISTICS;
	globalTesterWizPtr->fcb.buffer_length = 1;
	globalTesterWizPtr->fcb.dlci = dlci;
	globalTesterWizPtr->fcb.data[0] = 0;
	globalTesterWizPtr->Fr_DoCommand();
}

void Fr_DLCI_Statistics_Impl::set_dlci_to_poll(unsigned short d)
{
	dlci = d;
	txt.sprintf("DLCI %u Statistics", d);
	setCaption( txt );
}

