// Fr_DlciList_Impl.cpp: implementation of the Fr_DlciList_Impl class.
//
//////////////////////////////////////////////////////////////////////

#include "MainWizardImpl.h"

extern TesterWizardImpl * globalTesterWizPtr;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Fr_DlciList_Impl::Fr_DlciList_Impl(	QWidget* parent,
									const char* name,
									bool modal,
									WFlags fl) : Fr_DlciList(parent, name, modal, fl)
{
	PushButton10->hide();
}

Fr_DlciList_Impl::~Fr_DlciList_Impl()
{

}

void Fr_DlciList_Impl::set_command(unsigned char command)
{
	switch(command)
	{
	case FR_ADD_DLCI:
		setCaption("Add DLCIs (Access Node)");
		break;
	case FR_ACTIVATE_DLCI:
		setCaption("Activate DLCIs (Access Node)");
		break;
	case FR_DELETE_DLCI:
		setCaption("Delete DLCIs (Access Node)");
		break;
	case FR_DEACTIVATE_DLCI:
		setCaption("Deactivate DLCIs (Access Node)");
		break;
	}
}

void Fr_DlciList_Impl::showEvent(QShowEvent * ev)
{
	unsigned short * dlci_ptr = 
		(unsigned short *)globalTesterWizPtr->set_fr_cfg.configured_dlcis;

	ListBox_ConfiguredDlcis->clear();
	ListBox_DlcisInCommand->clear();

	while (*dlci_ptr != 0)
	{	str.sprintf("%d", *dlci_ptr);
		ListBox_ConfiguredDlcis->insertItem( str, -1 );
		dlci_ptr ++;
	}
}

void Fr_DlciList_Impl::closeEvent(QCloseEvent * e)
{
	done(IDCANCEL);
}

void Fr_DlciList_Impl::on_remove_clicked()
{
	if(ListBox_DlcisInCommand->currentItem() == -1)
	{	QMessageBox::warning(0, "", "No DLCI was selected. Please select a DLCI to remove.");
		return;
	}

	ListBox_ConfiguredDlcis->insertItem(ListBox_DlcisInCommand->currentText(), -1 );
	ListBox_DlcisInCommand->removeItem(ListBox_DlcisInCommand->currentItem());

	ListBox_DlcisInCommand->sort(TRUE);
	ListBox_ConfiguredDlcis->sort(TRUE);
}

void Fr_DlciList_Impl::on_add_clicked()
{
	if(ListBox_ConfiguredDlcis->currentItem() == -1)
	{	QMessageBox::warning(0, "", "No DLCI was selected. Please select a DLCI to add.");
		return;
	}

	ListBox_DlcisInCommand->insertItem(ListBox_ConfiguredDlcis->currentText(), -1) ;
	ListBox_ConfiguredDlcis->removeItem(ListBox_ConfiguredDlcis->currentItem());

	ListBox_DlcisInCommand->sort(TRUE);
	ListBox_ConfiguredDlcis->sort(TRUE);
}

void Fr_DlciList_Impl::on_ok_clicked()
{
	QString temp = "";

	int count = ListBox_DlcisInCommand->count();

	if(!count)
	{	QMessageBox::warning(0, "",
			"No DLCI was added to list of DLCIs included in Command. Use \"Cancel\" button to close this dialog .");
		return;
	}

	memset(dlci_list, 0x00, sizeof(dlci_list));

	for(int i=0; i < count; i++)
	{	temp += ListBox_DlcisInCommand->text (i);
		temp += " ";
	}

	sprintf(dlci_list, "%s", (const char *)temp);

	DbgPrint2(_DEBUG, "dlci_list : %s\n", dlci_list);

	done(IDOK);
}

