// Fr_GlobalStats_Impl.cpp: implementation of the Fr_GlobalStats_Impl class.
//
//////////////////////////////////////////////////////////////////////

#include "MainWizardImpl.h"

extern TesterWizardImpl * globalTesterWizPtr;

#define DBG_FR_GLOB_STATS 1

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Fr_GlobalStats_Impl::Fr_GlobalStats_Impl(QWidget* parent, const char* name,
									   WFlags fl):Fr_GlobalStats(parent, name, fl)

{
	window_closed = TRUE;

	set_widget_caption(this);

	memset(&lastcb, 0x00, sizeof(FCBLOCK));

	//Init the array to NULLs, only the ones which are not NULLs will be used.
	for(int i=0; i < NUM_OPSTATS_OPS; i++)
		fr_stats_data[i] = NULL;

	//now init those which will be used
	fr_stats_data[0] = txt_200;
	fr_stats_data[1] = txt_201;

	fr_stats_data[14] = txt_214;
	fr_stats_data[20] = txt_220;
	fr_stats_data[21] = txt_221;

	fr_stats_data[22] = txt_222;
	fr_stats_data[23] = txt_223;
	fr_stats_data[16] = txt_216;
	fr_stats_data[17] = txt_217;
	fr_stats_data[21] = txt_221;

	fr_stats_data[26] = txt_226;
	fr_stats_data[27] = txt_227;

	fr_stats_data[2] = txt_202;
	fr_stats_data[3] = txt_203;
	fr_stats_data[4] = txt_204;
}

Fr_GlobalStats_Impl::~Fr_GlobalStats_Impl()
{

}

void Fr_GlobalStats_Impl::showEvent(QShowEvent * ev)
{
	DbgPrint1(DBG_FR_GLOB_STATS, "Fr_GlobalStats_Impl::showEvent()");

	set_widget_position_on_screen(this);
}

void Fr_GlobalStats_Impl::closeEvent(QCloseEvent * e)
{
	globalTesterWizPtr->fr_menu_link_monitor->
		setItemChecked(globalTesterWizPtr->fr_menu_link_monitor->idAt(1), FALSE );

	window_closed = TRUE;

	e->accept();
}

void Fr_GlobalStats_Impl::timerEvent(QTimerEvent * e)
{
	DbgPrint1(DBG_FR_GLOB_STATS, "Fr_GlobalStats_Impl::timerEvent()");

	globalTesterWizPtr->ResetCB(&globalTesterWizPtr->fcb);

	globalTesterWizPtr->fcb.command = FR_READ_DLC_STATISTICS;
	globalTesterWizPtr->fcb.buffer_length = 0;
	globalTesterWizPtr->fcb.dlci = 0;
	globalTesterWizPtr->Fr_DoCommand();

	if (!globalTesterWizPtr->CompCB(&lastcb, &globalTesterWizPtr->fcb))
	{
		if (globalTesterWizPtr->fcb.return_code == 0) 
		{
			globalTesterWizPtr->SaveCB(&lastcb, &globalTesterWizPtr->fcb);
			for (int c = 0; c < NUM_OPSTATS_OPS; c++)
			{
				if(fr_stats_data[c] != NULL)
				{
					txt.sprintf("%d",
  						globalTesterWizPtr->
	  						GetDUI((BYTE *)(globalTesterWizPtr->fcb.data+(c*2))));

					fr_stats_data[c]->setText(txt);
				}
			}
		}
	}
}

void Fr_GlobalStats_Impl::on_flush_clicked()
{
	DbgPrint1(DBG_FR_GLOB_STATS, "Fr_GlobalStats_Impl::on_flush_clicked()");

	globalTesterWizPtr->fcb.command = FR_FLUSH_DLC_STATISTICS;
	globalTesterWizPtr->fcb.buffer_length = 1;
	globalTesterWizPtr->fcb.dlci = 0;
	globalTesterWizPtr->fcb.data[0] = 1;
	globalTesterWizPtr->Fr_DoCommand();
}

BOOL Fr_GlobalStats_Impl::my_isVisible()
{
	return (window_closed == FALSE) ? TRUE : FALSE;
}

BOOL Fr_GlobalStats_Impl::my_show()
{
	window_closed = FALSE;
	show();
	return TRUE;
}
