// Fr_LinkStatus_Impl.cpp: implementation of the Fr_LinkStatus_Impl class.
//
//////////////////////////////////////////////////////////////////////

#include "MainWizardImpl.h"

extern TesterWizardImpl * globalTesterWizPtr;

#define DBG_FR_LINK_STATUS	0

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Fr_LinkStatus_Impl::Fr_LinkStatus_Impl( QWidget* parent, const char* name,
									                      WFlags fl):Fr_LinkStatus(parent, name, fl)
{
	set_widget_caption(this);
	window_closed = TRUE;
}

Fr_LinkStatus_Impl::~Fr_LinkStatus_Impl()
{

}

void Fr_LinkStatus_Impl::showEvent(QShowEvent * ev)
{
	PushButton2->hide();
	PushButton3->hide();
	set_widget_position_on_screen(this);
}

void Fr_LinkStatus_Impl::closeEvent(QCloseEvent * e)
{
	globalTesterWizPtr->fr_menu_link_monitor->
		setItemChecked(globalTesterWizPtr->fr_menu_link_monitor->idAt(0), FALSE );

	window_closed = TRUE;

	e->accept();
}

void Fr_LinkStatus_Impl::timerEvent(QTimerEvent * e)
{
	static BYTE cs = 0xFF;

	globalTesterWizPtr->fcb.command = FR_READ_DLC_STATUS;
	globalTesterWizPtr->fcb.buffer_length = 0;
	globalTesterWizPtr->fcb.dlci = 0;
	globalTesterWizPtr->Fr_DoCommand();

	DbgPrint3(DBG_FR_LINK_STATUS,
		"fcb.return_code : 0x%X  fcb.data[0] : 0x%X\n",
		globalTesterWizPtr->fcb.return_code,
		globalTesterWizPtr->fcb.data[0]
		);

	if (globalTesterWizPtr->fcb.data[0] != cs && globalTesterWizPtr->fcb.return_code == 0) 
	{	QString qstr_temp;

		cs = globalTesterWizPtr->fcb.data[0];
		(cs) ? qstr_temp = "OPERATIVE" : qstr_temp = "INOPERATIVE";

		/*
		(globalTesterWizPtr->fcb.data[0] !=0 ) ?
			qstr_temp = "OPERATIVE" : qstr_temp = "INOPERATIVE";
		*/

		txt_LinkSatus->setText(qstr_temp);
	}
}

BOOL Fr_LinkStatus_Impl::my_isVisible()
{
	return (window_closed == FALSE) ? TRUE : FALSE;
}

BOOL Fr_LinkStatus_Impl::my_show()
{
	window_closed = FALSE;
	show();
	return TRUE;
}
