// Fr_Fr_ModemStatus_Impl.cpp: implementation of the Fr_Fr_ModemStatus_Impl class.
//
//////////////////////////////////////////////////////////////////////

#include "MainWizardImpl.h"

extern TesterWizardImpl * globalTesterWizPtr;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Fr_ModemStatus_Impl::Fr_ModemStatus_Impl( QWidget* parent,
									const char* name,
									WFlags fl):ModemStatus(parent, name, fl )
{
  set_widget_caption(this);
}

Fr_ModemStatus_Impl::~Fr_ModemStatus_Impl()
{

}

//this is over ride of QObject's timer function
void Fr_ModemStatus_Impl::timerEvent(QTimerEvent * e)
{
	FCBLOCK cb;
	static FCBLOCK lastcb;
	
	globalTesterWizPtr->ResetCB(&globalTesterWizPtr->fcb);

	globalTesterWizPtr->fcb.command = FR_READ_MODEM_STATUS;
	globalTesterWizPtr->fcb.buffer_length = 0;
	globalTesterWizPtr->fcb.dlci = 0;	// for supervisor display
	globalTesterWizPtr->Fr_DoCommand();

	memcpy(&cb, &globalTesterWizPtr->fcb, sizeof(cb));

	if (!globalTesterWizPtr->CompCB(&lastcb, &cb))
	{
		if (cb.return_code == 0)
		{
			globalTesterWizPtr->SaveCB(&lastcb, &cb);
			(cb.data[0] & 0x08) ?
					label_DCD->setText(tr("High")) : label_DCD->setText(tr("Low"));

			(cb.data[0] & 0x20) ?
					label_CTS->setText(tr("High")) : label_CTS->setText(tr("Low"));
		}
	}

}

void Fr_ModemStatus_Impl::showEvent(QShowEvent * ev)
{
  set_widget_position_on_screen(this);
}

void Fr_ModemStatus_Impl::on_Close_clicked()
{
	close();
}

void Fr_ModemStatus_Impl::closeEvent(QCloseEvent * e)
{
	globalTesterWizPtr->fr_menu_link_monitor->
		setItemChecked (globalTesterWizPtr->fr_menu_link_monitor->idAt(4), FALSE );
	e->accept();
}
