// Fr_NodeSpecificStats_Impl.cpp: implementation of the Fr_NodeSpecificStats_Impl class.
//
//////////////////////////////////////////////////////////////////////

#include "MainWizardImpl.h"

extern TesterWizardImpl * globalTesterWizPtr;

#define DBG_NODE_STATS 0

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Fr_NodeSpecificStats_Impl::Fr_NodeSpecificStats_Impl(QWidget* parent, const char* name,
									   WFlags fl):Fr_NodeSpecificStats(parent, name, fl)

{
	memset(&lastcb, 0x00, sizeof(FCBLOCK));

	//Init the array to NULLs, only the ones which are not NULLs will be used.
  for(int i=0; i < NUM_OPSTATS_OPS; i++)
	  fr_stats_data[i] = NULL;

	//now init those which will be used
	fr_stats_data[19] = txt_219;
	fr_stats_data[25] = txt_225;

	fr_stats_data[10] = txt_210;
	fr_stats_data[11] = txt_211;

	fr_stats_data[12] = txt_212;
	fr_stats_data[13] = txt_213;
}

Fr_NodeSpecificStats_Impl::~Fr_NodeSpecificStats_Impl()
{

}

void Fr_NodeSpecificStats_Impl::showEvent(QShowEvent * ev)
{
	set_widget_position_on_screen(this);
}

void Fr_NodeSpecificStats_Impl::closeEvent(QCloseEvent * e)
{
	globalTesterWizPtr->fr_menu_link_monitor->
		setItemChecked(globalTesterWizPtr->fr_menu_link_monitor->idAt(2), FALSE );
	hide();
}

void Fr_NodeSpecificStats_Impl::timerEvent(QTimerEvent * e)
{
	globalTesterWizPtr->ResetCB(&globalTesterWizPtr->fcb);

	globalTesterWizPtr->fcb.command = FR_READ_DLC_STATISTICS;
	globalTesterWizPtr->fcb.buffer_length = 0;
	globalTesterWizPtr->fcb.dlci = 0;
	globalTesterWizPtr->Fr_DoCommand();

	if (!globalTesterWizPtr->CompCB(&lastcb, &globalTesterWizPtr->fcb))
	{
		if (globalTesterWizPtr->fcb.return_code == 0) 
		{
			globalTesterWizPtr->SaveCB(&lastcb, &globalTesterWizPtr->fcb);

			for (int c = 0; c < NUM_OPSTATS_OPS; c++)
			{
				if(fr_stats_data[c] != NULL)
        {
  				txt.sprintf("%d",
	  				globalTesterWizPtr->
		  				GetDUI((BYTE *)(globalTesterWizPtr->fcb.data+(c*2))));

					fr_stats_data[c]->setText(txt);
        }
			}
		}
	}
}


void Fr_NodeSpecificStats_Impl::on_flush_clicked()
{
	DbgPrint1(DBG_NODE_STATS, "Fr_NodeSpecificStats_Impl::on_flush_clicked()");

	globalTesterWizPtr->fcb.command = FR_FLUSH_DLC_STATISTICS;
	globalTesterWizPtr->fcb.buffer_length = 1;
	globalTesterWizPtr->fcb.dlci = 0;
	globalTesterWizPtr->fcb.data[0] = 1;
	globalTesterWizPtr->Fr_DoCommand();
}

