/***************************************************************************
Fr_SendInfoFrames_Impl.cpp  -  description
-------------------
begin				 : Wed Oct 2 2002
copyright			 : (C) 2002 by David Rokhvarg
email				 : drokhvarg@sangoma.com
***************************************************************************/

/***************************************************************************
*																		   *
*	 This program is free software; you can redistribute it and/or modify  *
*	 it under the terms of the GNU General Public License as published by  *
*	 the Free Software Foundation; either version 2 of the License, or	   *
*	 (at your option) any later version.								   *
*																		   *
***************************************************************************/

#include "MainWizardImpl.h"

extern TesterWizardImpl * globalTesterWizPtr;

#define DBG_FR_SEND_INFO 0

char txtext[1000];

Fr_SendInfoFrames_Impl::Fr_SendInfoFrames_Impl( QWidget* parent, const char* name,
											   WFlags fl):Fr_SendInfoFrames(parent, name, fl)
{
	set_widget_caption(this);
	
	length = 100;
	sdlci = 16;
	lb_previously_tx_107->clear();
	tflag = false;
	
	smflag = 0;
	databyte = 0;
	
	sqdm = 0;
	seqnum = 0;

	timer_id = 0;
}


Fr_SendInfoFrames_Impl::~Fr_SendInfoFrames_Impl()
{
	DbgPrint1(DBG_FR_SEND_INFO, "Fr_SendInfoFrames_Impl::~Fr_SendInfoFrames_Impl()\n");
}

int Fr_SendInfoFrames_Impl::initialize()
{
	chk_FECN_102->setChecked(FALSE);
	chk_BECN_103->setChecked(FALSE);
	chk_DE_104->setChecked(FALSE);
	chk_CR_105->setChecked(FALSE);
	
	//some default data to send
	qstr_temp = "01 02 03";
	edt_Tx_data_113->setText(qstr_temp);
	
	//default dlci
	qstr_temp.sprintf("%d", sdlci);
	edt_DLCI_112->setText(qstr_temp);
	
	//data is text or hex
	chk_data_is_text_106->setChecked(tflag);
	
	//length of data when sending many
	qstr_temp.sprintf("%d", length);
	edt_send_many_length_114->setText(qstr_temp);

	return true;
}

void Fr_SendInfoFrames_Impl::showEvent(QShowEvent * ev)
{
	set_widget_position_on_screen(this);
}

void Fr_SendInfoFrames_Impl::closeEvent(QCloseEvent * e)
{
	if(timer_id)
		killTimer(timer_id);
	
	// stop sending many
	smflag = 0;
	
	qstr_temp = "Start";
	btn_start_stop_send_many_151->setText(qstr_temp);
	
	qstr_temp = "Stopped";
	lbl_send_many_status_150->setText(qstr_temp);
	
	e->accept();
}

void Fr_SendInfoFrames_Impl::timerEvent(QTimerEvent * e)
{
	if (smflag)
	{
		memset(globalTesterWizPtr->fcb.data, databyte, length);
		
		globalTesterWizPtr->fcb.command = FR_INFORMATION_WRITE;
		globalTesterWizPtr->fcb.buffer_length = length;
		globalTesterWizPtr->fcb.dlci = sdlci;
		globalTesterWizPtr->fcb.FECN_BECN_DE_CR_bits = sqdm;
		globalTesterWizPtr->Fr_DoCommand();
		
		qstr_temp.sprintf("Sent # %u: %02X %02X %02X... - RC 0x%02X",
			seqnum, (UCHAR)databyte, (UCHAR)databyte,
			(UCHAR)databyte, (UCHAR)globalTesterWizPtr->fcb.return_code);
		
		lbl_send_many_status_150->setText(qstr_temp);
		
		if (globalTesterWizPtr->fcb.return_code == 0) {
			seqnum++;
			databyte++;
		}
	}
}

void Fr_SendInfoFrames_Impl::on_previously_sent_list_double_clicked()
{
	DbgPrint1(DBG_FR_SEND_INFO, "Fr_SendInfoFrames_Impl::~on_previously_sent_list_double_clicked()\n");
	
	edt_Tx_data_113->setText(lb_previously_tx_107->currentText());
}

void Fr_SendInfoFrames_Impl::on_send_many_frames()
{
	if (smflag)
	{	
		//user wants to stop sending many
		if(timer_id)
		{	killTimer(timer_id);
			timer_id = 0;
		}
		
		// stop sending many
		smflag = 0;
		
		qstr_temp = "Start";
		btn_start_stop_send_many_151->setText(qstr_temp);
		
		qstr_temp = "Stopped";
		lbl_send_many_status_150->setText(qstr_temp);
		
	}else
	{
		sdlci = get_edit_box_value(edt_DLCI_112, &ok);
		if(ok == false || sdlci < 16 || sdlci > 991)
		{	QMessageBox::warning( 0, "Error.", "Invalid DLCI to send on.");
			return;
		}
		
		length = get_edit_box_value(edt_send_many_length_114, &ok);
		if(ok == false || length < 1 || length > FR_MDATALEN)
		{	QMessageBox::warning( 0, "Error.", "Data length should be between 1 and 2048 bytes long.");
			return;
		}

		//start the transmission timer.
		if((timer_id = startTimer(TX_DELAY)) == 0)
		{	QMessageBox::warning( 0, "Error.", "Failed to start transmission timer!!");
			return;
		}
		
		// start sending many
		smflag = 1;
		databyte = 0;
		
		qstr_temp = "Stop";
		btn_start_stop_send_many_151->setText(qstr_temp);
		
		qstr_temp = "Starting...";
		lbl_send_many_status_150->setText(qstr_temp);
		
		sqdm = 0;
		seqnum = 0;
		
		if (chk_FECN_102->isChecked() == true) sqdm |= 0x08;
		if (chk_BECN_103->isChecked() == true) sqdm |= 0x04;
		if (chk_DE_104->isChecked() == true) sqdm |= 0x02;
		if (chk_CR_105->isChecked() == true) sqdm |= 0x01;
	}
}

void Fr_SendInfoFrames_Impl::on_send_one_frame()
{
	sdlci = get_edit_box_value(edt_DLCI_112, &ok);
	if(ok == false || sdlci < 16 || sdlci > 991)
	{	QMessageBox::warning(	0, "Error.", "Invalid DLCI to send on.");
		return;
	}
	
	qstr_temp = edt_Tx_data_113->text();	
	
	if(qstr_temp.length() < 1)
	{	QMessageBox::warning(	0, "Error.", "The data should be at least one byte long.");
		return;
	}
	
	if (chk_data_is_text_106->isChecked() == true) tflag = 1;
	else tflag = 0;
	
	if (tflag)
	{ //it is a text
		memcpy(globalTesterWizPtr->fcb.data, (const char *)qstr_temp, qstr_temp.length());
		n = qstr_temp.length();
	}else
	{ //it is sequence of hex numbers
		strcpy(txtext, (const char *)qstr_temp);
		n = ParseTextToHex(	strlen(txtext),
							(unsigned char *)txtext,
							globalTesterWizPtr->fcb.data
							);
	}
	globalTesterWizPtr->fcb.buffer_length = n;
	globalTesterWizPtr->fcb.dlci = sdlci;
	
	qdm = 0;
	if (chk_FECN_102->isChecked() == true) qdm |= 0x08;
	if (chk_BECN_103->isChecked() == true) qdm |= 0x04;
	if (chk_DE_104->isChecked() == true) qdm |= 0x02;
	if (chk_CR_105->isChecked() == true) qdm |= 0x01;
	
	globalTesterWizPtr->fcb.FECN_BECN_DE_CR_bits = qdm;
	globalTesterWizPtr->fcb.command = FR_INFORMATION_WRITE;
	globalTesterWizPtr->Fr_DoCommand();
	
	//Try to find the last string in the list box of sent strings.
	//If not found add it.
	if(0 == lb_previously_tx_107->findItem(edt_Tx_data_113->text(), 0))
		ADDSTR(lb_previously_tx_107, (const char *)edt_Tx_data_113->text());
}

