/***************************************************************************
                          HDLC_Comms_Err_Stats_Impl.cpp  -  description
                             -------------------
    begin                : Mon Oct 15 2001
    copyright            : (C) 2001 by DavidR
    email                : drokhvarg@sangoma.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "MainWizardImpl.h"

extern TesterWizardImpl * globalTesterWizPtr;

HDLC_Comms_Err_Stats_Impl::HDLC_Comms_Err_Stats_Impl( QWidget* parent,
																		const char* name,
																		WFlags fl):HDLC_Comms_Err_Stats(parent,
																																	  name, fl )
{
  set_widget_caption(this);

	comesdata[0] = FLD_OVR;
	comesdata[1] = FLD_CRC;
	comesdata[2] = FLD_ABORTR;
	comesdata[3] = FLD_DISCINT;
	comesdata[4] = FLD_ABORTT;
	comesdata[5] = FLD_UNDER;
	comesdata[6] = FLD_UIM;
	comesdata[7] = (QLabel *)0xFFFF;
	comesdata[8] = FLD_DCD;
	comesdata[9] = FLD_CTS;
	comesdata[10] = NULL;
}


HDLC_Comms_Err_Stats_Impl::~HDLC_Comms_Err_Stats_Impl(){
}

void HDLC_Comms_Err_Stats_Impl::on_Flush_clicked()
{
	globalTesterWizPtr->xcb.command = HDLC_FLUSH_COMMS_ERR_STATS;
	globalTesterWizPtr->xcb.buffer_length = 0;
	globalTesterWizPtr->xcb.logical_channel = 0;
  globalTesterWizPtr->wait_for_poll_to_finish(HDLC_FLUSH_COMMS_ERR_STATS);
}


void HDLC_Comms_Err_Stats_Impl::timerEvent(QTimerEvent * e)
{
	char tmp[20];

	globalTesterWizPtr->ResetCB(&globalTesterWizPtr->xcb);
	globalTesterWizPtr->xcb.command = HDLC_READ_COMMS_ERR_STATS;
	globalTesterWizPtr->xcb.buffer_length = 0;
	globalTesterWizPtr->xcb.logical_channel = 0;	// for supervisor display
	globalTesterWizPtr->X25_DoCommand();

  memcpy(&cb, &globalTesterWizPtr->xcb, sizeof(cb));

	if (!globalTesterWizPtr->CompCB(&lastcb, &cb))
	{
		if (globalTesterWizPtr->xcb.return_code == 0)
		{
			globalTesterWizPtr->SaveCB(&lastcb, &cb);
			c = 0;
			while (comesdata[c] != NULL)
			{		if(comesdata[c] != (QLabel *)0xFFFF)
					{	sprintf(tmp, "%d", cb.data[c]);
						comesdata[c]->setText(tmp);
					}
					c++;
			}
		}
	}
}

void HDLC_Comms_Err_Stats_Impl::on_Close_clicked()
{
	close();
}

void HDLC_Comms_Err_Stats_Impl::showEvent(QShowEvent * ev)
{
  set_widget_position_on_screen(this);
}

void HDLC_Comms_Err_Stats_Impl::closeEvent(QCloseEvent * e)
{
  globalTesterWizPtr->x25_menu_hdlc_monitor->
    setItemChecked (globalTesterWizPtr->x25_menu_hdlc_monitor->idAt(2), FALSE );
	e->accept();
}

