/***************************************************************************
                          HDLC_Oper_Stats_Impl.cpp  -  description
                             -------------------
    begin                : Mon Oct 15 2001
    copyright            : (C) 2001 by DavidR
    email                : drokhvarg@sangoma.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "MainWizardImpl.h"

extern TesterWizardImpl * globalTesterWizPtr;

QLabel * opstatsdata[17];

HDLC_Oper_Stats_Impl::HDLC_Oper_Stats_Impl( QWidget* parent,
																		const char* name,
																		WFlags fl):HDLC_Oper_Stats(parent, name, fl )
{
  set_widget_caption(this);

	/* field identifiers for OPSTATS dialog */
	opstatsdata[0]= FLD_IFRECV;
	opstatsdata[1]= FLD_IFOUTSEQ;
	opstatsdata[2]= FLD_IFNOI;
	opstatsdata[3]= FLD_IFINVALID;
	opstatsdata[4]= FLD_IFTOOLONG;
	opstatsdata[5]= FLD_IFBADADD;
	opstatsdata[6]= FLD_IFTRANS;
	opstatsdata[7]= FLD_IFRETRANS;
	opstatsdata[8]= FLD_IFTIMEOUTS;
	opstatsdata[9]= FLD_SABMR;
	opstatsdata[10]= FLD_DISCR;
	opstatsdata[11]= FLD_DMR;
	opstatsdata[12]= FLD_FRMRR;
	opstatsdata[13]= FLD_SABMT;
	opstatsdata[14]= FLD_DISCT;
	opstatsdata[15]= FLD_DMT;
	opstatsdata[16]= FLD_FRMRT;
	opstatsdata[17]= 0;
	
}

HDLC_Oper_Stats_Impl::~HDLC_Oper_Stats_Impl(){
}

void HDLC_Oper_Stats_Impl::showEvent(QShowEvent * ev)
{
  set_widget_position_on_screen(this);
}

void HDLC_Oper_Stats_Impl::closeEvent(QCloseEvent * e)
{
	globalTesterWizPtr->x25_menu_hdlc_monitor->
		setItemChecked (globalTesterWizPtr->x25_menu_hdlc_monitor->idAt(1), FALSE );

	e->accept();
}

//this is over ride of QObject's timer function
void HDLC_Oper_Stats_Impl::timerEvent(QTimerEvent * e)
{
	int c;
	char tmp[20];

	globalTesterWizPtr->ResetCB(&globalTesterWizPtr->xcb);
	globalTesterWizPtr->xcb.command = READ_OPERATIONAL_STATS;
	globalTesterWizPtr->xcb.buffer_length = 0;
	globalTesterWizPtr->xcb.logical_channel = 0;	// for supervisor display
	globalTesterWizPtr->X25_DoCommand();

  memcpy(&cb, &globalTesterWizPtr->xcb, sizeof(cb));

	if (!globalTesterWizPtr->CompCB(&lastcb, &cb))
	{
		if (cb.return_code == 0)
		{
			globalTesterWizPtr->SaveCB(&lastcb, &cb);
			c = 0;
			while (opstatsdata[c] != 0)
			{
				sprintf(tmp, "%d", globalTesterWizPtr->GetDUI((BYTE *)(cb.data+(c*2))));
				opstatsdata[c]->setText(tmp);
				c++;
			}//while
		}//if(cb.return_code...
	}

}

void HDLC_Oper_Stats_Impl::on_Flush_clicked()
{
	globalTesterWizPtr->xcb.command = FLUSH_OPERATIONAL_STATS;
	globalTesterWizPtr->xcb.buffer_length = 0;
	globalTesterWizPtr->xcb.logical_channel = 0;
	globalTesterWizPtr->wait_for_poll_to_finish(FLUSH_OPERATIONAL_STATS);
}

void HDLC_Oper_Stats_Impl::on_Close_clicked()
{
	close();
}

