/***************************************************************************
LineTrace_Impl.h  -  description
-------------------
begin                : Thu Oct 18 2001
copyright            : (C) 2001 by DavidR
email                : drokhvarg@sangoma.com
***************************************************************************/

/***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
***************************************************************************/

#ifndef LINETRACE_IMPL_H
#define LINETRACE_IMPL_H

#include "LineTrace.h"
/*
#include	<tester.h>
#include <xapi.h>
*/

/**
*@author DavidR
*/

class LineTrace_Impl : public LineTrace  {
public: 
	~LineTrace_Impl();
	LineTrace_Impl( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );

	bool window_closed;

	char list_view_buff[500];
	char list_view_hdlc_buff[500];
	QListViewItem * list_view_item_HDLC_level;
	QListViewItem * list_view_item_X25_level;
	
	void initialize();
	
	void timerEvent(QTimerEvent * e);
	void showEvent(QShowEvent * ev);
	void closeEvent(QCloseEvent * e);
	
	void Stop_Trace_To_File();
	void on_Close_Trace_Window();
	void on_Flush_Trace_Window();
	void on_Start_Trace_To_File();
	void on_ShowRawTrace();
	void on_ShowInterpretedTrace();
	
	void ShowRawTrace();
	void ShowInterpretedTrace();
	
	BOOL EnableTracing();
	BOOL DisableTracing(void);
	bool ProcessHDLCLevel(char *Str, BYTE *Frame);
	bool ProcessX25Level(char *Str, BYTE *Frame, int FrLength);
	void PrintPR(char *Str, BYTE *Frame);
	void PrintCauseDiagnostics(char *Str, BYTE *Frame, int FrLength);
	void PrintDNAField(char *Str, BYTE *Frame, int FrLength);
	
	//data
	int timer_id;
	int LoopCount;
	XCBLOCK cb;
	
	char	StrHDLC[200];			// strings to put into HDLC level trace to file
	char	StrX25[500];			// strings to put into X25 level trace to file
	char	tmpstr[100];
	int		Index;
	BOOL	IsX25;					// TRUE if this is X25 frame
	
	int			trace_ind;	// 0 if the trace file hasn't been opened
	// 1 if the trace file is opened, but the file trace disabled
	// 2 if trace to the file is enabled
	BOOL show_interpreted;
};

#endif
