/***************************************************************************
                          LinkStatus_Impl.cpp  -  description
                             -------------------
    begin                : Mon Oct 15 2001
    copyright            : (C) 2001 by DavidR
    email                : drokhvarg@sangoma.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "MainWizardImpl.h"

extern TesterWizardImpl * globalTesterWizPtr;

LinkStatus_Impl::LinkStatus_Impl( QWidget* parent,
																		const char* name,
																		WFlags fl):LinkStatus(parent, name, fl )
{
  set_widget_caption(this);
}

LinkStatus_Impl::~LinkStatus_Impl(){
}

void LinkStatus_Impl::on_Close_clicked()
{
	close();	
}

void LinkStatus_Impl::showEvent(QShowEvent * ev)
{
  set_widget_position_on_screen(this);
}

void LinkStatus_Impl::closeEvent(QCloseEvent * e)
{
  globalTesterWizPtr->x25_menu_hdlc_monitor->
    setItemChecked (globalTesterWizPtr->x25_menu_hdlc_monitor->idAt(0), FALSE );

	e->accept();
}

//this is over ride of QObject's timer function
void LinkStatus_Impl::timerEvent(QTimerEvent * e)
{
	XCBLOCK cb;
	static XCBLOCK lastcb;
	char flag;
	char tmp[20];

	globalTesterWizPtr->ResetCB(&globalTesterWizPtr->xcb);
	globalTesterWizPtr->xcb.command = LINK_STATUS;
	globalTesterWizPtr->xcb.buffer_length = 0;
	globalTesterWizPtr->xcb.logical_channel = 0;	// for supervisor display
	globalTesterWizPtr->X25_DoCommand();

  memcpy(&cb, &globalTesterWizPtr->xcb, sizeof(cb));

	if (!globalTesterWizPtr->CompCB(&lastcb, &globalTesterWizPtr->xcb))
	{
		globalTesterWizPtr->SaveCB(&lastcb, &cb);
		flag=0;
		switch(cb.return_code)
		{
		case 0:
			FLD_LINKS->setText(tr("DISCONNECTED"));
			flag=1;
			break;
		case 1:
			FLD_LINKS->setText(tr("ABM"));
			flag=1;
			break;
		case 3:
			FLD_LINKS->setText(tr("CLOSED"));
			break;
		case 7:
			FLD_LINKS->setText(tr("FRMR"));
			break;
		default:
			FLD_LINKS->setText(tr("UNHANDLED"));
			break;
		}//switch(cb.return_code)

		if (flag)
		{
			(cb.data[2] == 1) ?
				FLD_SCONFIG->setText(tr("DTE")) : FLD_SCONFIG->setText(tr("DCE"));

			//SetDlgItemInt(hDlg, FLD_IQTRANS, (BYTE)cb.data[0], FALSE);
			sprintf(tmp, "%d", (BYTE)cb.data[0]);
			FLD_IQTRANS->setText(tmp);			
			//SetDlgItemInt(hDlg, FLD_IQRECEPT, (BYTE)cb.data[1], FALSE);
			sprintf(tmp, "%d", (BYTE)cb.data[1]);
			FLD_IQRECEPT->setText(tmp);
			//SetDlgItemInt(hDlg, FLD_LAPB, (BYTE)cb.data[3], FALSE);
			sprintf(tmp, "%d", (BYTE)cb.data[3]);
			FLD_LAPB->setText(tmp);
			//SetDlgItemInt(hDlg, FLD_RSFCOUNT, (BYTE)cb.data[4], FALSE);
			sprintf(tmp, "%d", (BYTE)cb.data[4]);
			FLD_RSFCOUNT->setText(tmp);
		} else {
			FLD_SCONFIG->setText(tr("N/A"));
			FLD_IQTRANS->setText(tr(""));
			FLD_IQRECEPT->setText(tr(""));
			FLD_LAPB->setText(tr(""));
			FLD_RSFCOUNT->setText(tr(""));
		}
	}
}
