/****************************************************************************
** implementation file of TesterWizardImpl class
**
** Created: Thu Sep 6 14:59:35 2001
**      by:  David Rokhvarg		<drokhvarg@sangoma.com>
**
****************************************************************************/

#include "MainWizardImpl.h"

char DebugString[500];

#define SUCCESS_STRING	"Success"

//this is the application icon in the top-left corner
static const char* const image0_data[] = { 
"58 58 9 1",
". c #212084",
"a c #422084",
"c c #424184",
"# c #634184",
"d c #636184",
"f c #848284",
"g c #c6dfc6",
"e c #fffbf7",
"b c #ffffff",
"..........................................................",
".....................#abbbbbbbbbbbcd......................",
"..................cbbbbbbbbbbbbbbbbbba....................",
"................cbbbbbbbbbbbbbbbbbbbbbbbc.................",
"..............cbbbbbbbbbbbbbbbbbbbbbbbbbbb#...............",
"............dbbbbbbbbbbbbbbbbbbbbbbbbbbbbbba..............",
"...........cbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbc............",
"..........abbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbc...........",
".........bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbba..........",
"........abbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbba.........",
".......abbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbc........",
"......cbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbc.......",
".....cbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbd......",
".....bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb......",
"....abbbbbbe.............ebbbbbbbbbbbbbbbbbbbbbbbbbbc.....",
"...dbbbbbbb..............ebbbbbbbbbbbbbbbbbbbbbbbbbbb.....",
"...bbbbbbbb...............bbbbbbbbbbbbbbbbbbbbbbbbbbba....",
"..dbbbbbbbe...ffffffff....bbbbbbbbbbbbbbbbbbbbbbbbbbbbd...",
"..abbbbbbb....fffffffff...bbbbbbbbbbbbbbbbbbbbbbbbbbbbb...",
"..bbbbbbbb...ffffffffff...bbbbbbbbbbbbbbbbbbbbbbbbbbbbb...",

".#bbbbbbbb...ffffffffff...ebbbbbbbbbbbbbbbbbbbbbbbbbbbbb..",
".abbbbbbb....fffffffffff...bbbbbbbbbbbbbbbbbbbbbbbbbbbbb..",
".bbbbbbbb...ffffffffffff...bbbbbbbbbbbbbbbbbbbbbbbbbbbbbb.",
".bbbbbbbb...ffffffffffff...ebbbbbbbbbbbbbbbbbbbbbbbbbbbbb.",
".bbbbbbb....ffffffffffff....bbbbbbbbbbbbbbbbbbbbbbbbbbbbb.",
".bbbbbbb...fffffffffffff....bbbbbbbbbbbbbbbbbbbbbbbbbbbbb.",
".eeeeee....ffffffffffffff...bbbbbbbbbbbbbbbbbbbbbbbbbbbbb.",
"...........ffffffffffffff...bbbbbbbbbbbbbbbbbbbbbbbbbbbbb.",
"..........fffffffffffffff...ebbbbbbbbbbbbbbbbbbbbbbbbbbbb.",
"..........fffffffffffffff....bbbbbbbbbbbbbbbbb............",
".fffffffffffffffffffffffff...bbbbbbbbbbbbbbbb.............",
".fffffffffffffffffffffffff...bbbbbbbbbbbbbbbb.............",
".fffffffffffffffffffffffff...ebbbbbbbbbbbbbbb...fffffffff.",
".fffffffffffffffffffffffff....bbbbbbbbbbbbbb....fffffffff.",
".fffffffffffffffffffffffff....bbbbbbbbbbbbbb...ffffffffff.",
".ffffffffffffffffffffffffff...bbbbbbbbbbbbbe...ffffffffff.",
".ffffffffffffffffffffffffff...bbbbbbbbbbbbb....ffffffffff.",
".ffffffffffffffffffffffffff...ebbbbbbbbbbbb...fffffffffff.",
".ffffffffffffffffffffffffff....bbbbbbbbbbbe...ffffffffff..",
".fffffffffffffffffffffffffff...bbbbbbbbbbb....ffffffffff..",
"..ffffffffffffffffffffffffff...bbbbbbbbbbb...ffffffffff...",
"...fffffffffffffffffffffffff...ebbbbbbbbbg...ffffffffff...",
"...fffffffffffffffffffffffff...ebbbbbbbbb....fffffffff....",
"....fffffffffffffffffffffffff...bbbbbbbbb...ffffffffff....",
"....fffffffffffffffffffffffff...eeeeeeee....fffffffff.....",
".....ffffffffffffffffffffffff...............ffffffff......",
"......fffffffffffffffffffffff..............fffffffff......",
".......ffffffffffffffffffffff..............ffffffff.......",
".......fffffffffffffffffffffffffffffffffffffffffff........",
"........fffffffffffffffffffffffffffffffffffffffff.........",
".........fffffffffffffffffffffffffffffffffffffff..........",
"..........fffffffffffffffffffffffffffffffffffff...........",
"...........ffffffffffffffffffffffffffffffffff.............",
".............fffffffffffffffffffffffffffffff..............",
"..............ffffffffffffffffffffffffffff................",
"................fffffffffffffffffffffffff.................",
"..................ffffffffffffffffffffff..................",
".........................................................."};


#define DBG_MAIN_WIZ            0
#define DBG_X25_DATA_RECEPTION  0

#if defined(BUILD_FOR_UNIX)
  static const char * wanpipe_devices_list[] = {
	  "wanpipe1", "wanpipe2", "wanpipe3",
		"wanpipe4", "wanpipe5", "wanpipe6",
		"wanpipe7", "wanpipe8", 0 };
#elif defined(WIN32)	
  static const char * sdla_devices_list[] = {
		"   Card 0", "   Card 1", "   Card 2",
		"   Card 3", "   Card 4", "   Card 5",
		"   Card 6", "   Card 7", 0 };
#endif

//////////////////////////////////////////////////////////////////
char *ifailedmsg = "The SDLA driver could not be opened! It may not be installed properly, or it couldn't start.";
char *ifailedhdr = "Initialization Failure";
		
//////////////////////////// Macros //////////////////////////////
#define	ADDTEXT(x)	strcat(s, x)
#define	FORMHEX(x)	sprintf(t, "0x%02X ", (BYTE)x)
#define	ADDHEX()	strcat(s, t)
#define	FORMBNUMBER(x)	sprintf(t, "%u ", (BYTE)x)
#define	ADDNUMBER()	strcat(s, t)
#define	FORMWNUMBER(x)	sprintf(t, "%u ", (WORD)x)
		
#define	ADDUTEXT(x)	strcat(s, x)
		
#define X25_NO_DATA_AVAILABLE 0x33
		


char *unnumbered_frame_type[] = {
	"SABM command", "DISC command", "DM response", "UI", "XID"
};
		
TesterWizardImpl * globalTesterWizPtr;
		
//////////////////////////////////////////////////////////////////////////
//for displaying command names for Frame Relay
char * fr_cmd_text[] = {
	"0x00",
		"SEND_I_FRAME",
		"INFORMATION_READ",
		"FULL_STATUS_ENQ.",//"In-Channel Signal",
		"0x04",
		"0x05",
		"0x06",
		"0x07",
		"0x08",
		"0x09",

		"0x0a",
		"0x0b",
		"0x0c",
		"0x0d",
		"0x0e",
		"0x0f",
		"SET_FR_CONFIGURATION",
		"READ_FR_CONFIGURATION",
		"DISABLE_COMMS",
		"ENABLE_COMMS",
		"READ_STATUS",
		"READ_STATISTICS",
		"ZERO_STATISTICS",
		"LIST_DLCIS",
		"FLUSH_BFRS",
		"0x19",
		"0x1a",
		"0x1b",
		"0x1c",
		"0x1d",
		"0x1e",
		"0x1f",
		"ADD_DLCIs",
		"DELETE_DLCI",
		"ACTIVATE_DLCIs",
		"DEACTIVATE_DLCI",
		"0x24",
		"0x25",
		"0x26",
		"0x27",
		"0x28",
		"0x29",
		"0x2a",
		"0x2b",
		"0x2c",
		"0x2d",
		"0x2e",
		"0x2f",
		"READ_DCD_CTS",
		"SET_MODEM_STAT",
		"READ_COMM_ERRORS",
		"ZERO_COMM_ERRORS",
		"0x34",
		"0x35",
		"0x36",
		"0x37",
		"0x38",
		"0x39",
		"0x3a",
		"0x3b",
		"0x3c",
		"0x3d",
		"0x3e",
		"0x3f",
		"READ_CODE "
};

//constants for decoding return codes
char enanble_comms_first[] = "(Enable Communications has not been executed.)";
char disable_comms_first[] = "(Disable Communications before executing this command on DLCI zero.)";
char set_config_first[] = "(The initial Set Configuration command was not issued)";
char channel_inoperative[] = "(The channel is currently inoperative.)";

char dev_not_configured_message[] = "The device is not configured. Use \"Set Configuration...\" button to configure the device.";

#define CMD_COL         0
#define CMD_RC_COL      1
#define CMD_RC_EXPL_COL 2

char dlci_list[MAX_DLCIS+1];
int action_confirmation(char * question);


///////////////////////////////////////////////////////////////////

TesterWizardImpl::TesterWizardImpl( 	QWidget* parent,
								   const char* name,
								   bool modal,
								   WFlags fl) : TesterWizard(	parent, name,
								   modal, fl)
{
	//clean up before displaying
	MainListBox->clear();
	MainListBox_X25->clear();
	
	((QWidget *)helpButton())->hide();
	btn_FrStartMonitor->hide();//fr monitor button is not used
	
	btn_FrReceiveInfoFrames->hide();//not used
	m_butStartMonitor->hide();//x25 monitor button is not used
	PushButton76->hide();//place holder on x25 page
	
	
	//select x25 by default
	RB_X25->setChecked(TRUE);
	
	//member inits
	nsent = 0;
	ntosend = 0;
	manysize = 0;
	fdomanysend = false;
	domanyrcv = true;
	dobounce = false;
	dorfes = false;
	manychannel = 0;
	rmanychannel = 0;
	brchannel = 0;
	bschannel = 0;
	rewrite=0;
	sent = 0;
	busy_in_command = FALSE;
	
	rx_timer_id = 0;
	tx_timer_id = 0;
	
	is_registered = 0;
	view_in_ascii = 0;
	send_hex_data = 1;
	globalTesterWizPtr = this;
	busy_polling = 0;
	fr_domanyrcv = TRUE;
	wait_condition = new QWaitCondition();
	
	m_intProtocol = m_intProtocolLoaded = PROTOCOL_OPTION_NO_PROTOCOL;
	
	xapi_notification = 0;
	
	x25_data_entry = new DataEntryImpl();

	m_butStartMonitor->setEnabled(false);
	
	btn_FrReserved->hide();
	m_butDisableEnableReceiver->setText("Disable X.25 Data Receiver");
	
	bConfigured = false;
	comms_enabled = false;
	
	trace_file = NULL;
	
	/////////////////////////////////////////////////////////////////
	//Construct Frame Relay main list view
	//remove all columns first
	int column_count = ListView_FrMain->columns();
	int i;
	
	for(i = column_count - 1; i >= 0; i--)
	{	ListView_FrMain->removeColumn(i);
	}
	
	ListView_FrMain->setSorting(-1);
	ListView_FrMain->addColumn("Command             ");       //0
	//ListView_FrMain->addColumn("                       ");       //0
	ListView_FrMain->addColumn("Return Code ");  //1
	//ListView_FrMain->addColumn("               ");  //1
	ListView_FrMain->setColumnAlignment(CMD_RC_COL, Qt::AlignHCenter);
	ListView_FrMain->addColumn("                                                                                                                                                                                                    ");  //2
	
	fr_send_info_frames = new Fr_SendInfoFrames_Impl(0, 0, 0);
	fr_link_status = new Fr_LinkStatus_Impl(0, 0, 0);
	fr_global_stats = new Fr_GlobalStats_Impl(0, 0, 0);
	fr_cpe_stats = new Fr_CpeSpecificStats_Impl(0, 0, 0);
	fr_node_stats = new Fr_NodeSpecificStats_Impl(0, 0, 0);
	fr_comms_err_stats = new Fr_Comms_Err_Stats_Impl(0, 0, 0);
	fr_modem_status = new Fr_ModemStatus_Impl(0, 0, 0);
	fr_configured_dlcis = new Fr_ConfiguredDlcis_Impl(0, 0, 0);
	fr_line_trace = new Fr_LineTrace_Impl(0, 0, 0);
	
	
	x25_hdlc_link_status = new LinkStatus_Impl(0, 0, 0);
	x25_hdlc_oper_stats =  new HDLC_Oper_Stats_Impl(0, 0, 0);
	x25_comms_err_stats = new HDLC_Comms_Err_Stats_Impl(0, 0, 0);
	x25_modem_status = new ModemStatus_Impl(0, 0, 0);
	x25_stats = new X25_Stats_Impl(0, 0, 0);


	x25_history = new X25_History_Impl(0, 0, 0);
	x25_active_channels = new X25_ActiveChannels_Impl(0, 0, 0);
	x25_line_trace = new LineTrace_Impl(0, 0, 0);


	//ATM
	atm_line_trace_ptr = new atm_line_trace_impl();
	atm_comms_err_stats_ptr = new atm_comms_err_stats_impl();
	atm_phy_oper_stats_ptr = new atm_phy_oper_stats_impl();
	atm_phy_level_status_ptr = new atm_phy_level_status_impl();

	atm_send_info_frames_ptr = new atm_send_info_frames_impl();
	atm_vpi_vci_status_ptr = new atm_vpi_vci_status_impl();
	atm_vpi_vci_list_ptr = new atm_vpi_vci_list_impl();
	atm_delete_vpi_vci_ptr = new atm_delete_vpi_vci_impl();
	atm_connect_disconnect_pvc_ptr = new atm_connect_disconnect_pvc_impl();
	atm_oam_continuity_check_ctrl_ptr = new atm_oam_continuity_check_ctrl_impl();
	atm_send_atm_aal_loopback_ptr = new atm_send_atm_aal_loopback_impl();

	m_cCard = 0;
	
	//set the application icon in the top-left corner
	setIcon(( const char** ) image0_data);

	QTimer::singleShot( 500, this, SLOT(defered_initialization()) );
	//defered_initialization();
	
#if defined(BUILD_FOR_UNIX)
	
	ComboBox_Devices->insertStrList(wanpipe_devices_list, 8, -1);
	
#elif defined(WIN32)
	
	ComboBox_Devices->insertStrList(sdla_devices_list, 8, -1);
	
#endif
	
	//////////////////////////////////////
	// Create the X.25 menubar
	x25_menubar = new QMenuBar(x25_test_page, "x25_test_page");
	x25_menubar->setSeparator( QMenuBar::InWindowsStyle );
	
	x25_menu_hdlc_monitor = new QPopupMenu(x25_test_page, "x25_test_page");
	x25_menu_monitor      = new QPopupMenu(x25_test_page, "x25_test_page");
	x25_menu_line_trace   = new QPopupMenu(x25_test_page, "x25_test_page");
	
	//And the menu to the X.25 page and tell the layout about it.
	x25_test_pageLayout->setMenuBar( x25_menubar );
	
	//HDLC Monitor
	x25_menu_hdlc_monitor->
		insertItem(tr("Link Status"), this, SLOT(on_x25mon_link_status()));
	x25_menu_hdlc_monitor->
		insertItem(tr("Operational Statistics"), this, SLOT(on_x25mon_oper_stats()) );
	x25_menu_hdlc_monitor->
		insertItem(tr("Comm Err Statistics"), this, SLOT(on_x25mon_comm_err_stats()) );
	x25_menu_hdlc_monitor->
		insertItem(tr("Modem Status"), this, SLOT(on_x25mon_modem_stats()) );
	x25_menu_hdlc_monitor->setCheckable(TRUE);
	x25_menubar->insertItem(tr("&HDLC Monitor"), x25_menu_hdlc_monitor );
	
	//X.25 Monitor
	x25_menu_monitor->
		insertItem(tr("Statistics"), this, SLOT(on_x25mon_x25_stats()) );
	x25_menu_monitor->
		insertItem(tr("History Table"), this, SLOT(on_x25mon_x25_history_table()) );
	x25_menu_monitor->
		insertItem(tr("Active Channels"), this, SLOT(on_x25mon_x25_active_channels()) );
	x25_menu_monitor->setCheckable(TRUE);
	x25_menubar->insertItem(tr("&X.25 Monitor"), x25_menu_monitor );
	
	x25_menu_line_trace->
		insertItem(tr("Open Line Trace Window"), this, SLOT(on_x25mon_open_line_trace_window()) );;
	x25_menu_line_trace->
		insertItem(tr("Set Line Trace File Name"), this, SLOT(on_x25mon_set_line_trace_file_name()) );;
	x25_menu_line_trace->setCheckable(TRUE);
	x25_menubar->insertItem(tr("&Line Trace"), x25_menu_line_trace);
	
	x25_menubar->show();
	//////////////////////////////////////
	/*
	QMenuBar * fr_menubar;
	QPopupMenu * fr_menu_link_monitor;
	QPopupMenu * fr_menu_dlci_monitor;
	QPopupMenu * fr_menu_line_trace;
	
	*/
	//////////////////////////////////////
	// Create the Frame Relay menubar
	fr_menubar = new QMenuBar(frame_relay_page, "frame_relay_page");
	fr_menubar->setSeparator( QMenuBar::InWindowsStyle );
	
	fr_menu_link_monitor = new QPopupMenu(x25_test_page, "frame_relay_page");
	fr_menu_dlci_monitor = new QPopupMenu(x25_test_page, "frame_relay_page");
	fr_menu_line_trace   = new QPopupMenu(x25_test_page, "frame_relay_page");
	
	//And the menu to the Frame Relay page and tell the layout about it.
	frame_relay_pageLayout->setMenuBar(fr_menubar);
	
	//Link Monitor
	fr_menu_link_monitor->
		insertItem(tr("Link Status"), this, SLOT(on_frmon_link_status()));
	fr_menu_link_monitor->
		insertItem(tr("Global Statistics"), this, SLOT(on_frmon_global_stats()) );
	fr_menu_link_monitor->
		insertItem(tr("Station-Specific Statistics"), this, SLOT(on_frmon_stn_specific_stats()) );
	fr_menu_link_monitor->
		insertItem(tr("Comm Error Statistics"), this, SLOT(on_frmon_comm_err_stats()) );
	fr_menu_link_monitor->
		insertItem(tr("Modem Status"), this, SLOT(on_frmon_modem_stats()) );
	fr_menu_link_monitor->setCheckable(TRUE);
	fr_menubar->insertItem(tr("&Link Monitor"), fr_menu_link_monitor );
	
	//DLCI Monitor
	
	fr_menu_dlci_monitor->


		insertItem(tr("Configured DLCIs and Statistics"), this, SLOT(on_frmon_configured_dlci_and_stats()) );
	fr_menu_dlci_monitor->setCheckable(TRUE);
	fr_menubar->insertItem(tr("&DLCI Monitor"), fr_menu_dlci_monitor );
	
	//line trace
	fr_menu_line_trace->
		insertItem(tr("Open Line Trace Window"), this, SLOT(on_frmon_open_line_trace_window()) );;
	fr_menu_line_trace->
		insertItem(tr("Set Line Trace File Name"), this, SLOT(on_frmon_set_line_trace_file_name()) );;
	fr_menu_line_trace->setCheckable(TRUE);
	fr_menubar->insertItem(tr("&Line Trace"), fr_menu_line_trace);
	
	fr_menubar->show();
	//////////////////////////////////////

	/////////////////////////////////////////////////////////////////
	//Construct ATM main list view
	//remove all columns first
	column_count = MainListView_ATM->columns();
	
	for(i = column_count - 1; i >= 0; i--)
	{	MainListView_ATM->removeColumn(i);
	}

	MainListView_ATM->setSorting(-1);//bug?? - causing to be sorted when not needed!!!
//	MainListView_ATM->setShowSortIndicator(false);
	MainListView_ATM->addColumn("Command             ");		//0
	MainListView_ATM->addColumn("Return Code ");				//1
	MainListView_ATM->setColumnAlignment(CMD_RC_COL, Qt::AlignHCenter);
	MainListView_ATM->addColumn("                                                                                                                                                                                                    ");  //2

	phy_prefix = "PHY - ";
	atmal_prefix = "ATMAL - ";
	atm_sar_enabled = false;
	atm_pvc_connected = false;
	atm_phy_comms_enabled = false;

	//////////////////////////////////////////////////////////////////////////////
	// Create the ATM menubar
	atm_menubar = new QMenuBar(atm_test_page, "atm_test_page");
	atm_menubar->setSeparator( QMenuBar::InWindowsStyle );
	
	atm_phy_level_stats_menu =
		new QPopupMenu(atm_test_page, "atm_test_page");

	atm_atmal_level_status_and_stats_menu =
		new QPopupMenu(atm_test_page, "atm_test_page");

	atm_phy_level_trace_menu =
		new QPopupMenu(atm_test_page, "atm_test_page");

	//And the menu to the ATM page and tell the layout about it.
	atm_test_pageLayout->setMenuBar(atm_menubar);

	//////////////////////////////////////////////////////////////////////////////
	//PHY level stats menu
	//
	atm_phy_level_stats_menu->
		insertItem(tr("PHY Level Status"), this, 
			SLOT(atm_on_phy_level_status()));

	atm_phy_level_stats_menu->
		insertItem(tr("Communication Errors"), this, 
			SLOT(atm_on_phy_communication_err_stats()));

	atm_phy_level_stats_menu->
		insertItem(tr("Operational Statistics"), this, 
			SLOT(atm_on_phy_operational_stats()));


	//End of PHY level stats menu
	//////////////////////////////////////////////////////////////////////////////

	//ATM/AAL level stats menu
	//
	atm_atmal_level_status_and_stats_menu->
		insertItem(tr("PVC Status"), this, 
			SLOT(atm_on_atmal_pvc_status()));

	atm_atmal_level_status_and_stats_menu->
		insertItem(tr("PVC Statistics"), this, 
			SLOT(atm_on_atmal_pvc_statistics()));

	//End of PHY level stats menu
	//////////////////////////////////////////////////////////////////////////////

	//Trace menu
	atm_phy_level_trace_menu->
		insertItem(tr("Open Line Trace"), this, SLOT(atm_on_phy_open_trace()));
	atm_phy_level_trace_menu->
		insertItem(tr("Set Line Trace File Name"), this, SLOT(get_trace_file_name()) );;

	//End of PHY level trace menu
	//////////////////////////////////////////////////////////////////////////////

	atm_menubar->
		insertItem(tr("&PHY Level Status/Statistics  "), atm_phy_level_stats_menu );

	atm_menubar->
		insertItem(tr("&ATM/AAL Level Status/Statistics  "),
			atm_atmal_level_status_and_stats_menu );

	atm_menubar->insertItem(tr("&Line Trace"), atm_phy_level_trace_menu );

	atm_menubar->show();

	atm_enable_disable_visual_controls(FALSE);
}

/*
*  Destroys the object and frees any allocated resources
*/
TesterWizardImpl::~TesterWizardImpl()
{	
	DbgPrint1(DBG_MAIN_WIZ, "TesterWizardImpl::~TesterWizardImpl()\n");
	
	int err=0;
	
	stop_poll_timers();
	
	DbgPrint2(DBG_MAIN_WIZ, "is_registered %d\n", is_registered);
	
	if(is_registered)
	{	
		if(	m_intProtocol == PROTOCOL_OPTION_FR)
		{	
			DbgPrint1(DBG_MAIN_WIZ, "m_intProtocol == PROTOCOL_OPTION_FR\n");
      err = FAPIDEREGISTERCARD(m_cCard);
			FAPICLEANUP();
		}else if(m_intProtocol == PROTOCOL_OPTION_X25)
		{	
			DbgPrint1(DBG_MAIN_WIZ, "m_intProtocol == PROTOCOL_OPTION_X25\n");
			err = XAPIDEREGISTERCARD(m_cCard);
			XAPICLEANUP();
		}else if(m_intProtocol == PROTOCOL_OPTION_ATM)
		{	
			DbgPrint1(DBG_MAIN_WIZ, "m_intProtocol == PROTOCOL_OPTION_ATM\n");
			err = ATMAPIDEREGISTERCARD(m_cCard);
			ATMAPICLEANUP();
		}
	}
	
	DbgPrint2(DBG_MAIN_WIZ, "result of deregister call %d\n", err);

#if defined(BUILD_FOR_UNIX)
	if(is_registered && err)
	{	QMessageBox::information(	(QWidget *)this, "Error deregestering card",
		"Failed to deregister the card please restart the WANPIPE driver.",
		QMessageBox::Ok);
	}
#elif defined(WIN32)
	if(is_registered && err != SDLAR_RELEASED)
	{	QMessageBox::information(	(QWidget *)this, "Error deregestering card",
		"Failed to deregister the card please restart the SDLA driver.",
		QMessageBox::Ok);
	}
#endif

	delete fr_send_info_frames;
	delete fr_link_status;
	delete fr_global_stats;
	delete fr_cpe_stats;
	delete fr_node_stats;
	delete fr_comms_err_stats;
	delete fr_modem_status;
	delete fr_configured_dlcis;
	delete fr_line_trace;
	
	delete x25_data_entry;	
	delete x25_hdlc_link_status;
	delete x25_hdlc_oper_stats;
	delete x25_comms_err_stats;
	delete x25_modem_status;
	delete x25_stats;
	delete x25_history;
	delete x25_active_channels;
	delete x25_line_trace;

	delete atm_line_trace_ptr;
	delete atm_comms_err_stats_ptr;
	delete atm_phy_oper_stats_ptr;
	delete atm_phy_level_status_ptr;
	delete atm_send_info_frames_ptr;
	delete atm_vpi_vci_status_ptr;
	delete atm_vpi_vci_list_ptr;
	delete atm_delete_vpi_vci_ptr;
	delete atm_connect_disconnect_pvc_ptr;
	delete atm_oam_continuity_check_ctrl_ptr;
	delete atm_send_atm_aal_loopback_ptr;
}



/******************************************************************
* Read Code version
******************************************************************/
int TesterWizardImpl::read_code_version()
{
	char s[100];
	int err;
	
	if(m_intProtocol == PROTOCOL_OPTION_X25)
	{
		xcb.command = 0x15;//X25 READ_CODE_VERSION
		xcb.buffer_length = 0x00;
		XAPICONTROL(&xcb, m_cCard);
		
		if (xcb.return_code)
		{	DbgPrint2(DBG_MAIN_WIZ, "Failed to read code version rc : 0x%x\n",
				xcb.return_code);
		}else
		{	xcb.data[xcb.buffer_length] = '\0';
			sprintf(s, "X25 Code Version : %s", xcb.data);
			ADDSTR(MainListBox, s);
		}
		err = xcb.return_code;
		
	}else if(m_intProtocol == PROTOCOL_OPTION_FR){
		fcb.command = FR_READ_CODE_VERSION;//0x40
		fcb.buffer_length = 0x00;
		FAPICONTROL(&fcb, m_cCard);
		
		if(fcb.return_code)
		{	DbgPrint2(DBG_MAIN_WIZ, "Failed to read code version rc : 0x%x\n",
				fcb.return_code);
		}else
		{	fcb.data[fcb.buffer_length] = '\0';
			sprintf(s, "Frame Relay microcode version: %s", fcb.data);
			ADDSTR(MainListBox, s);
		}
		err = fcb.return_code;
	}else if(m_intProtocol == PROTOCOL_OPTION_ATM){
		
		//try to read code version to verify card is running
		atm_api_obj.atm_cb.command = PHY_READ_CODE_VERSION;
		atm_api_obj.atm_cb.buffer_length = 0;
		atm_api_obj.atm_cb.return_code = Z80_TIMEOUT_ERROR;
		
		ATMAPICONTROL(&atm_api_obj.atm_cb, m_cCard);
		
		if(atm_api_obj.atm_cb.return_code)
		{	DbgPrint2(DBG_MAIN_WIZ, "Failed to read code version rc : 0x%x\n",
				atm_api_obj.atm_cb.return_code);
		}else
		{	atm_api_obj.atm_cb.data[atm_api_obj.atm_cb.buffer_length] = '\0';
			sprintf(s, "ATM microcode version: %s", atm_api_obj.atm_cb.data);
			ADDSTR(MainListBox, s);
		}
		err = atm_api_obj.atm_cb.return_code;
	}
	
	if(err){
		sprintf(s, "Failed to read code version rc : 0x%x\n", err);
			ADDSTR(MainListBox, s);
		
		if(err = Z80_TIMEOUT_ERROR){
			ADDSTR(MainListBox, "The code on the card is not running!");
		}
	}
	return err;
}


void TesterWizardImpl::next()
{
	if(m_intProtocolLoaded == PROTOCOL_OPTION_NO_PROTOCOL)
	{
		ADDSTR(MainListBox, "You must load the card before switching to the next page.");
		return;
	}
	
	if( m_intProtocolLoaded == PROTOCOL_OPTION_X25 &&	RB_X25->isChecked() == TRUE)	
	{
		showPage(x25_test_page);
		another_page_shown();
	}else if(m_intProtocolLoaded == PROTOCOL_OPTION_FR && RB_FrRelay->isChecked() == TRUE)
	{
		showPage(frame_relay_page);
		another_page_shown();
	}else if(m_intProtocolLoaded == PROTOCOL_OPTION_ATM && RB_ATM->isChecked() == TRUE)
	{
		showPage(atm_test_page);
		another_page_shown();
	}else
	{
		ADDSTR(MainListBox, "Please reload protocol before switching to the next page.");

		return;
	}
	
	((QWidget *)backButton())->setEnabled(TRUE);
	((QWidget *)nextButton())->setEnabled(FALSE);
}

void TesterWizardImpl::back()
{
	DbgPrint1(DBG_MAIN_WIZ, "TesterWizardImpl::back()\n");

	stop_poll_timers();

	//send 'close' signal to ALL windows
	//Frame Relay
	fr_send_info_frames->close();
	fr_link_status->close();
	fr_global_stats->close();
	fr_cpe_stats->close();
	fr_node_stats->close();
	fr_comms_err_stats->close();
	fr_modem_status->close();
	fr_configured_dlcis->close();
	fr_line_trace->close();

	//X25	
	x25_hdlc_link_status->close();
	x25_hdlc_oper_stats->close();
	x25_comms_err_stats->close();
	x25_modem_status->close();
	x25_stats->close();
	x25_history->close();
	x25_active_channels->close();
	x25_line_trace->close();


	//ATM
	atm_line_trace_ptr->close();
	atm_comms_err_stats_ptr->close();
	atm_phy_oper_stats_ptr->close();
	atm_phy_level_status_ptr->close();
	atm_send_info_frames_ptr->close();
	atm_vpi_vci_status_ptr->close();
	atm_vpi_vci_list_ptr->close();
	atm_delete_vpi_vci_ptr->close();
	atm_connect_disconnect_pvc_ptr->close();
	atm_oam_continuity_check_ctrl_ptr->close();
	atm_send_atm_aal_loopback_ptr->close();

	showPage(load_card_page);
	another_page_shown();
}

bool TesterWizardImpl::on_load_clicked_slot()
{
	char device_filename[100];
	int err;

	stop_poll_timers();


#if defined(BUILD_FOR_UNIX)

	if(is_registered)
	{	//if we got here it means the card is ReLoaded, not Loaded
		is_registered = 0;
		
		if(m_intProtocol == PROTOCOL_OPTION_FR)
		{	
			FAPIDEREGISTERCARD(m_cCard);
			FAPICLEANUP();
			
		}else if(m_intProtocol == PROTOCOL_OPTION_X25){
			XAPIDEREGISTERCARD(m_cCard);
			XAPICLEANUP();

		}else if(m_intProtocol == PROTOCOL_OPTION_ATM){

			ATMAPIDEREGISTERCARD(m_cCard);			
			ATMAPICLEANUP();
		}
	}

#elif defined(WIN32)
	{	//if we got here it means the card is ReLoaded, not Loaded
		is_registered = 0;
		
		if(m_intProtocol == PROTOCOL_OPTION_FR)
		{	
			FAPIDEREGISTERCARD(m_cCard);
		
		}else if(m_intProtocol == PROTOCOL_OPTION_X25){
			XAPIDEREGISTERCARD(m_cCard);

		}else if(m_intProtocol == PROTOCOL_OPTION_ATM){

			ATMAPIDEREGISTERCARD(m_cCard);			
		}
	}

#endif

	//get new protocol which should be loaded
	if(RB_X25->isChecked() == TRUE)	{
		m_intProtocol = PROTOCOL_OPTION_X25;
	}else if(RB_FrRelay->isChecked() == TRUE){
		m_intProtocol = PROTOCOL_OPTION_FR;
	}else if(RB_ATM->isChecked() == TRUE){	
	    m_intProtocol = PROTOCOL_OPTION_ATM;
	}else{
		ADDSTR(MainListBox, "No protocol was selected!.");
		return false;
	}

	if(connect_to_api(device_filename) == FALSE)	
		return false;

	FormPathToFirmwareFile();

	if(PrepareForLoading() == FALSE)
	{	return false;
	}
	
	err = DoLoading();

	//even if loading failed, do clean up:
	CompleteLoading();

	if(err == FALSE)
	{	return false;
	}
	
	err = read_code_version();

#if defined(WIN32)	

	if(RegisterCard() == FALSE)
	{	return FALSE;
	}else
		is_registered = 1;
#endif

	if(err)
	{	messages.sprintf("Failed to read code version. Check contents of the log file.");
		ADDSTR(MainListBox, (const char *)messages);
		ADDSTR(MainListBox, "Stopped because of an error.");
		return false;
	}

	m_intProtocolLoaded = m_intProtocol;
	ADDSTR(MainListBox, "Finished loading the card.");

	return true;
}


//////////////////////////////////////////////////////////////////////////////////////

#if defined(BUILD_FOR_UNIX)

int TesterWizardImpl::connect_to_api(char * device_filename)
{
	int err = TRUE;
	
	QString tmp = ComboBox_Devices->currentText();
	
	sprintf(device_filename, "/proc/net/wanrouter/%s", tmp.latin1());
	
	DbgPrint2(DBG_MAIN_WIZ, "device_filename : %s\n", device_filename);
	
	//this should be done only *once* by an application	
	if(!is_registered)
	{
		ADDSTR(MainListBox, "Setting up internal structures...");
		
		switch(m_intProtocol)
		{
		case PROTOCOL_OPTION_X25:
			err = XAPISETUP(device_filename);
			break;
			
		case PROTOCOL_OPTION_FR:
			err = FAPISETUP(device_filename);
			break;
			
		case PROTOCOL_OPTION_ATM:
			err = ATMAPISETUP(device_filename);
			break;
		}
		
		if(err == DEVICE_NOT_IN_PROCFILE_SYSTEM)
		{ messages.sprintf( "File %s is not in the proc file system. Or failed to run shell command.",
		device_filename);
		ADDSTR(MainListBox, (const char *)messages);
		}else if(err == OPEN_DEVICE_ERR)
		{ messages.sprintf( "Failed to connect to the WANPIPE driver. Please make sure '%s' is started.",
		device_filename);
		ADDSTR(MainListBox, (const char *)messages);
		}else if(err == MEMORY_ALLOC_ERR){
			ADDSTR(MainListBox, "There is not enough system resources to run the application.");
		}
		
		if(!err){
			ADDSTR(MainListBox, "O.K.");
		}else{
			ADDSTR(MainListBox, "Stopped because of an error.");
			return FALSE;
		}
		
		ADDSTR(MainListBox, "Registering with the driver...");
		switch(m_intProtocol)
		{
		case PROTOCOL_OPTION_X25:
			err = XAPIREGISTERCARD(TRUE);
			break;
			
		case PROTOCOL_OPTION_FR:
			err = FAPIREGISTERCARD(TRUE);
			break;
			
		case PROTOCOL_OPTION_ATM:
			err = ATMAPIREGISTERCARD(TRUE);
			break;
		}
		
		if(err == IOCTL_ERR)
		{ ADDSTR(MainListBox,
        "IOCTL Error. Please make sure the WANPIPE driver is running in EduKit mode.");
		}
		
		if(err == CARD_REGISTER_ERR)
		{ /*NOTE1:
		  Because of the BUG IN QT LIBRARY, when QProcess->tryTerminate() is called
		  in the "main_screen" application, the KILLSIGN is sent sometimes,
		  instead of the TERMSIGN.
		  
			There is no such bug in MS Windows version Qt library.
			
			  The TERMSIGN causing the eventClose() to run, and clean exit of the program
			  is performed.
			  
				On KILLSIGN the application does not have a chance to do the "clean-up".
				So card stays registered, and the next time application
				runs the CARD_REGISTER_ERR can be returned from "REGISTERCARD()".
			*/
			ADDSTR(MainListBox,
				"Card currently in use by another application. It is recommended to close all other instances of the tester and try again.");
			//see NOTE1.
			err=0;//don't stop!!
		}
		
		if(!err)
		{	ADDSTR(MainListBox, "O.K.");
			is_registered = 1;
			err = TRUE;
		}else
		{	ADDSTR(MainListBox, "Stopped because of an error.");
			err = FALSE;
		}

	}//if(!is_registered)
	
	return err;
}

//////////////////////////////////////////////////////////////////////////////////////

#elif defined(WIN32)

int TesterWizardImpl::connect_to_api(char * device_filename)
{
	m_cCard = ComboBox_Devices->currentItem();
		
	if(	is_registered == 1)
	{	//If we got here it means the card is ReLoaded, not Loaded.
		//We have to deregister in order for loading to be allowed.
		if(m_intProtocol == PROTOCOL_OPTION_FR)
		{	FAPIDEREGISTERCARD(m_cCard);
		}else if(m_intProtocol == PROTOCOL_OPTION_X25){
			XAPIDEREGISTERCARD(m_cCard);
		}else if(m_intProtocol == PROTOCOL_OPTION_ATM)
		{	ATMAPIDEREGISTERCARD(m_cCard);			
		}
		is_registered = 0;
	}
	
	if(CheckCardStatus() == FALSE)
	{	return FALSE;
	}
	
	return TRUE;
}

//$(QTDIR)\lib\qtmain.lib opengl32.lib glu32.lib delayimp.lib kernel32.lib user32.lib gdi32.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib imm32.lib winmm.lib wsock32.lib winspool.lib kernel32.lib user32.lib gdi32.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib imm32.lib wsock32.lib winspool.lib winmm.lib
//  /DELAYLOAD:opengl32.dll
//-mt305.lib

int TesterWizardImpl::CheckCardStatus()
{
	int rg;
	BOOL rcode = FALSE;
	
	DbgPrint2(DBG_MAIN_WIZ,
		"CheckCardStatus():m_intProtocol : %d\n", m_intProtocol);
	
	if(m_intProtocol == PROTOCOL_OPTION_X25)
	{
		if(XAPISETUP(NULL) == SDLAR_SETUP_FAILED)
		{	ADDSTR(MainListBox, ifailedmsg);
			return rcode;
		}
		rg = XAPIGETCARDS();
	}else if(m_intProtocol == PROTOCOL_OPTION_FR)
	{
		if(FAPISETUP(NULL) == SDLAR_SETUP_FAILED)
		{	ADDSTR(MainListBox, ifailedmsg);
			return rcode;
		}
		rg = FAPIGETCARDS();
	}else if(m_intProtocol == PROTOCOL_OPTION_ATM)
	{
		if(ATMAPISETUP(NULL) == SDLAR_SETUP_FAILED)
		{	ADDSTR(MainListBox, ifailedmsg);
			return rcode;
		}
		rg = ATMAPIGETCARDS();
	}
	
	if(rg & (0x01L << m_cCard))
	{	messages.sprintf("* Card %u is currently in use!", m_cCard);
		ADDSTR(MainListBox, (const char *)messages);
		rcode = FALSE;
	}else if (rg & (0x00010000L << m_cCard)){
		messages.sprintf("Card %u is available for loading.", m_cCard);
		ADDSTR(MainListBox, (const char *)messages);
		rcode = TRUE;
	}else
	{	messages.sprintf("* No configuration entry exists for card %u!", m_cCard);
		ADDSTR(MainListBox, (const char *)messages);
		rcode = FALSE;
	}
	
	return rcode;
}

int TesterWizardImpl::RegisterCard()
{
	int rc;
	
	DbgPrint1(DBG_MAIN_WIZ, "RegisterCard()\n");
	
	//////////////////
	if(m_intProtocol == PROTOCOL_OPTION_X25)
	{	
		rc = XAPIREGISTERCARD(m_cCard);
		DbgPrint2(DBG_MAIN_WIZ, "RegisterCard():x25 : rc : %d\n", rc);
		
		if(rc != SDLAR_ALLOCATED)
		{	
			if(rc == SDLAR_REGISTERED)

			{	messages.sprintf("Card %d is already in use by another application.", m_cCard);
				ADDSTR(MainListBox, (const char *)messages);
			}
			if(rc == SDLAR_NOT_REGISTERED)
			{	messages.sprintf("Card %d can not be used. X.25 API internal error.", m_cCard);
				ADDSTR(MainListBox, (const char *)messages);
			}
			rcode = FALSE;
		}else
			rcode = TRUE;
	}else if(m_intProtocol == PROTOCOL_OPTION_FR)
	{	
		rc = FAPIREGISTERCARD(m_cCard);
		
		DbgPrint2(DBG_MAIN_WIZ, "RegisterCard():fr : rc : %d\n", rc);
		
		if(rc != SDLAR_ALLOCATED)
		{	
			if(rc == SDLAR_REGISTERED)
			{	messages.sprintf("Card %d is already in use by another application.", 
					m_cCard);
				ADDSTR(MainListBox, (const char *)messages);
			}
			
			if(rc == SDLAR_NOT_REGISTERED)
			{	messages.sprintf("Card %d can not be used. Internal API error.",
					m_cCard);
				ADDSTR(MainListBox, (const char *)messages);
			}
			rcode = FALSE;
		}else
			rcode = TRUE;
		
	}else if(m_intProtocol == PROTOCOL_OPTION_ATM)
	{	
		rc = ATMAPIREGISTERCARD(m_cCard); 
		
		DbgPrint2(DBG_MAIN_WIZ, "RegisterCard():fr : rc : %d\n", rc);
		
		if(rc != SDLAR_ALLOCATED)
		{	
			if(rc == SDLAR_REGISTERED)
			{	messages.sprintf("Card %d is already in use by another application.",
					m_cCard);
				ADDSTR(MainListBox, (const char *)messages);
			}
			
			if(rc == SDLAR_NOT_REGISTERED)
			{	messages.sprintf("Card %d can not be used. Internal API error.",
					m_cCard);
				ADDSTR(MainListBox, (const char *)messages);
			}
			rcode = FALSE;
		}else
			rcode = TRUE;
	}
	
	return rcode;
}

#endif

void TesterWizardImpl::FormPathToFirmwareFile()
{

#if defined(BUILD_FOR_UNIX)

	switch(m_intProtocol)
	{
	case PROTOCOL_OPTION_X25:
		strcpy(codefname, X25_FIRMWARE_FILE);
		break;

	case PROTOCOL_OPTION_FR:
		strcpy(codefname, FR_FIRMWARE_FILE);
		break;

	case PROTOCOL_OPTION_ATM:
		strcpy(codefname, ATM_FIRMWARE_FILE);
		break;
	}

#elif defined(WIN32)

	//current dir
	GetCurrentDirectory(MAX_PATH, CurrentDir);
	DbgPrint2(DBG_MAIN_WIZ, "FormPathToFirmwareFile(): CurrentDir : %s\n", CurrentDir);
	
	//form path to the code file
	switch(m_intProtocol)
	{
	case PROTOCOL_OPTION_X25:
		strcpy(codefname, CurrentDir);
		strcat(codefname, X25_FIRMWARE_FILE);
		break;

	case PROTOCOL_OPTION_FR:
		strcpy(codefname, CurrentDir);
		strcat(codefname, FR_FIRMWARE_FILE);
		break;

	case PROTOCOL_OPTION_ATM:
		strcpy(codefname, CurrentDir);
		strcat(codefname, ATM_FIRMWARE_FILE);
		break;
	}
#endif

	DbgPrint2(DBG_MAIN_WIZ, "FormPathToFirmwareFile(): codefname : %s\n", codefname);
}


BOOL TesterWizardImpl::PrepareForLoading()
{
	int rcode = 0;
	
	DbgPrint1(DBG_MAIN_WIZ, "PrepareForLoading()\n");

	if(m_intProtocol == PROTOCOL_OPTION_X25)
		rcode = XAPIPREPAREFORLOADING(m_cCard);		
	else if(m_intProtocol == PROTOCOL_OPTION_FR)
		rcode = FAPIPREPAREFORLOADING(m_cCard);
	else if(m_intProtocol == PROTOCOL_OPTION_ATM)
		rcode = ATMAPIPREPAREFORLOADING(m_cCard);
	
	if (rcode != SDLAR_PREPARED)
	{	ADDSTR(MainListBox,
			"* Loading failed : card currently in use or bad memory on the card!");
		ADDSTR(MainListBox,
			"*                        Check contents of the 'sdlalog.wri' log file.");
		return(FALSE);
	}
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////////////

void TesterWizardImpl::CompleteLoading()
{
	if(m_intProtocol == PROTOCOL_OPTION_X25)
		XAPILOADCOMPLETE(m_cCard);
	else if(m_intProtocol == PROTOCOL_OPTION_FR)
		FAPILOADCOMPLETE(m_cCard);
	else if(m_intProtocol == PROTOCOL_OPTION_ATM)
		ATMAPILOADCOMPLETE(m_cCard);
}

//
// Do the actual loading. This function is called from the main window when
// "Load" button is pressed

//
BOOL TesterWizardImpl::DoLoading(void)
{
	WORD i;
	char s[100];
	
	DbgPrint1(DBG_MAIN_WIZ, "TesterWizardImpl::DoLoading(void)\n");
	
	ADDSTR(MainListBox, "Downloading firmware file...");
	//show what file will be downloaded
	ADDSTR(MainListBox, codefname);
	
	if(m_intProtocol == PROTOCOL_OPTION_X25)
	{ i = XAPILOADFIRMWARE(codefname, m_cCard);
	}else if(m_intProtocol == PROTOCOL_OPTION_FR)
	{ i = FAPILOADFIRMWARE(codefname, m_cCard);
	}else if(m_intProtocol == PROTOCOL_OPTION_ATM)
	{ i = ATMAPILOADFIRMWARE(codefname, m_cCard);
  }

	switch(i)
	{
  case API_FIRMWARE_DOWNLOADED_OK:
		i = TRUE;
		break;

	case API_OPEN_FIRMWARE_FILE_ERR:
		ADDSTR(MainListBox, "* Code file not found!");
		i = FALSE;
		break;

	case API_FIRMWARE_COMPARE_FAILED:
		ADDSTR(MainListBox, "* Code on board is not identical to original!");
		ADDSTR(MainListBox, "* Memory access problem or bad memory on the card.");
		i = FALSE;
		break;

  case MEMORY_ALLOC_ERR:
		ADDSTR(MainListBox, "* Failed allocate PC memory for firmware file!");
		i = FALSE;
    break;

	default:
		sprintf(s,
			"* Unknown return code 0x%X on return form ATMAPILoadFirmware()!", i);
		ADDSTR(MainListBox, s);
		i = FALSE;
	}

	return i;
}



BYTE TesterWizardImpl::Fr_DoCommand()
{
	memcpy(&backup_fcb, &fcb, sizeof(FCBLOCK));
	
	if(	fcb.command == FR_INFORMATION_READ || fcb.command == FR_READ_DLC_STATUS ||
		fcb.command == FR_READ_DLC_STATISTICS || fcb.command == FR_READ_COMMS_ERR_STATS ||
		fcb.command == FR_READ_MODEM_STATUS || fcb.command == FR_GET_TRACE_INFO ||
		fcb.command == FR_SET_TRACE_CONFIGURATION)

	{	//not all return codes should be decoded
		FAPICONTROL(&fcb, m_cCard);
	}else
	{	
		for(int i=0; i<10; i++)
		{	/*	repeat the command 10 times so users won't
			see return codes like 0x11, 0x13 ... which are
			not of interest to them. */
			memcpy(&fcb, &backup_fcb, sizeof(FCBLOCK));
			
			FAPICONTROL(&fcb, m_cCard);
			
			if(fcb.return_code == 0)
			{	break;
			}
		}
		Fr_DecodeReturnCode(&fcb);
	}
	return(fcb.return_code);
}


//lb_FrPage
//list_view_FrMain
void TesterWizardImpl::Fr_DecodeReturnCode(FCBLOCK *cb)
{
	list_view_item =
		new QListViewItem(ListView_FrMain, ListView_FrMain->lastItem());

	list_view_item_1 = NULL;
	list_view_item_2 = NULL;
	list_view_item_3 = NULL;
	
	s1[0] = '\0';
	s2[0] = '\0';
	s3[0] = '\0';
	
	rcode = (BYTE)cb->return_code;
	
	//sprintf(s, "Command:%s", fr_cmd_text[cb->command]);
	sprintf(s, "%s", fr_cmd_text[cb->command]);
	list_view_item->setText(CMD_COL, QString::fromLatin1(s));
	
	//sprintf(s, "Return Code:0x%02X", cb->return_code);
	sprintf(s, "0x%02X", cb->return_code);
	list_view_item->setText(CMD_RC_COL, QString::fromLatin1(s));
	
	switch(rcode)
	{
	case FRRES_OK:
		sprintf(s, "(Success)");
		break;
		
	case FRRES_MODEM_FAILURE:
		strcat(s, "(Modem failure -");
		
		switch(cb->data[0])
		{
		case 0x01:	
			sprintf(s, " DCD low)");
			break;
		case 0x02:	
			sprintf(s, " CTS low)");
			break;
		default:
			sprintf(s, " DCD and CTS low)");
			break;
		}
		break;
		

		case FRRES_CHANNEL_DOWN:
			sprintf(s, "(Channel moved from Operative to being Inoperative)");
			break;
			
		case FRRES_CHANNEL_UP:
			sprintf(s, "(Channel moved from Inoperative to being Operative)");
			break;
			
		case FRRES_DLCI_CHANGE:
			sprintf(s, "(A change reported in the status of a DLCI or a number of DLCIs)");
			break;
			
		case FRRES_DLCI_MISMATCH:
			sprintf(s, "(A DLCI or a number of DLCIs used in this command where not");
			
			sprintf(s1, "included in the original configuration.)");
			
			break;
			
		case FRRES_INVALID_CMD:
			sprintf(s, "(Invalid command was used)");
			break;
		case RCODE_TIMEOUT_ERROR:
			sprintf(s, "(Timeout occurred - hardware failure)");
			break;
			
			// END OF COMMON ERROR CODES
			
		default:
			switch(cb->command)
			{
			case FR_INFORMATION_WRITE:
				switch(rcode) {
				case 1:
					sprintf(s, enanble_comms_first);
					break;
				case 2:
					sprintf(s, channel_inoperative);
					break;
				case 3:
					sprintf(s, "(The DLCI is currently inactive.)");
					break;
				case 4:
					sprintf(s, "(The DLCI selected is invalid - was not included in DLCIs list");
					sprintf(s1, "on Set Configuration command.)");
					break;
				case 5:
					sprintf(s, "(The buffer length set by application exceeded the maximum I-frame");
					sprintf(s1, "length defined by Set Configuration command.)");
					break;
				case 6:
					sprintf(s, "(The buffer length set by application exceeded the maximum number");
					sprintf(s1, "of bytes which may be transmitted in a single Tc period.)");
					break;
				case 7:
					sprintf(s, "(The current transmit throughput has exceeded that defined by");
					
					sprintf(s1, "Committed Information Rate (CIR) or the Uncommitted Information Rate.");
					sprintf(s2, "The application is attempting to send data to the frame relay network");
					sprintf(s3, "at a rate faster than transmit throughput constraints dictate.)");
					break;
					//case 8:
					//we don't want to show this return code to the user (student) because
					//it is not related to the Frame Relay protocol error.
					//sprintf(s, "(The data was not queued due to the fact that all the transmit buffers are currently occupied)");
				}
				
				break;
				
				case FR_ISSUE_SIGNALLING_FRAME:
					switch(rcode) {
					case 1:
						sprintf(s, enanble_comms_first);
						break;
					case 6:
						sprintf(s, "(The type of Status Enquiry frame is invalid.)");
						break;
					case 7:
						sprintf(s, "(Status Enquiry message may not be issued at a station configured");
						sprintf(s1, "as Access Node.)");
						break;
					}
					break;
					
					case FR_SET_DLCI_CONFIGURATION:
						switch(rcode) {
						case 1:
							sprintf(s, disable_comms_first);
							break;
						case 4:
							sprintf(s, "(An ivalid DLCI was passed in the DLCI list.)");
							break;
						case 5:
						case 6:
							sprintf(s, "(A configuration parameter was invalid");
							sprintf(s1, "(i.e. No DLCI was added at Access Node).)");

							break;
						case 7:
							sprintf(s, "(The configured Bc plus Be is greater than the");
							sprintf(s1, "permitted maximum of 512 kbits.)");
							break;
						case 8:
							sprintf(s, "(The selected maximum data length is excessive for");
							sprintf(s1, "setting up the internal frame relay buffers.)");
							break;
						}

						break;
						
						case FR_ENABLE_COMMUNICATIONS:
							switch(rcode) {
							case 1:
								sprintf(s, set_config_first);
								break;
							}
							break;
							
							case FR_ADD_DLCI:
								switch(rcode) {
								case 4:
									sprintf(s, "(An invalid DLCI was listed.)");
									break;
								case 5:
									sprintf(s, "(The length of DLCI list was excessive.)");
									break;
								case 7:
									sprintf(s, "(The command is invalid for a station configured as a CPE.)");
									break;
								case 8:
									sprintf(s, "(A listed DLCI has already been 'added' and is already included");
									sprintf(s1, "in the Full Status message.)");
									break;
								}
								break;
								
								case FR_DELETE_DLCI:
									switch(rcode) {
									case 4:
										sprintf(s, "(An invalid DLCI was listed.)");
										break;
									case 5:
										sprintf(s, "(The length of DLCI list was excessive.)");
										break;
									case 7:
										sprintf(s, "(The command is invalid for a station configured as a CPE.)");
										break;
									case 8:
										sprintf(s, "(A listed DLCI has not been 'added' and cannot therefore be 'deleted'.)");
										break;
									}
									break;
									
									case FR_ACTIVATE_DLCI:
										switch(rcode) {
										case 4:
											sprintf(s, "(An invalid DLCI was listed.)");
											break;
										case 5:
											sprintf(s, "(The length of DLCI list was excessive.)");
											break;
										case 7:
											sprintf(s, "(The command is invalid for a station configured as a CPE.)");
											break;
										case 8:
											sprintf(s, "(A listed DLCI has not been 'added' and cannot therefore be 'activated'.)");
											break;
										}
										break;
										
		case FR_DEACTIVATE_DLCI:
			switch(rcode) {
			case 4:
				sprintf(s, "(An invalid DLCI was listed.)");
				break;
			case 5:
				sprintf(s, "(The length of DLCI list was excessive.)");
				break;
			case 7:
				sprintf(s, "(The command is invalid for a station configured as a CPE.)");
				break;
			case 8:
				sprintf(s, "(A listed DLCI has not been 'added' and cannot therefore be 'deactivated'.)");
				break;
			}
			break;
		default:

			sprintf(s, "?");
			break;
		}//switch(cb->command)
	}//switch(rcode)
	
	list_view_item->setText(CMD_RC_EXPL_COL, QString::fromLatin1(s));
	LIST_VIEW_ADDSTR(ListView_FrMain, list_view_item);
	
	if(strlen(s1))
	{	list_view_item_1 = new QListViewItem(ListView_FrMain, ListView_FrMain->lastItem());
	    list_view_item_1->setText(CMD_RC_EXPL_COL, QString::fromLatin1(s1));
		LIST_VIEW_ADDSTR(ListView_FrMain, list_view_item_1);
	}
	
	if(strlen(s2))
	{	list_view_item_2 = new QListViewItem(ListView_FrMain, ListView_FrMain->lastItem());
	    list_view_item_2->setText(CMD_RC_EXPL_COL, QString::fromLatin1(s2));
		LIST_VIEW_ADDSTR(ListView_FrMain, list_view_item_2);
	}
	
	if(strlen(s3))
	{	list_view_item_3 = new QListViewItem(ListView_FrMain, ListView_FrMain->lastItem());
	    list_view_item_3->setText(CMD_RC_EXPL_COL, QString::fromLatin1(s3));
		LIST_VIEW_ADDSTR(ListView_FrMain, list_view_item_3);
	}
	
	list_view_item_separator = new QListViewItem(ListView_FrMain, ListView_FrMain->lastItem());
	list_view_item_separator->setText(CMD_COL, QString::fromLatin1(":"));
	LIST_VIEW_ADDSTR(ListView_FrMain, list_view_item_separator);
	
}//Fr_DecodeReturnCode()


BYTE TesterWizardImpl::X25_DoCommand()
{
	BYTE result;
	char s[2000], t[10];
	unsigned short n;
	
	result = (BYTE)XAPICONTROL(&xcb, m_cCard);
	
	//There are two reasons to call X25_IS_DATA_AVAILABLE:
	// 1. to get the asynchronous return codes
	// 2. to poll for incoming info frames
	if(xcb.command == X25_IS_DATA_AVAILABLE && xcb.return_code == 0 && xapi_notification == 0)
	{	return(xcb.return_code);
	}
	
	if(xcb.command == X25_IS_DATA_AVAILABLE && xcb.return_code == X25_NO_DATA_AVAILABLE)
	{	return(xcb.return_code);
	}
	
	if(result != 0 && xcb.command == X25_READ)
		return(xcb.return_code);
	
	//do NOT show return codes from all monitoring commands
	if( xcb.command == READ_TRACE_DATA || xcb.command == LINK_STATUS ||
		xcb.command == READ_OPERATIONAL_STATS || xcb.command == FLUSH_OPERATIONAL_STATS ||
		xcb.command == HDLC_READ_COMMS_ERR_STATS || xcb.command == HDLC_FLUSH_COMMS_ERR_STATS ||
		xcb.command == HDLC_READ_MODEM_STATUS || xcb.command == X25_FLUSH_X25_STATISTICS ||
		xcb.command == X25_READ_X25_STATISTICS || xcb.command == X25_READ_X25_HISTORY_TABLE ||
		xcb.command == X25_HISTORY_TABLE_CONTROL || xcb.command == X25_READ_HDLC_X25_CONFIGURATION ||
		xcb.command == X25_READ_ACTIVE_CHANNELS ||
		xcb.command == OPERATE_DATALINE_MONITOR)
	{
		return(xcb.return_code);
	}
	
	X25_SayResult();
	
	if (result == 0 && xcb.command == X25_READ)
	{
		sprintf(s, "Data: ");
		for (n=0; n < xcb.buffer_length; n++)
		{
			if(n > 30)
			{ strcat(s, "..."); break; }
			
			if(view_in_ascii)
				sprintf(t, "%c", xcb.data[n]);
			else
				sprintf(t, "%02X ", (BYTE)xcb.data[n]);
			
			strcat(s, t);
		}
		AddStringListBox(s);
		AddStringListBox(":");
	}
	
	/*
	else if(result != 0 && xcb.command == X25_READ){
	AddStringListBox(":");
	}
	*/
	return(xcb.return_code);
}


void TesterWizardImpl::X25_SayResult(void)
{
	int i, start;
	
	X25_DecodeReturnCode(&xcb, (char *)&result_text[0]);
	
	start=0; i=0;
	while (result_text[i] != '\0') {
		if (result_text[i] == '\n') {
			result_text[i] = '\0';
			AddStringListBox(result_text+start);
			start=i+1;
		}
		i++;
	}
	AddStringListBox(result_text+start);
	
	if(xcb.command != X25_READ)
		AddStringListBox(":");
}

void TesterWizardImpl::AddStringListBox(char * m)
{
	ADDSTR(MainListBox_X25, m);
}

/////////////////////////////////////////////////////////////////////////////////
//Decoding return codes from X25 commands
//
void TesterWizardImpl::X25_DecodeReturnCode(XCBLOCK * cb, char * s)
{
	BYTE rcode, pt;
	char t[100];
	
	QTime new_time = QTime::currentTime();      // get the current time
	QString str_new_time = new_time.toString ( QString("hh:mm:ss.zzz") );

	rcode = (BYTE)cb->return_code;
	//sprintf(s, "(RC:0x%02X Time:%s) ", rcode, (const char *)str_new_time);
	sprintf(s, "(CMD:0x%02X RC:0x%02X Time:%s) ",
		cb->command, rcode, (const char *)str_new_time);
	
	switch(rcode) {
	case HDLC_LINK_CLOSED:
		ADDTEXT("The link is CLOSED");
		break;
		
	case E_INVALID_COMMAND:
		ADDTEXT("Invalid command: ");
		FORMHEX(cb->command); ADDHEX();
		break;
		
	case RN_UNNUMBERED_FRAME:
		ADDTEXT(unnumbered_frame_type[cb->data[0]-1]);
		ADDTEXT(" frame was received");
		break;
		
	case S_N2_RETRY_EXCEEDED:
		ADDTEXT("N2 Retry Limit Exceeded for the command: ");
		switch(cb->data[0]) {
		case 0x01:	ADDTEXT("SABM"); break;
		case 0x02:	ADDTEXT("DISC"); break;
		default:	ADDTEXT("UNKNOWN"); break;
		}
		break;
		
		case S_FRAME_REJECT_MODE:
			ADDTEXT("The link is in Frame Reject (FRMR) Mode:\nSource: ");
			ADDTEXT((cb->data[0] == 0x01) ? "Local" : "Remote");
			ADDTEXT("\nReason: ");
			switch(cb->data[1]) {
			case 0x01: ADDTEXT("Control field invalid or not implemented"); break;
			case 0x03: ADDTEXT("S or U frame received with an illegal I-field attached"); break;
			case 0x04: ADDTEXT("I-frame received whose data length exceeded the defined maximum"); break;
			case 0x08: ADDTEXT("Invalid NR count"); break;
			}
			ADDTEXT("\nFRMR Information field: ");
			FORMHEX(cb->data[2]); ADDHEX();
			FORMHEX(cb->data[3]); ADDHEX();
			FORMHEX(cb->data[4]); ADDHEX();
			FORMHEX(cb->data[5]); ADDHEX();
			break;
			
			case S_MODEM_FAILURE:
				ADDTEXT("Modem failure -");
				if (cb->data[0] & 0x01) ADDTEXT(" DCD low");
				if (cb->data[0] & 0x02) ADDTEXT(" CTS low");
				break;
				
			case S_Z80_TIMEOUT:
				ADDTEXT("Z80 timeout occurred (hardware failure)");
				break;
				
			case RN_ASYNC_PACKET:
				ADDTEXT("Asynchronous X.25 packet received on LCN ");
				FORMWNUMBER(cb->logical_channel); ADDNUMBER();
				
				x25_data_entry->lc = cb->logical_channel;
				
				FormQDMBuffer(cb);
				ADDTEXT(qdm_buff);
				
				ADDTEXT(", Cause:");
				FORMHEX(cb->cause); ADDHEX();
				ADDTEXT(", Diag:");
				FORMHEX(cb->diagnostic); ADDHEX();
				ADDTEXT("\nAsync. packet type: ");
				pt = (BYTE)cb->X25_packet_type;
				switch(pt & (BYTE)(AUTO_RESPONSE_FLAG ^ 0xff))
				{
				case ASE_CLEAR_RQST: ADDUTEXT("CLEAR REQUEST/INDICATION"); break;
				case ASE_RESET_RQST: ADDUTEXT("RESET REQUEST/INDICATION"); break;
				case ASE_RESTART_RQST: ADDUTEXT("RESTART REQUEST/INDICATION"); break;
				case ASE_INTERRUPT: ADDUTEXT("INTERRUPT"); break;
				case ASE_DTE_REGISTR_RQST: ADDUTEXT("DTE REGISTRATION REQUEST"); break;
				case ASE_CALL_RQST: ADDUTEXT("CALL REQUEST/INCOMING CALL"); break;
				case ASE_CALL_ACCEPTED: ADDUTEXT("CALL ACCEPTED/CONNECTED"); break;
				case ASE_CLEAR_CONFRM: ADDUTEXT("CLEAR CONFIRMATION"); break;
				case ASE_RESET_CONFRM: ADDUTEXT("RESET CONFIRMATION"); break;
				case ASE_RESTART_CONFRM: ADDUTEXT("RESTART CONFIRMATION"); break;
				case ASE_INTERRUPT_CONFRM: ADDUTEXT("INTERRUPT CONFIRMATION"); break;
				case ASE_DCE_REGISTR_CONFRM: ADDUTEXT("DCE REGISTRATION CONFIRMATION"); break;
				case ASE_DIAGNOSTIC: ADDUTEXT("DIAGNOSTIC"); break;
				case ASE_CALL_AUTO_CLEAR: ADDUTEXT("CALL REQUEST/INCOMING CALL - CALL CLEARED"); break;
				default: FORMHEX(pt); ADDHEX(); break;
				}
				if (pt & (BYTE)AUTO_RESPONSE_FLAG)
					ADDTEXT(" [Responded Automatically]");
				if (cb->buffer_length > 0)  DumpAsyncData(cb, s);
				break;
				
				case S_PROTOCOL_VIOLATION:
					ADDTEXT("Protocol violation on LCN ");
					FORMWNUMBER(cb->logical_channel); ADDNUMBER();
					
					FormQDMBuffer(cb);
					ADDTEXT(qdm_buff);
					
					ADDTEXT(", Cause:");
					FORMHEX(cb->cause); ADDHEX();
					ADDTEXT(", Diag:");
					FORMHEX(cb->diagnostic); ADDHEX();
					ADDTEXT("\nTransmitted packet type: ");
					pt = (BYTE)cb->X25_packet_type;
					switch(pt & (BYTE)AUTO_RESPONSE_NOTMASK) {
					case ASE_CLEAR_CONFRM: ADDUTEXT("CLEAR REQUEST/INDICATION"); break;
					case ASE_RESET_CONFRM: ADDUTEXT("RESET REQUEST/INDICATION"); break;
					case ASE_RESTART_CONFRM: ADDUTEXT("RESTART REQUEST/INDICATION"); break;
					case ASE_DIAGNOSTIC: ADDUTEXT("DIAGNOSTIC"); break;
					default: FORMHEX(pt); ADDHEX(); break;
					}
					if ((pt & (BYTE)AUTO_RESPONSE_FLAG) &&
						pt != (BYTE)(ASE_RESTART_RQST | AUTO_RESPONSE_FLAG))
						ADDTEXT(" [RESTART Issued Automatically]");
					if (cb->buffer_length > 0)  DumpAsyncData(cb, s);
					break;
					case S_TIMEOUT:
						ADDTEXT("Timeout on LCN ");
						FORMWNUMBER(cb->logical_channel); ADDNUMBER();
						ADDTEXT(", Cause:");
						FORMHEX(cb->cause); ADDHEX();
						ADDTEXT(", Diag:");
						FORMHEX(cb->diagnostic); ADDHEX();
						ADDTEXT("\nTransmitted packet type: ");
						pt = (BYTE)cb->X25_packet_type;
						switch(pt) {
						case TIMEOUT_CLEAR: ADDUTEXT("CLEAR REQUEST/INDICATION"); break;
						case TIMEOUT_RESET: ADDUTEXT("RESET REQUEST/INDICATION"); break;
						case TIMEOUT_RESTART: ADDUTEXT("RESTART REQUEST/INDICATION"); break;
						case TIMEOUT_CALL: ADDUTEXT("CLEAR REQUEST"); break;
						default: FORMHEX(pt); ADDHEX(); break;
						}
						if (cb->buffer_length > 0)  DumpAsyncData(cb, s);
						break;
						
						case S_RETRY:
							ADDTEXT("Retry limit exceeded on LCN ");
							FORMWNUMBER(cb->logical_channel); ADDNUMBER();
							ADDTEXT("\nTransmitted packet type: ");
							pt = (BYTE)cb->X25_packet_type;
							switch(pt) {
							case TIMEOUT_CLEAR: ADDUTEXT("CLEAR REQUEST/INDICATION"); break;
							case TIMEOUT_RESET: ADDUTEXT("RESET REQUEST/INDICATION"); break;
							case TIMEOUT_RESTART: ADDUTEXT("RESTART REQUEST/INDICATION"); break;
							case TIMEOUT_CALL: ADDUTEXT("CALL REQUEST"); break;
							default: FORMHEX(pt); ADDHEX(); break;
							}
							if (cb->buffer_length > 0)  DumpAsyncData(cb, s);
							break;
							
							
							case S_NOT_IN_ABM:
								
								ADDTEXT("The link is not in ABM");
								break;
								
							case S_ASYNC_BUFF_IN_USE:
								switch(cb->command) {
									
								case X25_WRITE:
									ADDTEXT("Packet window closed or no transmit buffers available");
									break;
								case X25_READ:
									ADDTEXT("No data is available on specified channel to read");
									break;
								default:
									ADDTEXT("Async. buffer in use: packet not issued");
									break;
								}
								break;
								
								case S_NET_OUT_OF_ORDER:
									ADDTEXT("Network out of order - no data may be transferred");
									break;
									
								case S_QUEUED_DATA:
									ADDTEXT(COMMONMSG_0x35);
									break;
									

									/* END OF COMMON ERROR CODES */
									
								default:
									switch(cb->command) {
									case CONFIGURE_LINK:
										switch(rcode) {
										case 0:
											ADDTEXT("Using D");
											ADDTEXT((cb->data[0] == 0x01) ? "T" : "C");
											ADDTEXT("E frame level addressing");
											break;
										case 1:
											ADDTEXT("Invalid addressing mode selected");
											break;
										}
										break;
										case SET_GLOBAL_VARIABLES:
											switch(rcode) {
											case 0:
												ADDTEXT("DTR status has been changed successfully");
												break;
											}
											break;
											case HDLC_OPEN:
												switch(rcode) {
												case 0:
													ADDTEXT("The link is now OPEN");
													break;
													
												case 1:
													ADDTEXT("The link is already open");
													break;
												}
												break;
												case HDLC_CLOSE:
													switch(rcode) 
													{
													case 0:
														ADDTEXT("The link is now CLOSED");
														break;
													}
													break;
													case LINK_SETUP:
														switch(rcode) 
														{
														case 0:
															ADDTEXT("Initializing link and attempting to enter ABM...");
															break;
														}
														break;
														case LINK_DISCONNECT:
															switch(rcode) 
															{
															case 0:
																ADDTEXT("The link has been DISCONNECTED");
																break;
															case 2:
																ADDTEXT("The link is not in ABM");
																break;
															}
															break;
															
															case X25_PLACE_CALL:
																switch(rcode) {
																case 0:
																	ADDTEXT("Call placed on LCN ");
																	FORMWNUMBER(cb->logical_channel); ADDNUMBER();
																	break;
																case 0x02:
																	ADDTEXT("The link is not in ABM");
																	break;
																case 0x30:
																	ADDTEXT("No SVC available to place call");
																	break;
																case 0x32:
																	ADDTEXT("Call arguments too long");
																	break;
																case 0x33:
																	ADDTEXT("Asynchronous buffer in use");
																	break;
																case 0x38:
																	ADDTEXT("D-bit is not supported");
																	break;
																case 0x39:

																	ADDTEXT("Facility is not supported");
																	break;

																case 0x3a:
																	ADDTEXT("No destination address (-d) specified");
																	break;
																case 0x3b:
																	ADDTEXT("User data (-u) must contain even number of bytes");
																	break;
																}
																break;
																case X25_ACCEPT_CALL:
																	switch(rcode) {
																	case 0:
																		ADDTEXT("Call accepted on LCN ");
																		FORMWNUMBER(cb->logical_channel); ADDNUMBER();
																		break;
																	case 0x02:
																		ADDTEXT("The link is not in ABM");
																		break;
																	case 0x31:
																		ADDTEXT("No incoming call logged on this channel");
																		break;
																	case 0x32:
																		ADDTEXT("Call accept arguments too long");
																		break;
																	case 0x33:
																		ADDTEXT("Asynchronous buffer in use");
																		break;
																	case 0x34:
																		ADDTEXT("Incoming call included Fast Select Facility");
																		break;
																	case 0x38:
																		ADDTEXT("D-bit is not supported");
																		break;
																	case 0x39:
																		ADDTEXT("Facility is not supported");
																		break;
																	case 0x3b:
																		ADDTEXT("User data (-u) must contain even number of bytes");
																		break;
																	}
																	break;

																	
																	case X25_CLEAR_CALL:
																		switch(rcode) {
																		case 0:
																			ADDTEXT("Call cleared on LCN ");
																			FORMWNUMBER(cb->logical_channel); ADDNUMBER();
																			break;
																		case 0x02:
																			ADDTEXT("The link is not in ABM");
																			break;
																		case 0x30:
																			ADDTEXT("Specified channel not configured as SVC");
																			break;
																		case 0x31:
																			ADDTEXT(COMMONMSG_0x31);
																			break;
																		case 0x32:
																			ADDTEXT("Call clear arguments too long");
																			break;
																		case 0x35:
																			ADDTEXT(COMMONMSG_0x35);
																			break;
																		case 0x39:
																			ADDTEXT("Facility is not supported");
																			break;
																		case 0x3b:
																			ADDTEXT("User data (-u) must contain even number of bytes");
																			break;
																		}
																		break;
																		case X25_RESET_LOGICAL_CHANNEL:
																			switch(rcode) {
																			case 0:
																				ADDTEXT("Reset Request transmitted on LCN ");
																				FORMWNUMBER(cb->logical_channel); ADDNUMBER();
																				break;
																			case 0x02:
																				ADDTEXT("The link is not in ABM");
																				break;
																			case 0x30:
																				ADDTEXT(COMMONMSG_0x30);
																				break;
																			case 0x31:
																				ADDTEXT(COMMONMSG_0x31);
																				break;
																			case 0x35:
																				ADDTEXT(COMMONMSG_0x35);
																				break;
																			}
																			break;
																			case X25_RESTART:
																				switch(rcode) {
																				case 0:
																					ADDTEXT("Restart Request issued");
																					break;
																				}
																				break;
																				
																				case X25_WRITE:
																					switch(rcode) {
																					case 0:
																						ADDTEXT("Packet sent on LCN ");
																						FORMWNUMBER(cb->logical_channel); ADDNUMBER();
																						break;
																					case 0x30:
																						ADDTEXT(COMMONMSG_0x30);
																						break;
																					case 0x31:
																						ADDTEXT(COMMONMSG_0x31);
																						break;
																					case 0x32:
																						ADDTEXT("Data length exceeds permitted maximum");
																						break;
																					}
																					break;
																					case X25_READ:
																						switch(rcode) {
																						case 0:
																							ADDTEXT("Packet read on LCN ");
																							FORMWNUMBER(cb->logical_channel); ADDNUMBER();
																							
																							FormQDMBuffer(cb);
																							ADDTEXT(qdm_buff);
																							
																							ADDTEXT(" (length : ");
																							FORMWNUMBER(cb->buffer_length); ADDNUMBER();
																							ADDTEXT(")");
																							break;
																						case 0x30:
																							ADDTEXT(COMMONMSG_0x30);
																							break;
																						case 0x31:
																							ADDTEXT(COMMONMSG_0x31);
																							break;
																						}
																						break;
																						case X25_INTERRUPT:
																							switch(rcode) {
																							case 0:
																								ADDTEXT("Interrupt packet sent on LCN ");
																								FORMWNUMBER(cb->logical_channel); ADDNUMBER();
																								break;
																							case 0x30:
																								ADDTEXT(COMMONMSG_0x30);
																								break;
																							case 0x31:
																								ADDTEXT(COMMONMSG_0x31);
																								break;
																							case 0x32:
																								ADDTEXT("Interrupt data exceeds maximum length or none entered");
																								break;
																							}
																							
																							break;
																							
																							case X25_CONFIRM_INTERRUPT:
																								switch(rcode) {
																								case 0:
																									ADDTEXT("Interrupt confirmation sent on LCN ");
																									FORMWNUMBER(cb->logical_channel); ADDNUMBER();
																									break;
																								case 0x30:
																									ADDTEXT(COMMONMSG_0x30);
																									break;
																								case 0x31:
																									ADDTEXT("No interrupt packet was received to confirm");
																									break;
																								}
																								break;
																								case X25_CONFIRM_CLEAR:
																									switch(rcode) {
																									case 0:
																										ADDTEXT("Clear confirmation sent on LCN ");
																										FORMWNUMBER(cb->logical_channel); ADDNUMBER();
																										break;
																									case 0x30:
																										ADDTEXT("Specified logical channel not configured as SVC");
																										break;
																									case 0x31:
																										ADDTEXT("No Clear Request was received to confirm");
																										break;
																									case 0x32:
																										ADDTEXT("Packet arguments are too long");
																										break;
																									}
																									break;
																									case X25_CONFIRM_RESET:
																										switch(rcode) {
																										case 0:
																											ADDTEXT("Reset Confirmation sent on LCN ");
																											FORMWNUMBER(cb->logical_channel); ADDNUMBER();
																											break;
																										case 0x30:
																											ADDTEXT(COMMONMSG_0x30);
																											break;
																										case 0x31:
																											ADDTEXT("No Reset Request was received to confirm");
																											break;

																										}
																										break;
																										
																										case X25_CONFIRM_RESTART:
																											switch(rcode) {
																											case 0:
																												ADDTEXT("Restart Request sent");
																												break;
																											case 0x31:
																												ADDTEXT("No Restart Request was received to confirm");
																												break;
																												
																											}
																											break;
																											case X25_FLUSH_X25_DATA_BUFFERS:
																												switch(rcode) {

																												case 0:
																													if (cb->logical_channel == 0)
																														ADDTEXT("Data buffers flushed for all logical channels");
																													else {
																														ADDTEXT("Data buffers flushed on LCN ");
																														FORMWNUMBER(cb->logical_channel); ADDNUMBER();
																													}
																													break;
																												case 0x30:
																													ADDTEXT(COMMONMSG_0x30);
																													break;
																												}
																												break;
																												case X25_SET_HDLC_X25_CONFIGURATION:
																													switch(rcode) {
																													case 0:
																														ADDTEXT("Set HDLC\\X25 Configuration succeeded.");
																														break;
																													default:
																														ADDTEXT("Set HDLC\\X25 Configuration failed!");
																														break;
																													}
																													break;
																													
																													case X25_READ_HDLC_X25_CONFIGURATION:
																														switch(rcode) {
																														case 0:
																															ADDTEXT("Read HDLC\\X25 Configuration succeeded.");
																															break;
																														default:
																															ADDTEXT("Read HDLC\\X25 Configuration failed!");
																															break;
																														}
																														break;
		}
	}
}

/*
void TesterWizardImpl::DumpAsyncData(XCBLOCK *cb, char *s)
{
char t[10];
int n;

  ADDTEXT("\nData: ");
  for (n=0; n < cb->buffer_length; n++) {
		if (n > 30) { ADDTEXT("..."); break; }
		sprintf(t, "%c", cb->data[n]);
		ADDTEXT(t);
		}
		}
*/
void TesterWizardImpl::DumpAsyncData(XCBLOCK *cb, char *s)
{
	char temp[4000];
	int n;
	BYTE pt = (BYTE)cb->X25_packet_type;
	
	ADDTEXT("\nData: ");
	for (n=0; n < cb->buffer_length; n++)
	{
		if (n > 60)
		{ ADDTEXT("..."); break; }
		
		//print async data in ASCII for all but diagnostics
		switch(pt & (BYTE)(AUTO_RESPONSE_FLAG ^ 0xff))
		{
			
		case ASE_DIAGNOSTIC:
			sprintf(temp, "%02X ", cb->data[n]);
			break;
		default:
			sprintf(temp, "%c", cb->data[n]);
			break;
		}
		
		ADDTEXT(temp);

	}
}
		
		
void TesterWizardImpl::CheckInABM(void)
{
	char s[80];
	
	sprintf(s, "Link in ABM: %s", (XAPIQLINKINABM(m_cCard)) ? "YES" : "NO");
	AddStringListBox(s);
	AddStringListBox(":");
}
		
void TesterWizardImpl::set_fr_configuration()
{
	int rc;
	
	rc = set_fr_cfg.exec();

	
	
	DbgPrint2(DBG_MAIN_WIZ, "set_fr_configuration() : rc : %d\n", rc);
	
	if(rc == 0)
	{	DbgPrint1(DBG_MAIN_WIZ, "rc == IDOK\n");
	

		memcpy(dlci_list, set_fr_cfg.configured_dlcis, sizeof(dlci_list));
		do_set_fr_configuration_command();
	}else
	{	DbgPrint1(DBG_MAIN_WIZ, "rc == IDCANCEL\n");
	}
}


int TesterWizardImpl::do_set_fr_configuration_command()
{
	int i;
	
	//This should be done just in case the comms were enabled
	//by some other application and SET_DLCI_CONFIGURATION will

	//fail if comms are enabled.
	for (i = 0; i < 5; i++)
	{	fcb.command = FR_DISABLE_COMMUNICATIONS;
		fcb.buffer_length = 0;
		Fr_DoCommand();
	
		if (fcb.return_code == 0)
			break;
	}
	
	memcpy(fcb.data, &set_fr_cfg.m_fr_cfg, sizeof(FRAME_RELAY_CONFIG));
	i=0;
	while (set_fr_cfg.configured_dlcis[i] != 0)
		i++;
	
	memcpy(fcb.data+sizeof(FRAME_RELAY_CONFIG)-2, set_fr_cfg.configured_dlcis, i*2);
	
	do {
		fcb.command = FR_SET_DLCI_CONFIGURATION;
		fcb.dlci = 0;
		fcb.buffer_length = sizeof(FRAME_RELAY_CONFIG)-2+(2*i);
		Fr_DoCommand();
		
		if(fcb.return_code)
		{
			messages.sprintf(
				"Set Frame Relay Configuration command failed with return code 0x%02X. Retry?",
				fcb.return_code);
			
			i = QMessageBox::warning(this, "Configuration Error", (const char *)messages,
				"Retry", "Quit", 0, 0, 1);
		}
		//RETRY == 0;
	} while (fcb.return_code && i == 0);
	
	if(!fcb.return_code)
	{	bConfigured = TRUE;
		EnableDisableButtons(bConfigured);
		on_fr_enable_comms();
	
		if(set_fr_cfg.m_fr_cfg.Station)
		{	BOOL flag = TRUE;
			//Node
			btn_AddDlciAtNode->setEnabled(flag);
			btn_ActivateDlciAtNode->setEnabled(flag);
			btn_FrDeleteDlciAtNode->setEnabled(flag);
			btn_FrDeactivateDlciAtNode->setEnabled(flag);
			
			btn_FrSendFullStatusInquiry->setEnabled(FALSE);
		}else
		{	BOOL flag = FALSE;
			//Node
			btn_AddDlciAtNode->setEnabled(flag);
			btn_ActivateDlciAtNode->setEnabled(flag);
			btn_FrDeleteDlciAtNode->setEnabled(flag);
			btn_FrDeactivateDlciAtNode->setEnabled(flag);
			
			btn_FrSendFullStatusInquiry->setEnabled(TRUE);
		}
	}else
	{	bConfigured = FALSE;
		EnableDisableButtons(bConfigured);
	}

	if(app_command_line_empty == FALSE)
	{	if(card_number == CARD_DCE)
		{	//on Access Node add and activate one dlci (16)
			//ADD only 16
			fcb.buffer_length = 2;			//twice number of DLCIs
			*((unsigned short *)&fcb.data[0]) = 16;	//list of DLCIs as USHORT values
			fcb.command = FR_ADD_DLCI;
			Fr_DoCommand();
			
			//ACTIVATE only 16
			fcb.command = FR_ACTIVATE_DLCI;		//twice number of DLCIs
			fcb.buffer_length = 2;			//list of DLCIs as USHORT values
			*((unsigned short *)&fcb.data[0]) = 16;
			Fr_DoCommand();
		}
		else if(card_number == CARD_DTE)
		{ //on CPE only send full status enquiry
			on_fr_send_full_status_enquiry();
		}
	}

	if(!fcb.return_code)
	{	//poll timer for the main dialog (the wizard itself)
		start_poll_timers();
	}

	return 0;
}

void TesterWizardImpl::on_x25_configure()
{
	int rc = 0;
	DbgPrint1(DBG_MAIN_WIZ, "TesterWizardImpl::on_x25_configure()\n");
	
	rc = x25_cfg.exec();
	
	DbgPrint2(DBG_MAIN_WIZ, "rc : %d\n", rc);
	
	if(	rc == IDCANCEL)
		return;
	
	if(	app_command_line_empty == FALSE)
	{
		//set configuration only if different from what it was before.
		if(memcmp(&x25_cfg.m_X25_cfg_structNew,	&x25_cfg.m_X25_cfg_structOld,
				sizeof(X25_CONFIG_STRUCT))
			)
		{	
			//save in "Old" for future comparison
			memcpy(	&x25_cfg.m_X25_cfg_structOld,
					&x25_cfg.m_X25_cfg_structNew,
					sizeof(X25_CONFIG_STRUCT)
					);
			on_set_X25_configuration();
		}
	}
	
	if(	app_command_line_empty == TRUE)
	{
		on_set_X25_configuration();
	}
}

//this is over ride of QObject's timer function
void TesterWizardImpl::timerEvent(QTimerEvent * e)
{
	DbgPrint2(0, "TesterWizardImpl::timerEvent id : %d\n", e->timerId());
	
	busy_polling = 1;
	
	switch(m_intProtocolLoaded)
	{
	case PROTOCOL_OPTION_X25:
		X25_OnTimer(e->timerId());
		break;		
	case PROTOCOL_OPTION_FR:
		Fr_OnTimer(e->timerId());
		break;
	case PROTOCOL_OPTION_ATM:
		ATM_OnTimer(e->timerId());
		break;
	}
	
	busy_polling = 0;
}


void TesterWizardImpl::Fr_OnTimer(int timer_id)
{
	if(timer_id == rx_timer_id)
	{
		if(fr_domanyrcv == TRUE)
			FrDoManyRecv();
		
		if(fr_link_status->my_isVisible() == TRUE){
			fr_link_status->timerEvent((QTimerEvent *)NULL);
		}
		
		if(fr_global_stats->my_isVisible() == TRUE){
			fr_global_stats->timerEvent((QTimerEvent *)NULL);
		}
		
		if(fr_cpe_stats->my_isVisible() == TRUE){
			fr_cpe_stats->timerEvent((QTimerEvent *)NULL);
		}
		
		if(fr_node_stats->isVisible() == TRUE){
			fr_node_stats->timerEvent((QTimerEvent *)NULL);
		}
		
		if(fr_comms_err_stats->isVisible() == TRUE){
			fr_comms_err_stats->timerEvent((QTimerEvent *)NULL);
		}
		
		if(fr_modem_status->isVisible() == TRUE){
			fr_modem_status->timerEvent((QTimerEvent *)NULL);
		}
		
		if(fr_configured_dlcis->isVisible() == TRUE)
		{	fr_configured_dlcis->timerEvent((QTimerEvent *)NULL);
		
			if(fr_configured_dlcis->per_dlci_stats->isVisible() == TRUE){
				fr_configured_dlcis->per_dlci_stats->timerEvent((QTimerEvent *)NULL);
			}
		}
		
		if(fr_line_trace->isVisible() == TRUE){
			fr_line_trace->timerEvent((QTimerEvent *)NULL);
		}
	}
}

void TesterWizardImpl::FrDoManyRecv()
{
	char s[80], t[10];
	
	fcb.command = FR_INFORMATION_READ;
	fcb.buffer_length=0;
	Fr_DoCommand();
	
	if(fcb.return_code == 0 && fcb.buffer_length > 0)
	{
		list_view_item =
			new QListViewItem(ListView_FrMain, ListView_FrMain->lastItem());
		list_view_item_1 = NULL;
		
		s1[0] = '\0';
		
		rcode = (BYTE)fcb.return_code;
		
		sprintf(s, "%s", fr_cmd_text[fcb.command]);
		list_view_item->setText(CMD_COL, QString::fromLatin1(s));
		
		sprintf(s, "0x%02X", fcb.return_code);
		list_view_item->setText(CMD_RC_COL, QString::fromLatin1(s));
		
		memcpy(rxdata, fcb.data, 16 + fcb.buffer_length);
		
		pri = (PFRAME_RELAY_READ_INFO)rxdata;
		
		if (pri->Status == 0x01)
		{
			// a frame was received - dump it along with first 16 header bytes
			datlen = pri->FrameLength;
			
			sprintf(s,
				"(Rx Data on DLCI: %u, Length: %u, FECN:%2u, BECN:%2u, DE:%2u, C/R:%2u)",
				pri->DLCI, datlen,
				((pri->FecnBecnDeCr & 0x08) ? 1:0),
				((pri->FecnBecnDeCr & 0x04) ? 1:0),
				((pri->FecnBecnDeCr & 0x02) ? 1:0),
				((pri->FecnBecnDeCr & 0x01) ? 1:0)
				);
			
			
			list_view_item->setText(CMD_RC_EXPL_COL, QString::fromLatin1(s));
			LIST_VIEW_ADDSTR(ListView_FrMain, list_view_item);
			
			sprintf(s1, "Data: ");
			
			for (n=0; n < datlen; n++)
			{
				if (n > 20)
				{ strcat(s1, "..."); break; }
				
				sprintf(t, "%02X ", (BYTE)rxdata[n+16]);

				strcat(s1, t);
				
			}
			
			if(strlen(s1))
			{	list_view_item_1 =
			new QListViewItem(ListView_FrMain, ListView_FrMain->lastItem());
			list_view_item_1->setText(CMD_RC_EXPL_COL, QString::fromLatin1(s1));
			LIST_VIEW_ADDSTR(ListView_FrMain, list_view_item_1);
			}
			
			rxcount++;
		}
	}
}

void TesterWizardImpl::X25_OnTimer(int timer_id)
{
	//DbgPrint1();
	
	if(timer_id == rx_timer_id)
	{
		/* see if any async things to report */
		if (XAPIQNOTIFICATION(m_cCard))


		{	xapi_notification = 1;
			xcb.command = X25_IS_DATA_AVAILABLE;
			xcb.buffer_length = 0;
			xcb.logical_channel = 0;
			X25_DoCommand();
			xapi_notification = 0;
		}
		
		if(busy_in_command == FALSE)
		{
			if(domanyrcv == TRUE)
				DoManyRecv();
			
			if(x25_hdlc_link_status->isVisible() == TRUE)
				x25_hdlc_link_status->timerEvent((QTimerEvent *)NULL);
			
			if(x25_hdlc_oper_stats->isVisible() == TRUE)
				x25_hdlc_oper_stats->timerEvent((QTimerEvent *)NULL);

			
			if(x25_comms_err_stats->isVisible() == TRUE)
				x25_comms_err_stats->timerEvent((QTimerEvent *)NULL);
			
			if(x25_modem_status->isVisible() == TRUE)
				x25_modem_status->timerEvent((QTimerEvent *)NULL);
			
			if(x25_stats->isVisible() == TRUE)
				x25_stats->timerEvent((QTimerEvent *)NULL);
			
			if(x25_history->isVisible() == TRUE)
				x25_history->timerEvent((QTimerEvent *)NULL);
			
			if(x25_active_channels->isVisible() == TRUE)
				x25_active_channels->timerEvent((QTimerEvent *)NULL);
			
			x25_line_trace->timerEvent((QTimerEvent *)NULL);
		}
	}
	else if(timer_id == tx_timer_id)
	{
		if(busy_in_command == FALSE)
		{
			if (fdomanysend == TRUE)
				DoManySend();
		}
	}
}

void TesterWizardImpl::EnableDisableButtons(bool flag)
{
	if(m_intProtocolLoaded == PROTOCOL_OPTION_X25)
	{
		m_butStartMonitor->setEnabled(flag);
		m_butDisableEnableReceiver->setEnabled(flag);
		m_butHdlc->setEnabled(flag);
		//m_butBounce->setEnabled(flag);
		//	m_butX25cfg->setEnabled(flag);
		//	m_butSetX25Cfg->setEnabled(flag);
		m_butSend->setEnabled(flag);
		m_butRestart->setEnabled(flag);
		m_butResetCall->setEnabled(flag);
		m_butInterrupt->setEnabled(flag);
		m_butFlush->setEnabled(flag);
		m_butConfirmRestart->setEnabled(flag);
		m_butConfirmReset->setEnabled(flag);
		m_butConfirmClear->setEnabled(flag);
		m_butConfirmInterrupt->setEnabled(flag);
		m_butClearCall->setEnabled(flag);
		m_butAcceptCall->setEnabled(flag);
		m_buttonPlaceCall->setEnabled(flag);
		m_buttonSendMany->setEnabled(flag);
		m_butStartMonitor->setEnabled(flag);
		
		if(flag == false)
		{
			if(fdomanysend == true)
				m_buttonSendMany->setEnabled(fdomanysend);
			
		}else
		{
			;//do nothing. All buttons should be enabled.
		}
	}//X25 buttons
	else if(m_intProtocolLoaded == PROTOCOL_OPTION_FR)
	{
		btn_FrEnableComms->setEnabled(flag);
		//BUTTON_CONFIGURE->setEnabled(flag);
		btn_FrDisableComms->setEnabled(flag);
		btn_FrStartMonitor->setEnabled(flag);
		
		btn_SendInfoFrames->setEnabled(flag);
		
		btn_AddDlciAtNode->setEnabled(flag);
		btn_ActivateDlciAtNode->setEnabled(flag);
		btn_FrDeleteDlciAtNode->setEnabled(flag);
		btn_FrDeactivateDlciAtNode->setEnabled(flag);
		
		//btn_FrReceiveInfoFrames->setEnabled(flag);
		btn_FrSendFullStatusInquiry->setEnabled(flag);
	}
}


void TesterWizardImpl::on_x25_place_call()
{
	int rc;
	
	xcb.command = X25_PLACE_CALL;	
	rc = x25_data_entry->exec();
	
	if(rc == IDOK)
		wait_for_poll_to_finish(X25_PLACE_CALL);
}

void TesterWizardImpl::on_x25_reset_call()
{
	int rc;
	
	xcb.command = X25_RESET_LOGICAL_CHANNEL;	
	rc = x25_data_entry->exec();
	
	if(rc == IDOK)
		wait_for_poll_to_finish(X25_RESET_LOGICAL_CHANNEL);
}

void TesterWizardImpl::on_x25_accept_call()
{
	int rc;
	
	xcb.command = X25_ACCEPT_CALL;	
	rc = x25_data_entry->exec();
	
	if(rc == IDOK)
		
		wait_for_poll_to_finish(X25_ACCEPT_CALL);
}

void TesterWizardImpl::on_x25_clear_call()
{
	int rc;
	
	xcb.command = X25_CLEAR_CALL;	
	rc = x25_data_entry->exec();
	
	if(rc == IDOK)
		wait_for_poll_to_finish(X25_CLEAR_CALL);
}

void TesterWizardImpl::on_x25_confirm_clear()
{
	int rc;

	
	xcb.command = X25_CONFIRM_CLEAR;	
	rc = x25_data_entry->exec();
	
	if(rc == IDOK)
		wait_for_poll_to_finish(X25_CONFIRM_CLEAR);
}

void TesterWizardImpl::on_x25_confirm_reset()
{
	int rc;
	
	xcb.command = X25_CONFIRM_RESET;	
	rc = x25_data_entry->exec();
	
	if(rc == IDOK)
		wait_for_poll_to_finish(X25_CONFIRM_RESET);
}

void TesterWizardImpl::on_x25_receive()
{
	if(domanyrcv == true)
	{ m_butDisableEnableReceiver->setText("Enable X.25 Data Receiver");
	domanyrcv = false;
	}else
	{ m_butDisableEnableReceiver->setText("Disable X.25 Data Receiver");
	domanyrcv = true;
	}
}

void TesterWizardImpl::on_x25_receive_many()
{
	if(domanyrcv == FALSE)
	{
		xcb.command = X25_READ;	
		int rc = x25_data_entry->exec();
		
		if(rc == IDOK)
		{	
			domanyrcv = true;
			EnableDisableButtons(false);
			
			rmanychannel = xcb.logical_channel;
		}
	}else
	{
		domanyrcv = false;
		EnableDisableButtons(true);
	}
}

void TesterWizardImpl::on_x25_send()
{
	int rc;
	
	xcb.command = X25_WRITE;	
	rc = x25_data_entry->exec();
	
	if(rc == IDOK)
		wait_for_poll_to_finish(X25_WRITE);
}

void TesterWizardImpl::on_x25_send_many()
{
	if (fdomanysend == false)
	{
		if(x25_send_many.exec() == IDOK)
		{	
			fdomanysend = true;
			m_buttonSendMany->setText(tr("Stop Send"));
			EnableDisableButtons(false);
		}
	}else
	{
		fdomanysend = false;
		m_buttonSendMany->setText("Send Many");
		EnableDisableButtons(TRUE);
	}
}

void TesterWizardImpl::DoManyRecv()
{
	xcb.command = X25_IS_DATA_AVAILABLE;
	xcb.buffer_length = 0;
	xcb.logical_channel = 0;
	X25_DoCommand();
	
	//if xcb.return_code != 0 an asynch event will be shown
	
	//DbgPrint2(DBG_X25_DATA_RECEPTION, "IS_DATA_AVAILABLE rc : 0x%X\n", cb.return_code);
	
	if(xcb.return_code == 0)
	{
		lcn_ptr = (unsigned short *)xcb.data;
		
		number_of_channels_rx_data_available = xcb.buffer_length / 2;
		
		DbgPrint2(DBG_X25_DATA_RECEPTION, "number_of_channels_rx_data_available : %d\n",
			number_of_channels_rx_data_available);
		
		memset(rx_data_channels, 0x00, MAX_NUMBER_OF_LCNS);
		memcpy(rx_data_channels, xcb.data, xcb.buffer_length);
		
		for(int i=0; i < number_of_channels_rx_data_available; i++)
		{	
			DbgPrint2(DBG_X25_DATA_RECEPTION, "*lcn_ptr : %d\n",  *lcn_ptr);
			
			xcb.logical_channel = *lcn_ptr;
			xcb.command = X25_READ;
			xcb.buffer_length = 0;
			X25_DoCommand();
			lcn_ptr++;
			
			if(xcb.return_code)
				break;
		}
	}

}


void TesterWizardImpl::DoManySend()
{
	unsigned short n;
	
	xcb.buffer_length = manysize;
	xcb.command = X25_WRITE;
	xcb.logical_channel = manychannel;
	
	for (n=0; n < manysize; n++)
		xcb.data[n] = (BYTE)(nsent % 0x100);
	
	if(!X25_DoCommand())
	{
		nsent++;
		if (ntosend > 0 && nsent >= ntosend)
		{
			fdomanysend = FALSE;
			m_buttonSendMany->setText("Send Many");
			EnableDisableButtons(true);
		}
	}
}


void TesterWizardImpl::OnBounce()
{
}

void TesterWizardImpl::bounce()
{
	if (rewrite)
	{
		copy_cb(&xcb, &auxb);
		X25_DoCommand();
		if (xcb.return_code == 0) {
			rewrite=0; sent++;
		} else return;
	}
	
	if (!XAPIQDATATOREAD(m_cCard, brchannel)) return;
	
	xcb.command = X25_READ;
	xcb.logical_channel = brchannel;
	xcb.buffer_length=0;
	X25_DoCommand();
	if (xcb.return_code == 0) {
		xcb.command = X25_WRITE;
		xcb.logical_channel = bschannel;
		X25_DoCommand();
		if (xcb.return_code != 0) {
			rewrite=1;
			copy_cb(&auxb, &xcb);
		}
		else { rewrite=0; sent++; }
	}
}

void TesterWizardImpl::copy_cb(XCBLOCK *dest, XCBLOCK *src)
{
	memcpy((void *)dest, (void *)src, sizeof(XCBLOCK));
}

void TesterWizardImpl::on_x25_confirm_restart()
{
	int rc;
	
	xcb.command = X25_CONFIRM_RESTART;	
	rc = x25_data_entry->exec();
	
	if(rc == IDOK)
		wait_for_poll_to_finish(X25_CONFIRM_RESTART);
}

void TesterWizardImpl::on_x25_confirm_interrupt()
{
	int rc;
	

	xcb.command = X25_CONFIRM_INTERRUPT;	
	rc = x25_data_entry->exec();
	
	if(rc == IDOK)
		wait_for_poll_to_finish(X25_CONFIRM_INTERRUPT);
	
}


void TesterWizardImpl::on_x25_hdlc_clicked()
{
	x25_hdlc.exec();
}


void TesterWizardImpl::on_x25_interrupt()
{
	int rc;
	
	xcb.command = X25_INTERRUPT;	
	rc = x25_data_entry->exec();
	
	if(rc == IDOK)
		wait_for_poll_to_finish(X25_INTERRUPT);
	
}

void TesterWizardImpl::on_x25_flush_data_buff_clicked()
{
	int rc;
	
	xcb.command = X25_FLUSH_X25_DATA_BUFFERS;	
	rc = x25_data_entry->exec();
	
	if(rc == IDOK)
		wait_for_poll_to_finish(X25_FLUSH_X25_DATA_BUFFERS);
}

void TesterWizardImpl::on_x25_restart_clicked()
{
	int rc;
	
	xcb.command = X25_RESTART;	
	rc = x25_data_entry->exec();
	
	if(rc == IDOK)
		wait_for_poll_to_finish(X25_RESTART);
}


void TesterWizardImpl::on_x25_start_monitor()
{
}

void TesterWizardImpl::x25_monitor_exited()
{
	DbgPrint1(DBG_MAIN_WIZ, "TesterWizardImpl::x25_monitor_exited()\n");
}

void TesterWizardImpl::showEvent(QShowEvent * ev)
{
	DbgPrint1(DBG_MAIN_WIZ, "TesterWizardImpl::showEvent()\n");
}

void TesterWizardImpl::another_page_shown()
{
	DbgPrint1(DBG_MAIN_WIZ, "TesterWizardImpl::another_page_shown()\n");
	
	if(currentPage() == load_card_page)
	{
		setCaption(tr("Sangoma WAN Protocol Tester"));
		((QWidget *)nextButton())->setEnabled(TRUE);
		
	}else if(currentPage() == frame_relay_page)
	{
		if(app_command_line_empty == FALSE)
		{
			if(card_number == CARD_DCE)

			{	setCaption(tr("Frame Relay Tester - Access Node"));
			}else if(card_number == CARD_DTE)
			{	setCaption(tr("Frame Relay Tester - CPE"));
			}else
			{	setCaption(tr("Frame Relay Tester"));
			}
		}else
		{	setCaption(tr("Frame Relay Tester"));
		}
	}else if(currentPage() == x25_test_page)
	{
		if(app_command_line_empty == FALSE)
		{
			if(card_number == CARD_DCE)
			{	setCaption(tr("X.25 Tester - DCE"));
			}else if(card_number == CARD_DTE)
			{	setCaption(tr("X.25 Tester - DTE"));
			}else
			{	setCaption(tr("X.25 Tester"));
			}
		}else
		{	setCaption(tr("X.25 Tester"));
		}
	}else if(currentPage() == atm_test_page)
	{
		if(app_command_line_empty == FALSE)
		{
			if(card_number == CARD_DCE)
			{	setCaption(tr("ATM Tester - Switch"));
			}else if(card_number == CARD_DTE)
			{	setCaption(tr("ATM Tester - CPE"));
			}else
			{	setCaption(tr("ATM Tester"));
			}
		}else
		{	setCaption(tr("ATM Tester"));
		}
	}
}


/**
This function will run only once *after* the application object is created and
command line arguments processed. So it will do all initialization
wich depend on command line arguments.
*/
void TesterWizardImpl::defered_initialization()
{
	DbgPrint1(DBG_MAIN_WIZ, "TesterWizardImpl::defered_initialization()\n");
	
	m_intProtocol = protocol;
	
	DbgPrint2(DBG_MAIN_WIZ, "m_intProtocol : %d\n", m_intProtocol);
	
	x25_cfg.setDefaultX25CfgValues();
	set_fr_cfg.setDefaultFrCfgValues();
	atm_phy_cfg.setDefault_ATM_CfgValues();

	//no command line, just return
	if(app_command_line_empty == TRUE || protocol == PROTOCOL_OPTION_NO_PROTOCOL)
		return;

	//'m_cCard' will be used for all API calls (where applicable)
	m_cCard = card_number;
	
	//set the selection to correct device
	ComboBox_Devices->setCurrentItem(card_number);
	
	set_widget_position_on_screen(this);
	
	if(m_intProtocol == PROTOCOL_OPTION_FR)
	{	
		RB_FrRelay->setChecked(true);
		on_load_clicked_slot();
		
		if(m_intProtocolLoaded == PROTOCOL_OPTION_NO_PROTOCOL)
			return;
		
		do_set_fr_configuration_command();
	}else if(m_intProtocol == PROTOCOL_OPTION_X25)
	{
		RB_X25->setChecked(true);
		
		on_load_clicked_slot();
		
		if(m_intProtocolLoaded == PROTOCOL_OPTION_NO_PROTOCOL)
			return;
		
		on_set_X25_configuration();

	}else if(m_intProtocol == PROTOCOL_OPTION_ATM)
	{
		RB_ATM->setChecked(true);
		
		on_load_clicked_slot();
		
		if(m_intProtocolLoaded == PROTOCOL_OPTION_NO_PROTOCOL)
			return;
		
		//PHY level cfg
		if(atm_do_set_configuration())
			return;

		//ATM/AAL level cfg

		if(atm_do_set_aal_configuration())
			return;

		if(atm_enable_disable_sar())
			return;

		if(atm_phy_enable_disable_communications())
			return;
/*
		//Everything went well - start poll timer for the
		//main dialog (the wizard itself).
		start_poll_timers();
*/		
		if(atm_do_add_vpi_vci())
			return;

		atm_do_aal_connect_pvc();
	}
	
	if(m_intProtocolLoaded == PROTOCOL_OPTION_NO_PROTOCOL)
	{	DbgPrint1(DBG_MAIN_WIZ, "TesterWizardImpl::defered_initialization() - Failed!\n");
		return;
	}else
		next();
	
	DbgPrint1(DBG_MAIN_WIZ, "TesterWizardImpl::defered_initialization() - End\n");
}

void TesterWizardImpl::on_set_X25_configuration()
{
	xcb.command = X25_SET_HDLC_X25_CONFIGURATION;//0x51
	xcb.buffer_length = sizeof(X25_CONFIG_STRUCT);//0x37;
	memcpy( xcb.data, global_x25cfg_struct, sizeof(X25_CONFIG_STRUCT) );
	
	wait_for_poll_to_finish(X25_SET_HDLC_X25_CONFIGURATION);
	
	if (xcb.return_code != 0x00)
	{	messages.sprintf("* Unable to set X25 configuration !!! rc : 0x%02X", xcb.return_code);
		ADDSTR(MainListBox_X25, (const char *)messages);
		EnableDisableButtons(false);
		button_ConfigureX25->setEnabled(true);
		return;
	}else
	{	//CheckInABM();
		EnableDisableButtons(true);
		
		//everything went well - start poll timer for the main dialog (the wizard itself)
		start_poll_timers();
	}
}


void TesterWizardImpl::FormQDMBuffer(XCBLOCK * cb)
{
	strcpy(qdm_buff, ",  Q:");
	
	if(cb->Q_D_M_bits & MASK_QBIT)
	{	strcat(qdm_buff, "1");
	}else
	{	strcat(qdm_buff, "0");
	}
	
	strcat(qdm_buff, ", D:");
	
	if(cb->Q_D_M_bits & MASK_DBIT)
	{	strcat(qdm_buff, "1");
	}else
	{	strcat(qdm_buff, "0");
	}
	
	strcat(qdm_buff, ", M:");
	
	if(cb->Q_D_M_bits & MASK_MBIT)
	{	strcat(qdm_buff, "1");
	}else
	{	strcat(qdm_buff, "0");
	}
}


void TesterWizardImpl::on_fr_add_dlci_at_node()
{
	fr_dlci_list.set_command(FR_ADD_DLCI);
	int rc = fr_dlci_list.exec();
	
	DbgPrint2(DBG_MAIN_WIZ, "on_fr_add_dlci_at_node() : rc : %d\n", rc);
	
	if(rc == IDOK)
	{	DbgPrint1(DBG_MAIN_WIZ, "rc == IDOK\n");
	
		fcb.buffer_length = 2*(FormDLCIList());
	
		fcb.command = FR_ADD_DLCI;
		Fr_DoCommand();
	}
}

void TesterWizardImpl::on_fr_delete_dlci_at_node()
{
	fr_dlci_list.set_command(FR_DELETE_DLCI);
	int rc = fr_dlci_list.exec();
	
	if(rc == IDOK)
	{
		fcb.buffer_length = 2*(FormDLCIList());
		fcb.command = FR_DELETE_DLCI;
		Fr_DoCommand();
	}
}

void TesterWizardImpl::on_fr_activate_dlci_at_node()
{
	fr_dlci_list.set_command(FR_ACTIVATE_DLCI);
	int rc = fr_dlci_list.exec();
	
	if(rc == IDOK)
	{
		fcb.buffer_length = 2*(FormDLCIList());
		fcb.command = FR_ACTIVATE_DLCI;
		Fr_DoCommand();
	}
}

void TesterWizardImpl::on_fr_deactivate_dlci_at_node()
{
	fr_dlci_list.set_command(FR_DEACTIVATE_DLCI);
	int rc = fr_dlci_list.exec();
	
	if(rc == IDOK)
	{
		fcb.buffer_length = 2*(FormDLCIList());
		fcb.command = FR_DEACTIVATE_DLCI;
		Fr_DoCommand();
	}
}

void TesterWizardImpl::on_fr_disable_comms()
{
	if(bConfigured == FALSE)
	{	QMessageBox::warning(	0, "Tester", dev_not_configured_message);
		return;
	}
	
	if(comms_enabled == FALSE)
	{	QMessageBox::warning(	0, "Tester", "Communications already disabled.");
		return;
	}
	
	for (int i = 0; i < 5; i++)
	{	fcb.command = FR_DISABLE_COMMUNICATIONS;
		fcb.buffer_length = 0;
		Fr_DoCommand();
	
		if (fcb.return_code == 0 && comms_enabled == TRUE)
		{	comms_enabled = FALSE;
			break;
		}
	}
}

void TesterWizardImpl::on_fr_enable_comms()
{
	if(bConfigured == FALSE)
	{	QMessageBox::warning(	0, "Tester", dev_not_configured_message);
	return;
	}
	
	fcb.command = FR_ENABLE_COMMUNICATIONS;
	fcb.buffer_length = 0;
	Fr_DoCommand();
	
	if (fcb.return_code == 0)
	{ comms_enabled = TRUE;
	}else
	{	//bad return code will be shown in Main List box so
		//here nothing should be done
	}
}

void TesterWizardImpl::on_fr_send_full_status_enquiry()
{
	if(bConfigured == FALSE)
	{	QMessageBox::warning(	0, "Tester", dev_not_configured_message);
	return;
	}
	
	fcb.command = FR_ISSUE_SIGNALLING_FRAME;
	fcb.buffer_length = 1;
	fcb.data[0] = 0x03;
	Fr_DoCommand();
}

/*
QLabel *splashScreen = new QLabel( 0, "mySplashScreen",
WStyle_Customize | WStyle_NoBorder |
WStyle_Tool );
*/

void TesterWizardImpl::on_fr_send_info_frames()
{
	if(fr_send_info_frames->initialize() == (int)true)
		fr_send_info_frames->show();
}

//set_fr_cfg.configured_dlcis[i]
WORD TesterWizardImpl::FormDLCIList()
{
	WORD i, j, k;
	
	i=0; j=0; k=0;
	while (dlci_list[j++] != '\0' && k < 25) {
		if (dlci_list[j-1] == ' ') continue;
		i = (WORD)atoi(dlci_list+j-1);

		fcb.data[2*k] = (unsigned char)(i & 0x00ff);
		fcb.data[(2*k)+1] = (unsigned char)(i >> 8);
		k++;
		while (dlci_list[j] != ' ' && dlci_list[j] != '\0') j++;
	}
	return(k);
}

void TesterWizardImpl::closeEvent(QCloseEvent * e)
{
	DbgPrint1(DBG_MAIN_WIZ, "TesterWizardImpl::closeEvent\n");
	
	//do not ask for confirmation here, because it can be
  //a signal sent from "main_screen".
  //just exit the application.
  qApp->quit();
}

//Cancel is clicked
void TesterWizardImpl::reject()
{
	DbgPrint1(DBG_MAIN_WIZ, "TesterWizardImpl::reject()\n");

  //ask confirmation from the user	
	if(!action_confirmation("Are you sure you want to quit?"))
    qApp->quit();
}

//places the widget (dialogs usually) into default location on the screen
void set_widget_position_on_screen(QWidget * widget)
{
	if(app_command_line_empty == FALSE)
	{
		if(card_number == CARD_DCE)
		{ //show in upper left corner of the screen
			widget->setGeometry(
				DCE_DEFAULT_POS_X,
				DCE_DEFAULT_POS_Y,
				widget->width(),
				widget->height()
				);
			
		}else if(card_number == CARD_DTE)
		{	widget->setGeometry(
				DTE_DEFAULT_POS_X, 
				DTE_DEFAULT_POS_Y, 
				widget->width(), 
				widget->height()
				);
		}
	}
	else
	{	//put the main window in the middle of the screen
		QDesktopWidget screen;
		
		widget->setGeometry
			(
			(screen.width() - widget->width())/2,
			(screen.height() - widget->height())/2,
			widget->width(), widget->height()
			);
	}
}

void set_widget_caption(QWidget * widget)
{
	QString cap = widget->caption();

	if(app_command_line_empty == FALSE)	
	{
		if(card_number == CARD_DCE)
		{
			if(protocol == PROTOCOL_OPTION_FR)
			{	widget->setCaption( "Access Node - " + cap );
			}else if(protocol == PROTOCOL_OPTION_X25)
			{	widget->setCaption( "DCE - " + cap );
			}else if(protocol == PROTOCOL_OPTION_ATM)
			{	widget->setCaption( "Switch - " + cap );
			}
		}else if(card_number == CARD_DTE)
		{
			if(protocol == PROTOCOL_OPTION_FR)
			{	widget->setCaption( "CPE - " + cap );
			}else if(protocol == PROTOCOL_OPTION_X25)
			{	widget->setCaption( "DTE - " + cap );
			}else if(protocol == PROTOCOL_OPTION_ATM)
			{	widget->setCaption(	"CPE - " + cap );
			}
		}
	}
}

/*
Wait for rx data (OnRcvMany()) poll to finish and then do the command.
*/
int TesterWizardImpl::wait_for_poll_to_finish(UCHAR command)
{
	int wait_count=0;
	while(busy_polling == 1 && wait_count ++ < MAX_WAIT)
		wait_condition->wait(1);
	
	busy_in_command = TRUE;
	//restore the command, because the polling code
	//could change it while we were waiting
	xcb.command = command;
	X25_DoCommand();
	busy_in_command = FALSE;
	
	return xcb.return_code;
}

int action_confirmation(char * question)
{
	return QMessageBox::warning(NULL, "", question, "Yes", "No", 0, 0, 1);
}

void TesterWizardImpl::on_x25mon_link_status()
{
	DbgPrint1(DBG_MAIN_WIZ, "TesterWizardImpl::on_x25mon_link_status()\n");
	
	if( x25_menu_hdlc_monitor->isItemChecked(x25_menu_hdlc_monitor->idAt(0)) == FALSE)
	{
		x25_menu_hdlc_monitor->setItemChecked(x25_menu_hdlc_monitor->idAt(0), TRUE );
		x25_hdlc_link_status->show();
	}
}

void TesterWizardImpl::on_x25mon_oper_stats()
{
	DbgPrint1(DBG_MAIN_WIZ, "TesterWizardImpl::on_x25mon_oper_stats()\n");
	
	if( x25_menu_hdlc_monitor->isItemChecked(x25_menu_hdlc_monitor->idAt(1)) == FALSE)
	{
		x25_menu_hdlc_monitor->setItemChecked(x25_menu_hdlc_monitor->idAt(1), TRUE );
		x25_hdlc_oper_stats->show();
	}
}

void TesterWizardImpl::on_x25mon_comm_err_stats()
{
	DbgPrint1(DBG_MAIN_WIZ, "TesterWizardImpl::on_x25mon_comm_err_stats()\n");
	
	if( x25_menu_hdlc_monitor->isItemChecked(x25_menu_hdlc_monitor->idAt(2)) == FALSE)
	{
		x25_menu_hdlc_monitor->setItemChecked(x25_menu_hdlc_monitor->idAt(2), TRUE );
		x25_comms_err_stats->show();
	}
}

void TesterWizardImpl::on_x25mon_modem_stats()
{
	DbgPrint1(DBG_MAIN_WIZ, "TesterWizardImpl::on_x25mon_modem_status()\n");
	
	if( x25_menu_hdlc_monitor->isItemChecked(x25_menu_hdlc_monitor->idAt(3)) == FALSE)
	{
		x25_menu_hdlc_monitor->setItemChecked(x25_menu_hdlc_monitor->idAt(3), TRUE );
		x25_modem_status->show();
	}
}

void TesterWizardImpl::on_x25mon_x25_stats()
{
	DbgPrint1(DBG_MAIN_WIZ, "TesterWizardImpl::on_x25mon_x25_status()\n");
	
	if( x25_menu_monitor->isItemChecked(x25_menu_monitor->idAt(0)) == FALSE)
	{
		x25_menu_monitor->setItemChecked(x25_menu_monitor->idAt(0), TRUE );
		x25_stats->show();
	}
}

void TesterWizardImpl::on_x25mon_x25_history_table()
{
	DbgPrint1(DBG_MAIN_WIZ, "TesterWizardImpl::on_x25mon_x25_history_table()\n");
	
	if( x25_menu_monitor->isItemChecked(x25_menu_monitor->idAt(1)) == FALSE)
	{
		x25_menu_monitor->setItemChecked(x25_menu_monitor->idAt(1), TRUE );
		x25_history->show();
	}
}

void TesterWizardImpl::on_x25mon_x25_active_channels()
{
	DbgPrint1(DBG_MAIN_WIZ, "TesterWizardImpl::on_x25mon_x25_history_table()\n");
	
	if( x25_menu_monitor->isItemChecked(x25_menu_monitor->idAt(2)) == FALSE)
	{
		x25_menu_monitor->setItemChecked(x25_menu_monitor->idAt(2), TRUE );
		x25_active_channels->show();
	}
}

void TesterWizardImpl::on_x25mon_open_line_trace_window()
{
	DbgPrint1(DBG_MAIN_WIZ, "TesterWizardImpl::on_x25mon_x25_open_line_trace()\n");
	
	if( x25_menu_line_trace->isItemChecked(x25_menu_line_trace->idAt(0)) == FALSE)
	{
		x25_menu_line_trace->setItemChecked(x25_menu_line_trace->idAt(0), TRUE );
		
		x25_line_trace->initialize();
		x25_line_trace->show();
	}
}

void TesterWizardImpl::on_x25mon_set_line_trace_file_name()
{
	get_trace_file_name();
	//it is a modal dialog so the menu item will be always unchecked
	x25_menu_line_trace->setItemChecked(x25_menu_line_trace->idAt(1), FALSE );
}

///////////////////////////////////////////////////
//X25 mail box manipulation functions
void TesterWizardImpl::ResetCB(XCBLOCK *c1)
{	memset((void *)c1, 0, sizeof(XCBLOCK));
}

void TesterWizardImpl::SaveCB(XCBLOCK *dest, XCBLOCK *src)
{	memcpy((void *)dest, (void *)src, sizeof(XCBLOCK));
}

bool TesterWizardImpl::CompCB(XCBLOCK *c1, XCBLOCK *c2)
{	if (memcmp((void *)c1, (void *)c2, sizeof(XCBLOCK)) == 0)
		return(true);

	return(false);
}

WORD TesterWizardImpl::GetDUI(BYTE *d)
{	return( (WORD)(*d) + ((WORD)(*(d+1)) << 8) );
}

///////////////////////////////////////////////////
//Fr mail box manipulation functions
void TesterWizardImpl::SaveCB(FCBLOCK *dest, FCBLOCK *src)
{	memcpy((void *)dest, (void *)src, sizeof(FCBLOCK));
}

BOOL TesterWizardImpl::CompCB(FCBLOCK *c1, FCBLOCK *c2)
{	if (memcmp((void *)&c1->command, (void *)&c2->command, sizeof(FCBLOCK)) == 0)
		return(TRUE);
	return(FALSE);
}

void TesterWizardImpl::ResetCB(FCBLOCK *c1)
{	memset((void *)&c1->command, 0, sizeof(FCBLOCK));
}
///////////////////////////////////////////////////

void TesterWizardImpl::on_frmon_link_status()
{
	DbgPrint1(DBG_MAIN_WIZ, "TesterWizardImpl::on_frmon_link_status()\n");
	
	if( fr_menu_link_monitor->isItemChecked(fr_menu_link_monitor->idAt(0)) == FALSE)
	{
		if(fr_link_status->my_show() == TRUE)
		{	fr_menu_link_monitor->setItemChecked(fr_menu_link_monitor->idAt(0), TRUE );
		}
	}
}

void TesterWizardImpl::on_frmon_global_stats()
{
	DbgPrint1(DBG_MAIN_WIZ, "TesterWizardImpl::on_frmon_global_stats()\n");
	
	if( fr_menu_link_monitor->isItemChecked(fr_menu_link_monitor->idAt(1)) == FALSE)
	{
		if(fr_global_stats->my_show())
		{	fr_menu_link_monitor->setItemChecked(fr_menu_link_monitor->idAt(1), TRUE );
		}
	}
}

void TesterWizardImpl::on_frmon_stn_specific_stats()
{
	DbgPrint1(DBG_MAIN_WIZ, "TesterWizardImpl::on_frmon_stn_specific_stats()\n");
	
	if( fr_menu_link_monitor->isItemChecked(fr_menu_link_monitor->idAt(2)) == FALSE)
	{
		if(set_fr_cfg.m_fr_cfg.Station)
		{	fr_node_stats->show();

				fr_menu_link_monitor->
					setItemChecked(fr_menu_link_monitor->idAt(2), TRUE );

		}else
		{	if(fr_cpe_stats->my_show() == TRUE)
			{
				fr_menu_link_monitor->
					setItemChecked(fr_menu_link_monitor->idAt(2), TRUE );
			}
		}
	}
}

void TesterWizardImpl::on_frmon_comm_err_stats()
{
	DbgPrint1(DBG_MAIN_WIZ, "TesterWizardImpl::on_frmon_comm_err_stats()\n");
	
	if( fr_menu_link_monitor->isItemChecked(fr_menu_link_monitor->idAt(3)) == FALSE)
	{
		fr_menu_link_monitor->setItemChecked(fr_menu_link_monitor->idAt(3), TRUE );
		fr_comms_err_stats->show();
	}
}

void TesterWizardImpl::on_frmon_modem_stats()
{
	DbgPrint1(DBG_MAIN_WIZ, "TesterWizardImpl::on_frmon_modem_stats()\n");
	
	if( fr_menu_link_monitor->isItemChecked(fr_menu_link_monitor->idAt(4)) == FALSE)
	{
		fr_menu_link_monitor->setItemChecked(fr_menu_link_monitor->idAt(4), TRUE );
		fr_modem_status->show();
	}
}


void TesterWizardImpl::on_frmon_configured_dlci_and_stats()
{
	DbgPrint1(DBG_MAIN_WIZ, "TesterWizardImpl::on_frmon_configured_dlci_and_stats()\n");
	
	if( fr_menu_dlci_monitor->isItemChecked(fr_menu_dlci_monitor->idAt(0)) == FALSE)
	{
		fr_menu_dlci_monitor->setItemChecked(fr_menu_dlci_monitor->idAt(0), TRUE );
		fr_configured_dlcis->show();
	}
}


void TesterWizardImpl::on_frmon_open_line_trace_window()
{
	DbgPrint1(DBG_MAIN_WIZ, "TesterWizardImpl::on_frmon_open_line_trace_window()\n");
	
	if( fr_menu_line_trace->isItemChecked(fr_menu_line_trace->idAt(0)) == FALSE)
	{
		if(fr_line_trace->EnableTrace() == TRUE)
		{
			fr_menu_line_trace->setItemChecked(fr_menu_line_trace->idAt(0), TRUE );
			fr_line_trace->show();

		}
	}
}

void TesterWizardImpl::on_frmon_set_line_trace_file_name()
{
	get_trace_file_name();
	//it is a modal dialog so the menu item will be always unchecked
	fr_menu_line_trace->setItemChecked(fr_menu_line_trace->idAt(1), FALSE );
}

void TesterWizardImpl::get_trace_file_name()
{
	char message[255];
	
	//in case the file already open and user needs another one
	if (trace_file != NULL)
	{	//close old file
		fclose( trace_file );
		trace_file = NULL;
	}

	QString initial_file_name;


	switch(m_intProtocolLoaded)
	{
	case PROTOCOL_OPTION_X25:
		initial_file_name = "x25_trace.txt";
		break;		
	case PROTOCOL_OPTION_FR:
		initial_file_name = "frame_relay_trace.txt";
		break;
	case PROTOCOL_OPTION_ATM:
		initial_file_name = "atm_trace.txt";
		break;
	}
	
	QString fileName = QFileDialog::getSaveFileName(initial_file_name, 0, this, 0);
	
	if (fileName.isEmpty() == FALSE)
	{
		sprintf(trace_file_name, "%s", fileName.latin1());
		
		DbgPrint2(DBG_MAIN_WIZ, "trace_file_name : %s", trace_file_name);
		
		trace_file = fopen( trace_file_name, "w" );
		
		if (trace_file == NULL)
		{	sprintf( message, "Can not open the file %s", trace_file_name);
			QMessageBox::warning(this, "File error", message);
		}
	}else
	{	QMessageBox::warning(
			this,
			"",
			tr("No trace file was chosen. Trace to file option will be disabled.")
			);
		strcpy(trace_file_name, "");
	}
}


void TesterWizardImpl::TesterWizard_destroyed( QObject * p)
{
	DbgPrint1(DBG_MAIN_WIZ, "TesterWizard_destroyed( QObject * p)\n");
}

void TesterWizardImpl::atm_set_phy_configuration()
{
	DbgPrint1(DBG_MAIN_WIZ, "atm_set_phy_configuration()\n");	

	int rc, configuration_changed = 0;


	rc = atm_phy_cfg.exec();
	
	DbgPrint2(DBG_MAIN_WIZ, "atm_set_phy_configuration() : rc : %d\n", rc);

	//
	//if config dialog was released by OK button and if configuration
	//has changed, set the new config.
	//
	configuration_changed = memcmp(	&atm_phy_cfg.atm_phy_cfg_old,
									&atm_phy_cfg.atm_phy_cfg, 
									sizeof(PHY_CONFIGURATION_STRUCT)
									);

	DbgPrint2(DBG_MAIN_WIZ, "atm_set_phy_configuration() : configuration_changed : %d\n",
		configuration_changed);

	if(	rc == 0)

	{	
		DbgPrint1(DBG_MAIN_WIZ, "rc == IDOK\n");

		if( app_command_line_empty == FALSE && configuration_changed )
		{	//disable comms before setting cfg
			if(atm_phy_enable_disable_communications())

				return;

			atm_do_set_configuration();

			atm_phy_enable_disable_communications();
		}else if(app_command_line_empty == TRUE)
		{
			atm_do_set_configuration();
		}


	}else
	{	DbgPrint1(DBG_MAIN_WIZ, "rc == IDCANCEL\n");
	}
}

int TesterWizardImpl::atm_do_set_configuration()
{
	//save new configuration for future comparisons
	memcpy(	&atm_phy_cfg.atm_phy_cfg_old, &atm_phy_cfg.atm_phy_cfg,
		sizeof(PHY_CONFIGURATION_STRUCT));
	
	atm_api_obj.atm_cb.command = PHY_SET_CONFIGURATION;

	atm_api_obj.atm_cb.buffer_length = sizeof(PHY_CONFIGURATION_STRUCT);
	atm_api_obj.atm_cb.return_code = Z80_TIMEOUT_ERROR;
	
	//copy cfg into mailbox data area
	memcpy(	atm_api_obj.atm_cb.data, &atm_phy_cfg.atm_phy_cfg,
			sizeof(PHY_CONFIGURATION_STRUCT));
	
	atm_do_command(&atm_api_obj.atm_cb, m_cCard);
	
	if(atm_api_obj.atm_cb.return_code)
	{
		DbgPrint2(DBG_MAIN_WIZ,
			"on PHY_SET_CONFIGURATION : rc 0x%X \n", atm_api_obj.atm_cb.return_code);

		atm_enable_disable_visual_controls(FALSE);


	}else
	{
		DbgPrint1(DBG_MAIN_WIZ, "PHY_SET_CONFIGURATION : OK\n");

		//Everything went well - start poll timer for the
		//main dialog (the wizard itself).
		start_poll_timers();

		if(atm_do_set_aal_configuration() == 0)
			atm_enable_disable_visual_controls(TRUE);
	}

	return atm_api_obj.atm_cb.return_code;
}

void  TesterWizardImpl::atm_enable_disable_visual_controls(BOOL flag)
{
    //pushButton_Set_PHY_Configuration;
    //pushButton_Set_ATM_AAL_Configuration;
    pushButton_Delete_VPI_VCI->setEnabled(flag);
    pushButton_Add_VPI_VCI->setEnabled(flag);
    pushButton_Send_Data->setEnabled(flag);
    pushButton_Send_ATM_Loopback->setEnabled(flag);
    pushButton_AAL_Connect_Disconnect_PVC->setEnabled(flag);
    pushButton_OAM_Continuity_Check_Ctr->setEnabled(flag);

    pushButton_Resynch_PHY_Receiver->setEnabled(flag);
    pushButton_Enable_Disable_PHY_Comms->setEnabled(flag);
    //pushButton_Enable_Disable_SAR->setEnabled(flag);

	atm_phy_level_stats_menu->setEnabled(flag);
	atm_atmal_level_status_and_stats_menu->setEnabled(flag);
	atm_phy_level_trace_menu->setEnabled(flag);
}

//poll timers for the main dialog (the wizard itself)

void TesterWizardImpl::start_poll_timers()
{
	if(!rx_timer_id)
	{	rx_timer_id = startTimer(RX_DELAY);
	}
	if( !tx_timer_id)
	{	tx_timer_id = startTimer(TX_DELAY);
	}
}

void TesterWizardImpl::stop_poll_timers()
{
	if(rx_timer_id)
		killTimer(rx_timer_id);

	if(tx_timer_id)
		killTimer(tx_timer_id);

	rx_timer_id = 0;

	tx_timer_id = 0;
}


void TesterWizardImpl::on_read_atm_statistics()
{
	PHY_STATUS_STRUCT * ptr_status_struct = 
		(PHY_STATUS_STRUCT *)atm_api_obj.atm_cb.data;

	DbgPrint1(DBG_MAIN_WIZ, "on_read_atm_statistics()\n");	

	atm_api_obj.atm_cb.command = PHY_READ_STATUS;
	atm_api_obj.atm_cb.buffer_length = sizeof(PHY_STATUS_STRUCT);
	atm_api_obj.atm_cb.return_code = Z80_TIMEOUT_ERROR;
	atm_do_command(&atm_api_obj.atm_cb, m_cCard);
}

unsigned char TesterWizardImpl::atm_do_command(ATM_MAILBOX_STRUCT * block, BYTE cardnumber)
{
	ATMAPICONTROL(block, cardnumber);
			
	atm_decode_return_code(block);

	return(block->return_code);
}

void TesterWizardImpl::atm_decode_return_code(ATM_MAILBOX_STRUCT * block)
{
	QString command_name = "";
	QString command_return_code = "";
	QString command_data = "";
	bool show_result_to_user = true;

	QTime new_time = QTime::currentTime();      // get the current time
	QString str_new_time = new_time.toString ( QString("hh:mm:ss.zzz") );

	switch(block->command)
	{
	/////////////////////////////////////////////////
	//PHY level/global commands:
	case READ_GLOBAL_EXCEPTION_CONDITION:
		command_name = "READ_GLOBAL_EXCEPTION_CONDITION";

		switch(block->return_code)
		{
		case 0x00:

			break;
		default:
			;
		}
		break;

	case SET_GLOBAL_CONFIGURATION:
		command_name = "SET_GLOBAL_CONFIGURATION";

		break;

	case READ_GLOBAL_CONFIGURATION:
		command_name = "READ_GLOBAL_CONFIGURATION";

		break;

	case READ_GLOBAL_STATISTICS:
		command_name = "READ_GLOBAL_STATISTICS";

		break;

	case FLUSH_GLOBAL_STATISTICS:
		command_name = "FLUSH_GLOBAL_STATISTICS";

		break;

	case SET_MODEM_STATUS:
		command_name = "SET_MODEM_STATUS";

		break;

	case READ_MODEM_STATUS:
		command_name = "READ_MODEM_STATUS";

		break;

	case READ_COMMS_ERROR_STATS:
		command_name = "READ_COMMS_ERROR_STATS";
		show_result_to_user = false;
		break;

	case FLUSH_COMMS_ERROR_STATS:
		command_name = "FLUSH_COMMS_ERROR_STATS";

		break;


	case SET_TRACE_CONFIGURATION:
		command_name = "SET_TRACE_CONFIGURATION";

		break;

	case READ_TRACE_CONFIGURATION:
		command_name = "READ_TRACE_CONFIGURATION";

		break;

	case READ_TRACE_STATISTICS:
		command_name = "READ_TRACE_STATISTICS";

		break;

	case FLUSH_TRACE_STATISTICS:
		command_name = "FLUSH_TRACE_STATISTICS";

		break;

	/* PHY-level interface commands */
	case PHY_READ_CODE_VERSION:
		command_name = "PHY_READ_CODE_VERSION";

		break;

	case PHY_READ_EXCEPTION_CONDITION:
		command_name = "PHY_READ_EXCEPTION_CONDITION";

		switch(atm_api_obj.atm_cb.return_code)
		{
		case PHY_EXCEP_RX_SYNC_STATE_CHANGE:

			atm_parse_phy_read_status_structure(
								(PHY_STATUS_STRUCT *)atm_api_obj.atm_cb.data,
								&command_data,
								PHY_READ_EXCEPTION_CONDITION
								);

			if(((PHY_STATUS_STRUCT *)atm_api_obj.atm_cb.data)->Rx_sync_status == 
					PHY_RX_SYNCHRONIZED)
			{	//do not show anything to the user!!
				show_result_to_user = false;
				//now when it is in synch, read the statistics
				on_read_atm_statistics();
			}

			break;

		case PHY_EXCEP_INVALID_HEC:
			command_data = phy_prefix + "cell received with an invalid HEC.";
			break;

		case PHY_EXCEP_RECEP_LOSS:
			command_data = phy_prefix + "no incomig cell.";
			break;

		case PHY_EXCEP_RX_DISCARD:
			command_data = "PHY_EXCEP_RX_DISCARD";
			break;

		case PHY_EXCEP_TX_LENGTH_ERROR:
			command_data = "PHY_EXCEP_TX_LENGTH_ERROR";
			break;

		case PHY_NO_EXCEP_COND_TO_REPORT:
			show_result_to_user = false;
			break;
		}

		break;

	case PHY_SET_CONFIGURATION:
		command_name = "PHY_SET_CONFIGURATION";

		break;

	case PHY_READ_CONFIGURATION:
		command_name = "PHY_READ_CONFIGURATION";

		break;

	case PHY_ENABLE_COMMUNICATIONS:
		command_name = "PHY_ENABLE_COMMUNICATIONS";

		break;

	case PHY_DISABLE_COMMUNICATIONS:
		command_name = "PHY_DISABLE_COMMUNICATIONS";

		break;

	case PHY_READ_STATUS:
		command_name = "PHY_READ_STATUS";

		if(atm_show_command_result == false)
			show_result_to_user = false;

		switch(block->return_code)
		{
		case 0x00:
			atm_parse_phy_read_status_structure(
								(PHY_STATUS_STRUCT *)atm_api_obj.atm_cb.data,
								&command_data,
								PHY_READ_STATUS
								);

			break;
		default:
			;
		}
		break;

	case PHY_READ_OPERATIONAL_STATS:
		command_name = "PHY_READ_OPERATIONAL_STATS";
		show_result_to_user = false;
		break;

	case PHY_FLUSH_OPERATIONAL_STATS:
		command_name = "PHY_FLUSH_OPERATIONAL_STATS";

		break;

	case PHY_RESYNCHRONIZE_RECEIVER:
		command_name = "PHY_RESYNCHRONIZE_RECEIVER";

		break;

	case PHY_SET_TX_UNDERRUN_CONFIG:
		command_name = "PHY_SET_TX_UNDERRUN_CONFIG";

		break;

	case PHY_READ_TX_UNDERRUN_CONFIG:
		command_name = "PHY_READ_TX_UNDERRUN_CONFIG";

		break;

	case PHY_SET_INTERRUPT_TRIGGERS:
		command_name = "PHY_SET_INTERRUPT_TRIGGERS";

		break;

	case PHY_READ_INTERRUPT_TRIGGERS:
		command_name = "PHY_READ_INTERRUPT_TRIGGERS";


		break;
	/////////////////////////////////////////////////
	//ATM/AAL level commands:
	case ATMAL_READ_CODE_VERSION:
		command_name = "ATMAL_READ_CODE_VERSION";

		break;

	case ATMAL_READ_EXCEPTION_CONDITION:
		command_name = "ATMAL_READ_EXCEPTION_CONDITION";

		if(	atm_api_obj.atm_cb.return_code != Z80_TIMEOUT_ERROR	&&
			atm_api_obj.atm_cb.return_code != ATMAL_NO_EXCEP_COND_TO_REPORT)
		{
			atm_parse_read_atmal_exception_structure(&command_data);
		}else
		{
			show_result_to_user = false;
		}

		break;

	case ATMAL_SET_CONFIGURATION:
		command_name = "ATMAL_SET_CONFIGURATION";


		break;

	case ATMAL_READ_CONFIGURATION:
		command_name = "ATMAL_READ_CONFIGURATION";

		break;

	case ATMAL_ENABLE_SAR:
		command_name = "ATMAL_ENABLE_SAR";

		break;

	case ATMAL_DISABLE_SAR:
		command_name = "ATMAL_DISABLE_SAR";

		break;

	case ATMAL_READ_STATUS:
		command_name = "ATMAL_READ_STATUS";

		break;

	case ATMAL_READ_OPERATIONAL_STATS:
		command_name = "ATMAL_READ_OPERATIONAL_STATS";
		show_result_to_user = false;
		break;

	case ATMAL_FLUSH_OPERATIONAL_STATS:
		command_name = "ATMAL_FLUSH_OPERATIONAL_STATS";

		break;

	case ATMAL_FLUSH_TX_BUFFERS:
		command_name = "ATMAL_FLUSH_TX_BUFFERS";

		break;

	case ATMAL_FLUSH_RX_BUFFERS:
		command_name = "ATMAL_FLUSH_RX_BUFFERS";

		break;

	case ATMAL_ADD_PVC:
		command_name = "ATMAL_ADD_PVC";

		switch(block->return_code)
		{
		case 0x00:
			command_data = SUCCESS_STRING;
			break;
		case ATMAL_PVC_ADDED://0x46
			command_data = "PVC already added";
			break;

		default:
			;
		}

		break;

	case ATMAL_DELETE_PVC:
		command_name = "ATMAL_DELETE_PVC";

		break;

	case ATMAL_CONNECT_PVC:
		command_name = "ATMAL_CONNECT_PVC";

		switch(block->return_code)
		{
		case 0x00:
			command_data = SUCCESS_STRING;
			break;
		case ATMAL_PVC_CONNECTED://0x47
			command_data = "PVC already connected";
			break;

		default:
			;
		}

		break;

	case ATMAL_DISCONNECT_PVC:
		command_name = "ATMAL_DISCONNECT_PVC";

		switch(block->return_code)
		{
		case 0x00:
			command_data = SUCCESS_STRING;
			break;
		case ATMAL_PVC_DISCONNECTED://0x47:
			command_data = "PVC already disconnected";
			break;

		default:
			;
		}

		break;

	case ATMAL_LIST_ADDED_PVCS:
		command_name = "ATMAL_LIST_ADDED_PVCS";
		show_result_to_user = false;
		break;

	case ATMAL_LIST_CONNECTED_PVCS:
		command_name = "ATMAL_LIST_CONNECTED_PVCS";

		break;

	case ATMAL_READ_PVC_STATUS:
		command_name = "ATMAL_READ_PVC_STATUS";
		show_result_to_user = false;
		break;

	case ATMAL_SET_INTERRUPT_TRIGGERS:
		command_name = "ATMAL_SET_INTERRUPT_TRIGGERS";

		break;

	case ATMAL_READ_INTERRUPT_TRIGGERS:
		command_name = "ATMAL_READ_INTERRUPT_TRIGGERS";

		break;

	case ATMAL_OAM_TRANSMIT_LOOPBACK:
		command_name = "ATMAL_OAM_TRANSMIT_LOOPBACK";

		break;

	case ATMAL_OAM_ACT_DEACT:
		command_name = "ATMAL_OAM_ACT_DEACT";

		switch(block->return_code)
		{
		case 0x00:
			command_data = SUCCESS_STRING;
			break;
		case ATMAL_OAM_INVALID_STATE://0x50

			if(block->command_qualifier == (OAM_CONTINUITY_CHECK | ACTIVATE_OAM_SIGNAL))
			{	command_data = "Continuity Check already enabled";
			}else if(block->command_qualifier == (OAM_CONTINUITY_CHECK | DEACTIVATE_OAM_SIGNAL))
			{	command_data = "Continuity Check already disabled";
			}else
			{	command_data = "No expanation string.";
			}
			break;

		default:
			;
		}
		break;

	default:
		//unknown command
		command_name = "unknown command";
	}

	if(show_result_to_user == true)
	{
		list_view_item = 
			new QListViewItem(MainListView_ATM, MainListView_ATM->lastItem());

		command_name = str_new_time + " " + command_name;
		list_view_item->setText(CMD_COL, command_name);
		

		command_return_code.sprintf("0x%02X", block->return_code);
		list_view_item->setText(CMD_RC_COL, command_return_code);

		list_view_item->setText(CMD_RC_EXPL_COL, command_data);

		LIST_VIEW_ADDSTR(MainListView_ATM, NULL);

	}
}

void TesterWizardImpl::ATM_OnTimer(int timer_id)
{
	if(timer_id == rx_timer_id)
	{
		atm_read_phy_exception_condition();
		atm_read_atmal_exception_cond();

		atm_line_trace_ptr->timerEvent(NULL);
		atm_comms_err_stats_ptr->timerEvent(NULL);
		atm_phy_oper_stats_ptr->timerEvent(NULL);
		atm_phy_level_status_ptr->timerEvent(NULL);
		atm_vpi_vci_status_ptr->timerEvent(NULL);
		atm_vpi_vci_list_ptr->timerEvent(NULL);
		atm_delete_vpi_vci_ptr->timerEvent(NULL);
		atm_connect_disconnect_pvc_ptr->timerEvent(NULL);
		atm_oam_continuity_check_ctrl_ptr->timerEvent(NULL);
		atm_send_atm_aal_loopback_ptr->timerEvent(NULL);
		atm_read_data();
	}

}

unsigned char TesterWizardImpl::atm_read_phy_exception_condition()
{
	atm_api_obj.atm_cb.command = PHY_READ_EXCEPTION_CONDITION;
	atm_api_obj.atm_cb.buffer_length = 0;
	atm_api_obj.atm_cb.return_code = Z80_TIMEOUT_ERROR;
	atm_do_command(&atm_api_obj.atm_cb, m_cCard);

	return atm_api_obj.atm_cb.return_code;
}

void TesterWizardImpl::atm_parse_phy_read_status_structure(
								PHY_STATUS_STRUCT * ptr_status_struct,
								QString * result_string,
								unsigned int command
								)
{


	*result_string = phy_prefix;

	if(command == PHY_READ_EXCEPTION_CONDITION)
	{
		switch(ptr_status_struct->Rx_sync_status)
		{
		case PHY_RX_SYNC_LOST:
			*result_string += "Receiver entered Synchronization state. ";
			break;
		
		case PHY_RX_HUNT:
			*result_string += "Receiver entered Hunt state. ";
			break;

		case PHY_RX_PRESYNC:
			*result_string += "Receiver entered Presync state. ";
			break;

		case PHY_RX_SYNCHRONIZED:
			;//do nothing
			break;

		default:
			((QString)*result_string).sprintf("Rx_sync_status 0x%02X ???",
				ptr_status_struct->Rx_sync_status);
		}
	}

	if(command == PHY_READ_STATUS)
	{
		QString temp;

		switch(ptr_status_struct->Rx_sync_status)
		{
		case PHY_RX_SYNC_LOST:
			*result_string += "Receiver entered Synchronization state. ";
			break;
		
		case PHY_RX_HUNT:
			*result_string += "Receiver entered Hunt state. ";
			break;

		case PHY_RX_PRESYNC:
			*result_string += "Receiver entered Presync state. ";
			break;

		case PHY_RX_SYNCHRONIZED:
			*result_string += "Receiver Synchronized. ";

			//temp.sprintf("No. blocks for reception: %d, ",
			//	ptr_status_struct->no_Rx_blocks_avail);
			//*result_string += temp;

			temp.sprintf("Rx sync time: %u, ", ptr_status_struct->Rx_sync_time);
			*result_string += temp;

			temp.sprintf("Rx sync bytes: 0x%04X, ", ptr_status_struct->Rx_sync_bytes);
			*result_string += temp;

			temp.sprintf("Rx sync offset: %u.", ptr_status_struct->Rx_sync_offset);
			*result_string += temp;

			break;

		default:
			((QString)*result_string).sprintf("Rx_sync_status 0x%02X ???",
				ptr_status_struct->Rx_sync_status);
		}
	}
}

void TesterWizardImpl::atm_on_phy_level_status()
{
	DbgPrint1(DBG_MAIN_WIZ, "atm_on_phy_level_status()\n");

	if( atm_phy_level_stats_menu->
			isItemChecked(atm_phy_level_stats_menu->idAt(0)) == FALSE)
	{
		atm_phy_level_stats_menu->
			setItemChecked(atm_phy_level_stats_menu->idAt(0), TRUE );

		if(atm_phy_level_status_ptr->initialize() == true)
		{	atm_phy_level_status_ptr->show();
		}
	}
}

void TesterWizardImpl::atm_on_phy_communication_err_stats()
{
	DbgPrint1(DBG_MAIN_WIZ, "atm_on_phy_communication_err_stats()\n");

	if( atm_phy_level_stats_menu->
			isItemChecked(atm_phy_level_stats_menu->idAt(1)) == FALSE)
	{
		atm_phy_level_stats_menu->setItemChecked(
			atm_phy_level_stats_menu->idAt(1), TRUE );

		if(atm_comms_err_stats_ptr->initialize() == true)
		{	atm_comms_err_stats_ptr->show();
		}
	}
}

void TesterWizardImpl::atm_on_phy_operational_stats()
{
	DbgPrint1(DBG_MAIN_WIZ, "atm_on_phy_operational_stats()\n");

	if( atm_phy_level_stats_menu->
			isItemChecked(atm_phy_level_stats_menu->idAt(2)) == FALSE)
	{
		atm_phy_level_stats_menu->
			setItemChecked(atm_phy_level_stats_menu->idAt(2), TRUE );

		if(atm_phy_oper_stats_ptr->initialize() == true)

		{	atm_phy_oper_stats_ptr->show();
		}
	}
}


void TesterWizardImpl::atm_on_phy_open_trace()
{
	DbgPrint1(DBG_MAIN_WIZ, "atm_on_phy_open_trace()\n");


	if( atm_phy_level_trace_menu->
			isItemChecked(atm_phy_level_trace_menu->idAt(0)) == FALSE)
	{
		atm_phy_level_trace_menu->
			setItemChecked(atm_phy_level_trace_menu->idAt(0), TRUE );

		if(atm_line_trace_ptr->initialize() == true)
		{	atm_line_trace_ptr->show();
		}
	}
}

void TesterWizardImpl::atm_set_atm_aal_configuration()
{

	DbgPrint1(DBG_MAIN_WIZ, "atm_set_atm_aal_configuration()\n");

	int rc, configuration_changed = 0;

	rc = atm_set_atm_aal_cfg.exec();
	
	DbgPrint2(DBG_MAIN_WIZ, "atm_set_atm_aal_configuration() : rc : %d\n", rc);

	//
	//if config dialog was released by OK button and if configuration
	//has changed, set the new config.
	//
	configuration_changed = memcmp(	&atm_set_atm_aal_cfg.atm_aal_cfg_old,
									&atm_set_atm_aal_cfg.atm_aal_cfg, 
									sizeof(atm_set_atm_aal_cfg.atm_aal_cfg)
									);

	DbgPrint2(DBG_MAIN_WIZ, "atm_set_phy_configuration() : configuration_changed : %d\n",
		configuration_changed);

	if(	rc == 0)
	{	
		DbgPrint1(DBG_MAIN_WIZ, "rc == IDOK\n");

		if( configuration_changed )
		{
			//save new configuration for future comparisons
			memcpy(	&atm_set_atm_aal_cfg.atm_aal_cfg_old,
					&atm_set_atm_aal_cfg.atm_aal_cfg, 
					sizeof(atm_set_atm_aal_cfg.atm_aal_cfg)
					);

			atm_do_set_aal_configuration();
		}
	}else
	{	DbgPrint1(DBG_MAIN_WIZ, "rc == IDCANCEL\n");
	}
	

}

int TesterWizardImpl::atm_do_set_aal_configuration()
{
	atm_api_obj.atm_cb.command = ATMAL_SET_CONFIGURATION;
	atm_api_obj.atm_cb.buffer_length = sizeof(ATMAL_CONFIGURATION_STRUCT);
	atm_api_obj.atm_cb.return_code = Z80_TIMEOUT_ERROR;
	
	//copy cfg into mailbox data area
	memcpy(	atm_api_obj.atm_cb.data,
			&atm_set_atm_aal_cfg.atm_aal_cfg,
			sizeof(ATMAL_CONFIGURATION_STRUCT)
			);
	
	atm_do_command(&atm_api_obj.atm_cb, m_cCard);

	return atm_api_obj.atm_cb.return_code;
}

void TesterWizardImpl::atm_add_vpi_vci()
{
	DbgPrint1(DBG_MAIN_WIZ, "atm_add_vpi_vci()\n");	
	
	int rc, configuration_changed = 0;

	rc = atm_add_vpi_vci_screen.exec();

	DbgPrint2(DBG_MAIN_WIZ, "atm_add_vpi_vci() : rc : %d\n", rc);

	if(	rc == 0)
	{	
		DbgPrint1(DBG_MAIN_WIZ, "rc == IDOK\n");

		atm_do_add_vpi_vci();

	}else
	{	DbgPrint1(DBG_MAIN_WIZ, "rc == IDCANCEL\n");
	}
}

int TesterWizardImpl::atm_do_add_vpi_vci()
{
	atm_api_obj.atm_cb.GFC_VPI	= atm_add_vpi_vci_screen.GFC_VPI;
	atm_api_obj.atm_cb.VCI		= atm_add_vpi_vci_screen.VCI;

	atm_api_obj.atm_cb.command = ATMAL_ADD_PVC;
	atm_api_obj.atm_cb.buffer_length = sizeof(ATMAL_ADD_PVC_STRUCT);
	atm_api_obj.atm_cb.return_code = Z80_TIMEOUT_ERROR;
	
	//copy cfg into mailbox data area
	memcpy(	atm_api_obj.atm_cb.data,
			&atm_add_vpi_vci_screen.add_pvc_struct,
			sizeof(ATMAL_ADD_PVC_STRUCT)
			);
	
	atm_do_command(&atm_api_obj.atm_cb, m_cCard);
	
	return atm_api_obj.atm_cb.return_code;
}

//////////////////////////////////////////////////////////////

int TesterWizardImpl::atm_do_enable_phy_comms()
{
	atm_api_obj.atm_cb.command = PHY_ENABLE_COMMUNICATIONS;
	atm_api_obj.atm_cb.buffer_length = 0;
	atm_api_obj.atm_cb.return_code = Z80_TIMEOUT_ERROR;
		
	atm_do_command(&atm_api_obj.atm_cb, m_cCard);
		
	return atm_api_obj.atm_cb.return_code;
}

int TesterWizardImpl::atm_do_disable_phy_comms()
{
	atm_api_obj.atm_cb.command = PHY_DISABLE_COMMUNICATIONS;
	atm_api_obj.atm_cb.buffer_length = 0;
	atm_api_obj.atm_cb.return_code = Z80_TIMEOUT_ERROR;
		
	atm_do_command(&atm_api_obj.atm_cb, m_cCard);
		
	return atm_api_obj.atm_cb.return_code;
}

//////////////////////////////////////////////////////////////

int TesterWizardImpl::atm_do_aal_enable_sar()
{
	atm_api_obj.atm_cb.command = ATMAL_ENABLE_SAR;
	atm_api_obj.atm_cb.buffer_length = 0;
	atm_api_obj.atm_cb.return_code = Z80_TIMEOUT_ERROR;
		
	atm_do_command(&atm_api_obj.atm_cb, m_cCard);
		
	return atm_api_obj.atm_cb.return_code;
}

int TesterWizardImpl::atm_do_aal_disable_sar()
{
	atm_api_obj.atm_cb.command = ATMAL_DISABLE_SAR;
	atm_api_obj.atm_cb.buffer_length = 0;
	atm_api_obj.atm_cb.return_code = Z80_TIMEOUT_ERROR;
		
	atm_do_command(&atm_api_obj.atm_cb, m_cCard);
		
	return atm_api_obj.atm_cb.return_code;
}

//////////////////////////////////////////////////////////////

int TesterWizardImpl::atm_do_aal_connect_pvc()
{
	atm_api_obj.atm_cb.command = ATMAL_CONNECT_PVC;
	atm_api_obj.atm_cb.buffer_length = 0;
	atm_api_obj.atm_cb.return_code = Z80_TIMEOUT_ERROR;

	atm_do_command(&atm_api_obj.atm_cb, m_cCard);
		
	return atm_api_obj.atm_cb.return_code;
}

int TesterWizardImpl::atm_do_aal_disconnect_pvc()
{
	atm_api_obj.atm_cb.command = ATMAL_DISCONNECT_PVC;
	atm_api_obj.atm_cb.buffer_length = 0;
	atm_api_obj.atm_cb.return_code = Z80_TIMEOUT_ERROR;
		
	atm_do_command(&atm_api_obj.atm_cb, m_cCard);
		
	return atm_api_obj.atm_cb.return_code;
}

//////////////////////////////////////////////////////////////

int TesterWizardImpl::atm_enable_disable_sar()
{
	if(	atm_sar_enabled == false)
	{	
		atm_do_aal_enable_sar();
		if(!atm_api_obj.atm_cb.return_code)
		{	atm_sar_enabled = true;
			//pushButton_Enable_Disable_SAR->setText("Disable SAR");
		}
	}else
	{	
		atm_do_aal_disable_sar();
		if(!atm_api_obj.atm_cb.return_code)
		{	atm_sar_enabled = false;
			//pushButton_Enable_Disable_SAR->setText("Enable SAR");
		}
	}

	return atm_api_obj.atm_cb.return_code;
}

//////////////////////////////////////////////////////////////

int TesterWizardImpl::atm_connect_disconnect_pvc()
{

	if(atm_connect_disconnect_pvc_ptr->window_closed == true)
	{
		atm_connect_disconnect_pvc_ptr->initialize();
		atm_connect_disconnect_pvc_ptr->show();
	}
	return atm_api_obj.atm_cb.return_code;
}

//////////////////////////////////////////////////////////////

int TesterWizardImpl::atm_phy_enable_disable_communications()
{
	if(	atm_phy_comms_enabled == false)
	{	
		atm_do_enable_phy_comms();

		if(!atm_api_obj.atm_cb.return_code)
		{	atm_phy_comms_enabled = true;
			pushButton_Enable_Disable_PHY_Comms->setText("Disable PHY Communications");
		}
	}else
	{	
		atm_do_disable_phy_comms();
		if(!atm_api_obj.atm_cb.return_code)
		{	atm_phy_comms_enabled = false;
			pushButton_Enable_Disable_PHY_Comms->setText("Enable PHY Communications");
		}
	}

	return atm_api_obj.atm_cb.return_code;
}

//////////////////////////////////////////////////////////////

void TesterWizardImpl::atm_send_data()
{
	if(atm_send_info_frames_ptr->my_isVisible() == false)
	{
		atm_send_info_frames_ptr->my_show();
	}
}

void TesterWizardImpl::atm_delete_vpi_vci()
{

	if(atm_delete_vpi_vci_ptr->window_closed == true)
	{
		atm_delete_vpi_vci_ptr->initialize();
		atm_delete_vpi_vci_ptr->show();
	}
}

int ParseTextToHex(int length,
				   unsigned char * src,
				   unsigned char * destination
				   )
{
	int i, j;
	DWORD v;
	
	i=0; j=0;
	while (i < length) {
		sscanf((const char *)&src[i], "%2lx", &v);
		destination[j] = (BYTE)v;
		j++;
		
		//skip spaces between the hex numbers
		while (i < length && src[i] != ' ')
			i++;

		i++;
	}
	return(j);
}


void TesterWizardImpl::atm_read_data()
{
	AAL_RX_STATUS_EL_STRUCT rx_el;
	int rc, i;
	unsigned char * dbg = (unsigned char *)&rx_el;

	rx_el.ptr_data_bfr = (unsigned long)atm_rx_buffer;

	qstr_length = "";
	qstr_time_stamp = "";
	qstr_data = "";

	qstr_vpi = "";
	qstr_vci = "";

	qstr_pt = "";
	qstr_clp = "";
	qstr_misc_rx_bits = "";

	rc = atm_api_obj.ATMAPIReadData(&rx_el, m_cCard);

	if(rc == 0)
	{
		DbgPrint1(0, "Rx_el:\n");

		for(i=0; i < sizeof(rx_el); i++)
		{
			DbgPrint2(0, "0x%02X ", *(dbg++));
		}

		qstr_length.sprintf("Rx user data : Length : %u ", rx_el.user_info_length);

		qstr_time_stamp.sprintf("Time Stamp : %u  ", rx_el.time_stamp);

		qstr_vpi.sprintf("VPI : %u ", rx_el.GFC_VPI);

		qstr_vci.sprintf(" VCI : %u ", rx_el.VCI);

		qstr_pt.sprintf("PT : 0x%1X ", rx_el.PT);

		qstr_clp.sprintf("CLP : %1d ", rx_el.CLP);

		//qstr_misc_rx_bits.sprintf("misc_Rx_bits : 0x%02X", rx_el.misc_Rx_bits);

		QListViewItem * rx_list_view_item = 
			new QListViewItem(MainListView_ATM, MainListView_ATM->lastItem());

		rx_list_view_item->setText(	CMD_COL,
									qstr_length +
									qstr_time_stamp +
									qstr_vpi +
									qstr_vci
									);
		
		rx_list_view_item->setText(CMD_RC_COL, "--");

		//reusing 'qstr_length'
		qstr_length = "";
		qstr_data = " Data : ";
		//NOTE2: when printing more than 2000 it will crash the program
		for(i = 0; i < rx_el.user_info_length;i++)
		{	qstr_length.sprintf("%02X ", atm_rx_buffer[i]);
			qstr_data += qstr_length;

			if(i >= 2000)
			{	qstr_data += "...";
				break;
			}
		}
		
		rx_list_view_item->setText(	CMD_RC_EXPL_COL, 
									qstr_pt  +
									qstr_clp +
									//qstr_misc_rx_bits +
									qstr_data
									);

		LIST_VIEW_ADDSTR(MainListView_ATM, NULL);
	}
}

void TesterWizardImpl::atm_on_atmal_pvc_status()
{
	DbgPrint1(DBG_MAIN_WIZ, "atm_on_atmal_pvc_status()\n");

	if( atm_atmal_level_status_and_stats_menu->
			isItemChecked(atm_atmal_level_status_and_stats_menu->idAt(0)) == FALSE)
	{
		atm_atmal_level_status_and_stats_menu->setItemChecked(
			atm_atmal_level_status_and_stats_menu->idAt(0), TRUE );

		if(atm_vpi_vci_status_ptr->initialize() == true)
		{	atm_vpi_vci_status_ptr->show();
		}
	}
}

void TesterWizardImpl::atm_on_atmal_pvc_statistics()
{
	if( atm_atmal_level_status_and_stats_menu->
			isItemChecked(atm_atmal_level_status_and_stats_menu->idAt(1)) == FALSE)
	{
		atm_atmal_level_status_and_stats_menu->setItemChecked(
			atm_atmal_level_status_and_stats_menu->idAt(1), TRUE );

		if( atm_vpi_vci_list_ptr->initialize() == true)
		{	atm_vpi_vci_list_ptr->show();
		}
	}
}


void TesterWizardImpl::atm_send_atm_aal_loopback()
{
	if(atm_send_atm_aal_loopback_ptr->window_closed == true)
	{
		atm_send_atm_aal_loopback_ptr->initialize();
		atm_send_atm_aal_loopback_ptr->show();
	}
}

void TesterWizardImpl::atm_recynch_phy_receiver()
{
	atm_api_obj.atm_cb.command = PHY_RESYNCHRONIZE_RECEIVER;
	atm_api_obj.atm_cb.buffer_length = 0;
	atm_api_obj.atm_cb.return_code = Z80_TIMEOUT_ERROR;

	atm_do_command(&atm_api_obj.atm_cb, m_cCard);
}

void TesterWizardImpl::atm_oam_continuity_check_cntrl()
{
	if(atm_oam_continuity_check_ctrl_ptr->window_closed == true)
	{
		atm_oam_continuity_check_ctrl_ptr->initialize();
		atm_oam_continuity_check_ctrl_ptr->show();
	}
}



void TesterWizardImpl::atm_read_atmal_exception_cond()
{
	atm_api_obj.atm_cb.command = ATMAL_READ_EXCEPTION_CONDITION;
	atm_api_obj.atm_cb.buffer_length = 0;
	atm_api_obj.atm_cb.return_code = Z80_TIMEOUT_ERROR;
		
	atm_do_command(&atm_api_obj.atm_cb, m_cCard);
}

void TesterWizardImpl::atm_parse_read_atmal_exception_structure(QString * result_string)
{
	ATMAL_READ_EXCEP_COND_STRUCT * ptr_excep_struct =
		(ATMAL_READ_EXCEP_COND_STRUCT *)atm_api_obj.atm_cb.data;

	QString qstr_temp;


	if(	atm_api_obj.atm_cb.return_code != Z80_TIMEOUT_ERROR	&&
		atm_api_obj.atm_cb.return_code != ATMAL_NO_EXCEP_COND_TO_REPORT)
	{
	
		*result_string = atmal_prefix;

		if(atm_api_obj.atm_cb.command_qualifier == ATMAL_EXCEP_VC)
		{
			qstr_temp.sprintf(
				"Exception condition on VPI/VCI: %u/%u  ",
					atm_api_obj.atm_cb.GFC_VPI, atm_api_obj.atm_cb.VCI);
			*result_string += qstr_temp;
		}else
		{	*result_string += "Global exception condition";
		}

		/*
		qstr_temp.sprintf("Length of exception data: 0x%02X  Exception flag: 0x%04X",
			atm_api_obj.atm_cb.buffer_length, ptr_excep_struct->exception
			);
		*result_string += qstr_temp;
		*/

		if(atm_api_obj.atm_cb.command_qualifier == ATMAL_EXCEP_VC) {
			if(ptr_excep_struct->exception & ATMAL_EXCEP_VC_AUTO_ADD) {
				*result_string += "   VC has automatically added";
			}
			if(ptr_excep_struct->exception & ATMAL_EXCEP_VC_CONNECTED) {
				*result_string += "   VC is connected";
			}
			if(ptr_excep_struct->exception & ATMAL_EXCEP_VC_DISCONNECTED) {
				*result_string += "   VC is disconnected";
			}
			if(ptr_excep_struct->exception & ATMAL_EXCEP_OAM_AIS_START) {
				*result_string += "   OAM AIS start";
			}
			if(ptr_excep_struct->exception & ATMAL_EXCEP_OAM_AIS_END) {
				*result_string += "   OAM AIS end";
			}
			if(ptr_excep_struct->exception & ATMAL_EXCEP_RX_LGTH_ERR) {
				*result_string += "   Received User Info exceeded the maximum length";
			}
			if(ptr_excep_struct->exception & ATMAL_EXCEP_INVALID_CRC) {
				*result_string += "   User Info received with invalid CRC";
			}
			if(ptr_excep_struct->exception & ATMAL_EXCEP_RX_DISCARD) {
				*result_string += "   User Info discarded";
			}
			if(ptr_excep_struct->exception & ATMAL_EXCEP_RX_PDU_TIMEOUT) {
				*result_string += "   A timeout occurred waiting for a PDU";
			}
			if(ptr_excep_struct->exception & ATMAL_EXCEP_TX_LGTH_ERR) {
				*result_string +=
					"   User Info transmitted by application of invalid length";
			}
		}else
		{
			if(ptr_excep_struct->exception & ATMAL_EXCEP_TX_INVALID_VC) {
				*result_string +=
					"   User Info transmitted by application on invalid VC";
			}
			if(ptr_excep_struct->exception & ATMAL_EXCEP_RX_INVALID_VC) {
				*result_string += "   Cells received on an invalid VC";
			}
		}
	}
}
