/***************************************************************************
                          ModemStatus_Impl.cpp  -  description
                             -------------------
    begin                : Fri Oct 12 2001
    copyright            : (C) 2001 by DavidR
    email                : drokhvarg@sangoma.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "MainWizardImpl.h"

extern TesterWizardImpl * globalTesterWizPtr;

ModemStatus_Impl::ModemStatus_Impl( QWidget* parent,
									const char* name,
									WFlags fl):ModemStatus(parent, name, fl )
{
  set_widget_caption(this);
}


ModemStatus_Impl::~ModemStatus_Impl()
{
}

//this is over ride of QObject's timer function
void ModemStatus_Impl::timerEvent(QTimerEvent * e)
{
	XCBLOCK cb;
	static XCBLOCK lastcb;
	
	globalTesterWizPtr->ResetCB(&globalTesterWizPtr->xcb);

	globalTesterWizPtr->xcb.command = HDLC_READ_MODEM_STATUS;//0x0C
	globalTesterWizPtr->xcb.buffer_length = 0;
	globalTesterWizPtr->xcb.logical_channel = 0;	// for supervisor display
	globalTesterWizPtr->X25_DoCommand();

  memcpy(&cb, &globalTesterWizPtr->xcb, sizeof(cb));

	if (!globalTesterWizPtr->CompCB(&lastcb, &cb))
	{
		if (cb.return_code == 0)
		{
			globalTesterWizPtr->SaveCB(&lastcb, &cb);
			(cb.data[0] & 0x08) ?
					label_DCD->setText(tr("High")) : label_DCD->setText(tr("Low"));

			(cb.data[0] & 0x20) ?
					label_CTS->setText(tr("High")) : label_CTS->setText(tr("Low"));
		}
	}

}

void ModemStatus_Impl::showEvent(QShowEvent * ev)
{
  set_widget_position_on_screen(this);
}

void ModemStatus_Impl::on_Close_clicked()
{
	close();
}

void ModemStatus_Impl::closeEvent(QCloseEvent * e)
{
  globalTesterWizPtr->x25_menu_hdlc_monitor->
    setItemChecked (globalTesterWizPtr->x25_menu_hdlc_monitor->idAt(3), FALSE );
	e->accept();
}
