/***************************************************************************
SetFrConfigImpl.cpp  -  description
-------------------
begin                : Mon Sep 24 2001
copyright            : (C) 2001 by DavidR
email                : drokhvarg@sangoma.com
***************************************************************************/

/***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
***************************************************************************/

#include "MainWizardImpl.h"

#define DBG_SET_FR_CFG 0

#include "TesterDefines.h"
#include "SetFrConfigImpl.h"

#include <qcheckbox.h>

////////////////////////////////////////////////////////////////////////////
/*
typedef struct _FRAME_RELAY_CONFIG {
	USHORT Station;
	USHORT ConfigBits;
	USHORT BaudRateKbps;
	USHORT ClockingInterface;
	USHORT MaxIFrameLength;
	USHORT T391;
	USHORT T392;
	USHORT N391;
	USHORT N392;
	USHORT N393;
	USHORT CIRfwd;
	USHORT Bcfwd;
	USHORT Befwd;
	USHORT CIRbwd;
	USHORT Bcbwd;
	USHORT Bebwd;
	USHORT DLCI[1];
} FRAME_RELAY_CONFIG, *PFRAME_RELAY_CONFIG;
*/
FRAME_RELAY_CONFIG cfg = {
	0, 0x8001, 8, 0, 2048, 5, 6, 2,
	3, 4, 4, 4, 0, 4, 4, 0, { 0 }
};


/////////////////////////////////////////////////////////////////////////////
SetFrConfigImpl::SetFrConfigImpl(QWidget* parent,
								 const char* name,
								 bool modal, WFlags fl ):SET_FR_CONFIG(parent,
								 name,
								 modal,
								 fl)
{
	memcpy(&m_fr_cfg, &cfg, sizeof(FRAME_RELAY_CONFIG));
	ok = false;
	set_widget_caption(this);
}

void SetFrConfigImpl::setDefaultFrCfgValues()
{
	//Card number may be passed as command line argument.
	//If so, update configuration structure.
	
	memset(configured_dlcis, 0x00, sizeof(configured_dlcis));
	
	if(app_command_line_empty == FALSE)
	{	
		if(card_number == CARD_DCE)
		{	//card 0 will be configured as Access Node
			m_fr_cfg.Station = 1;
			
			//add DLCIs 16 AND 17 to the list
			configured_dlcis[0] = 16;
			configured_dlcis[1] = 17;
			
			/*
			#if defined(_DEBUG)
			//clocking internal, RS232
			m_fr_cfg.ClockingInterface = 0x03;
			#else
			*/
			//clocking internal, V.35
			m_fr_cfg.ClockingInterface = 0x01;
			//#endif
		}else if(card_number == CARD_DTE)
		{	//card 1 will be configured as CPE
			m_fr_cfg.Station = 0;
			
			//add DLCI 16
			configured_dlcis[0] = 16;
			/*
			#if defined(_DEBUG)
			//clocking external, RS232
			m_fr_cfg.ClockingInterface = 0x02;
			#else
			*/
			//clocking external, V.35
			m_fr_cfg.ClockingInterface = 0x00;
			//#endif
		}
	}
}

SetFrConfigImpl::~SetFrConfigImpl()
{
}


void SetFrConfigImpl::OnOkClicked()
{
	DbgPrint1(DBG_SET_FR_CFG, "SetFrConfigImpl::OnOkClicked()\n" );
	//	char s[100];
	unsigned short i_temp;
	bool ok;
	
	//copy values from structure to visual controls
	// station config
	if(rb_AccessNode->isChecked() == true)
	{ m_fr_cfg.Station = 1;
	}else
	{ m_fr_cfg.Station = 0;
	}
	
	// ConfigBits
	m_fr_cfg.ConfigBits = 0x00;
	
	if(chk_Restrict_Tx_data_rate_500->isChecked() == true)
		m_fr_cfg.ConfigBits &= (~BIT0_SET);
	else
		m_fr_cfg.ConfigBits |= BIT0_SET;
	
	if(chk_CIR_checking_on_incoming_frames_501->isChecked() == false)
		m_fr_cfg.ConfigBits &= (~BIT1_SET);
	else
		m_fr_cfg.ConfigBits |= BIT1_SET;
	
	if(chk_Reject_Write_if_Be_Bc_exceeded_503->isChecked() == true)
		m_fr_cfg.ConfigBits &= (~BIT3_SET);
	else
		m_fr_cfg.ConfigBits |= BIT3_SET;
	
	if(chk_Calculate_throughput_504->isChecked() == false)
		m_fr_cfg.ConfigBits &= (~BIT4_SET);
	else
		m_fr_cfg.ConfigBits |= BIT4_SET;
	
	
	if(chk_No_exception_rcodes_on_send_505->isChecked() == false)
		m_fr_cfg.ConfigBits &= (~BIT5_SET);
	else
		m_fr_cfg.ConfigBits |= BIT5_SET;
	
	
	if(chk_Connected_to_MCI_508->isChecked() == false)
		m_fr_cfg.ConfigBits &= (~BIT8_SET);
	else
		m_fr_cfg.ConfigBits |= BIT8_SET;
	
	
	if(rb_Q933_Signalling_509->isChecked() == true)
		m_fr_cfg.ConfigBits |= BIT9_SET;
	else if(rb_LMI_Signalling_510->isChecked() == true)
		m_fr_cfg.ConfigBits |= BIT10_SET;
	else if(rb_No_inchannel_signalling_511->isChecked() == true)
		m_fr_cfg.ConfigBits |= BIT11_SET;
	else if(rb_AnnexD_T1_507->isChecked() == true)
	{  //if none of these bits is set the signalling is ANSI
	}
	
	if(rb_50_Tx_50_Rx_buffer_ratio->isChecked() == true)
	{ m_fr_cfg.ConfigBits &= (~BIT13_SET);
    m_fr_cfg.ConfigBits &= (~BIT14_SET);
	}else if(rb_70_Tx_30_Rx_buffer_ratio->isChecked() == true)
	{ m_fr_cfg.ConfigBits |= BIT13_SET;
    m_fr_cfg.ConfigBits &= (~BIT14_SET);
	}else if(rb_30_Tx_70_Rx_buffer_ratio->isChecked() == true)
	{ m_fr_cfg.ConfigBits |= BIT13_SET;
    m_fr_cfg.ConfigBits |= BIT14_SET;
	}
	
	if(chk_AutoConfigDLCI_CPE->isChecked() == true)
		m_fr_cfg.ConfigBits |= BIT15_SET;
	
	////////////////////////////////////
	i_temp = get_edit_box_value(BaudRate_304, &ok);
	if(ok == false || i_temp < 0 || i_temp > 1540)
	{ QMessageBox::warning(	0, "Invalid Configuration Parameter", "Baud Rate should be between 0 an 1540 kbps.");
    return;
	}else
		m_fr_cfg.BaudRateKbps = i_temp;
	////////////////////////////////////
	i_temp = get_edit_box_value(edit_Max_I_frame_size_308, &ok);
	if(ok == false || i_temp < 300 || i_temp > 2048)
	{ QMessageBox::warning(	0, "Invalid Configuration Parameter", "Maximum Frame Size should be between 300 an 2048.");
    return;
	}else
		m_fr_cfg.MaxIFrameLength = i_temp;
	////////////////////////////////////
	i_temp = get_edit_box_value(edit_CIR_Forward_320, &ok);
	if(ok == false || i_temp < 1 || i_temp > 512)
	{ QMessageBox::warning(	0, "Invalid Configuration Parameter", "CIR forward should be between 1 an 512.");
    return;
	}else
		m_fr_cfg.CIRfwd = i_temp;
	////////////////////////////////////
	i_temp = get_edit_box_value(edit_CIR_backward_326, &ok);
	if(ok == false || i_temp < 1 || i_temp > 512)
	{ QMessageBox::warning(	0, "Invalid Configuration Parameter", "CIR backward should be between 1 an 512.");
    return;
	}else
		m_fr_cfg.CIRbwd = i_temp;
	////////////////////////////////////
	i_temp = get_edit_box_value(edit_Bc_forward_322, &ok);
	if(ok == false || i_temp < 1 || i_temp > 512)
	{ QMessageBox::warning(	0, "Invalid Configuration Parameter", "Bc forward should be between 1 an 512.");
    return;
	}else
		m_fr_cfg.Bcfwd = i_temp;
	////////////////////////////////////
	i_temp = get_edit_box_value(edit_Bc_backward_328, &ok);
	if(ok == false || i_temp < 1 || i_temp > 512)
	{ QMessageBox::warning(	0, "Invalid Configuration Parameter", "Bc backward should be between 1 an 512.");
    return;
	}else
		m_fr_cfg.Bcbwd = i_temp;
	////////////////////////////////////
	i_temp = get_edit_box_value(edit_Be_forward_324, &ok);
	if(ok == false || i_temp < 0 || i_temp > 511)
	{ QMessageBox::warning(	0, "Invalid Configuration Parameter", "Be forward should be between 0 an 511");
    return;
	}else
		m_fr_cfg.Befwd = i_temp;
	////////////////////////////////////
	i_temp = get_edit_box_value(edit_Be_backward_330, &ok);
	if(ok == false || i_temp < 0 || i_temp > 511)
	{ QMessageBox::warning(	0, "Invalid Configuration Parameter", "Be backward should be between 0 an 511.");
    return;
	}else
		m_fr_cfg.Bebwd = i_temp;
	////////////////////////////////////
	i_temp = get_edit_box_value(edit_T391_310, &ok);
	if(ok == false || i_temp < 5 || i_temp > 30)
	{ QMessageBox::warning(	0, "Invalid Configuration Parameter", "T391 should be between 5 an 30.");
    return;
	}else
		m_fr_cfg.T391 = i_temp;
	////////////////////////////////////
	i_temp = get_edit_box_value(edit_N391_314, &ok);
	if(ok == false || i_temp < 1 || i_temp > 255)
	{ QMessageBox::warning(	0, "Invalid Configuration Parameter", "N391 should be between 1 an 255.");
    return;
	}else
		m_fr_cfg.N391 = i_temp;
	////////////////////////////////////
	i_temp = get_edit_box_value(edit_T392_312, &ok);
	if(ok == false || i_temp < 5 || i_temp > 30)
	{ QMessageBox::warning(	0, "Invalid Configuration Parameter", "T392 should be between 5 an 30.");
    return;
	}else
		m_fr_cfg.T392 = i_temp;
	////////////////////////////////////
	i_temp = get_edit_box_value(edit_N392_316, &ok);
	if(ok == false || i_temp < 1 || i_temp > 10)
	{ QMessageBox::warning(	0, "Invalid Configuration Parameter", "N392 should be between 1 an 10.");
    return;
	}else
		m_fr_cfg.N392 = i_temp;
	////////////////////////////////////
	i_temp = get_edit_box_value(edit_N393_318, &ok);
	if(ok == false || i_temp < 1 || i_temp > 10)
	{ QMessageBox::warning(	0, "Invalid Configuration Parameter", "N393 should be between 1 an 10.");
    return;
	}else
		m_fr_cfg.N393 = i_temp;
	////////////////////////////////////
	
	// clocking and Electrical interface
	if(RB_Internal_307->isChecked() == true)
		m_fr_cfg.ClockingInterface |= 0x01;
	else
		m_fr_cfg.ClockingInterface &= (~0x01);
	
	if(RB_External_306->isChecked() == false)
		m_fr_cfg.ClockingInterface |= 0x01;
	else
		m_fr_cfg.ClockingInterface &= (~0x01);
	
	//RS232 check box
	if(RS232_309->isChecked() == true)
		m_fr_cfg.ClockingInterface |= 0x02;
	else
		m_fr_cfg.ClockingInterface &= (~0x02);
	
	//V.35 check box
	if(RB_V35_311->isChecked() == false)
		m_fr_cfg.ClockingInterface |= 0x02;
	else
		m_fr_cfg.ClockingInterface &= (~0x02);
	
	
	//list of DLCIs alredy done
	
	done(0);
}

void SetFrConfigImpl::OnCancelClicked()
{
    DbgPrint1(DBG_SET_FR_CFG, "SetFrConfigImpl::OnCancelClicked()\n");
    done(1);
}

void SetFrConfigImpl::closeEvent(QCloseEvent * e)
{
	DbgPrint1(DBG_SET_FR_CFG, "SetFrConfigImpl::closeEvent\n");
	setResult(1);
	e->accept();
}

void SetFrConfigImpl::showEvent(QShowEvent * e)
{
	DbgPrint1(DBG_SET_FR_CFG, "SetFrConfigImpl::showEvent\n");
	char s[100];
	
	set_widget_position_on_screen(this);
	
	//copy values from structure to visual controls
	// station config
	if(m_fr_cfg.Station)
	{ rb_AccessNode->setChecked(true);
    rb_CPE->setChecked(false);
	}else
	{ rb_AccessNode->setChecked(false);
    rb_CPE->setChecked(true);
	}
	
	// ConfigBits
	chk_Restrict_Tx_data_rate_500->
		setChecked(((m_fr_cfg.ConfigBits & BIT0_SET) == 0) ? true : false);
	
	chk_CIR_checking_on_incoming_frames_501->
		setChecked(((m_fr_cfg.ConfigBits & BIT1_SET) == 0) ? false : true);
	
	chk_Reject_Write_if_Be_Bc_exceeded_503->
		setChecked(((m_fr_cfg.ConfigBits & BIT3_SET) == 0) ? true : false);
	
	chk_Calculate_throughput_504->
		setChecked(((m_fr_cfg.ConfigBits & BIT4_SET) == 0) ? false : true);
	
	chk_No_exception_rcodes_on_send_505->
		setChecked(((m_fr_cfg.ConfigBits & BIT5_SET) == 0) ? false : true);
	
	chk_Connected_to_MCI_508->
		setChecked(((m_fr_cfg.ConfigBits & BIT8_SET) == 0) ? false : true);
	
	if(m_fr_cfg.ConfigBits & BIT9_SET)
	{ rb_Q933_Signalling_509->setChecked(true);
	}else if(m_fr_cfg.ConfigBits & BIT10_SET)
	{ rb_LMI_Signalling_510->setChecked(true);
	}else if(m_fr_cfg.ConfigBits & BIT11_SET)
	{ rb_No_inchannel_signalling_511->setChecked(true);
	}else//if none of these bits is set the signalling is ANSI
		rb_AnnexD_T1_507->setChecked(true);
	
	if(!(m_fr_cfg.ConfigBits & BIT13_SET) && !(m_fr_cfg.ConfigBits & BIT14_SET))
	{ rb_50_Tx_50_Rx_buffer_ratio->setChecked(true);
	}else if((m_fr_cfg.ConfigBits & BIT13_SET) && !(m_fr_cfg.ConfigBits & BIT14_SET))
	{ rb_70_Tx_30_Rx_buffer_ratio->setChecked(true);
	}else if(!(m_fr_cfg.ConfigBits & BIT13_SET) && (m_fr_cfg.ConfigBits & BIT14_SET))
	{ rb_30_Tx_70_Rx_buffer_ratio->setChecked(true);
	}
	
	chk_AutoConfigDLCI_CPE->setChecked(!(m_fr_cfg.ConfigBits & BIT15_SET) ? false : true);
	
	sprintf(s, "%d", m_fr_cfg.BaudRateKbps);
	QString BaudRateKbps(s);
	BaudRate_304->setText(BaudRateKbps);
	
	sprintf(s, "%d", m_fr_cfg.MaxIFrameLength);
	QString MaxIFrameLength(s);
	edit_Max_I_frame_size_308->setText(MaxIFrameLength);
	
	sprintf(s, "%d", m_fr_cfg.CIRfwd);
	QString CIRfwd(s);
	edit_CIR_Forward_320->setText(CIRfwd);
	
	sprintf(s, "%d", m_fr_cfg.CIRbwd);
	QString CIRbwd(s);
	edit_CIR_backward_326->setText(CIRbwd);
	
	sprintf(s, "%d", m_fr_cfg.Bcfwd);
	QString Bcfwd(s);
	edit_Bc_forward_322->setText(Bcfwd);
	
	sprintf(s, "%d", m_fr_cfg.Bcbwd);
	QString Bcbwd(s);
	edit_Bc_backward_328->setText(Bcbwd);
	
	sprintf(s, "%d", m_fr_cfg.Befwd);
	QString Befwd(s);
	edit_Be_forward_324->setText(Befwd);
	
	sprintf(s, "%d", m_fr_cfg.Bebwd);
	QString Bebwd(s);
	edit_Be_backward_330->setText(Bebwd);
	
	
	sprintf(s, "%d", m_fr_cfg.T391);
	QString T391(s);
	edit_T391_310->setText(T391);
	
	sprintf(s, "%d", m_fr_cfg.N391);
	QString N391(s);
	edit_N391_314->setText(N391);
	
	sprintf(s, "%d", m_fr_cfg.T392);
	QString T392(s);
	edit_T392_312->setText(T392);
	
	sprintf(s, "%d", m_fr_cfg.N392);
	QString N392(s);
	edit_N392_316->setText(N392);
	
	sprintf(s, "%d", m_fr_cfg.N393);
	QString N393(s);
	edit_N393_318->setText(N393);
	
	// clocking and Electrical interface
	RB_Internal_307->
		setChecked((m_fr_cfg.ClockingInterface & 0x01) ? true : false);
	RB_External_306->
		setChecked((m_fr_cfg.ClockingInterface & 0x01) ? false : true);
	RS232_309->
		setChecked((m_fr_cfg.ClockingInterface & 0x02) ? true : false);//RS232 check box
	RB_V35_311->
		setChecked((m_fr_cfg.ClockingInterface & 0x02) ? false : true);//V.35 check box
	
	//list of DLCIs
	ListBox_DLCI_List_150->clear();
	
	int i=0;
	while (configured_dlcis[i] != 0)
	{	sprintf(s, "%u", configured_dlcis[i]);
    ADDSTR(ListBox_DLCI_List_150, s);
	i++;
	}
}

/*
QLineEdit* edit_DLCIs_151;
QPushButton* btn_AddDlci;
QPushButton* btn_RemoveDlci;
QListBox* ListBox_DLCI_List_150;

  QPushButton* PushButton38;
  */
  void SetFrConfigImpl::btn_AddDlci_clicked()
  {
	  DbgPrint1(DBG_SET_FR_CFG, "SetFrConfigImpl::btn_AddDlci_clicked()\n");
	  
	  s_tmp = edit_DLCIs_151->text();
	  int i = s_tmp.toUShort(&ok, 10);
	  
	  
	  if ((WORD)i > 991 || (WORD)i < 16)
	  {	QMessageBox::warning(	0, "Invalid DLCI", "DLCIs must be in the range 16 to 991.");
	  return;
	  }
	  
	  switch(adddlci((WORD)i))
	  {
	  case 1:
		  sprintf(s, "%u", (WORD)i);
		  ADDSTR(ListBox_DLCI_List_150, s);
		  break;
	  case 0:
		  sprintf(s, "There is a maximum of %u DLCIs that may be configured.", MAX_DLCIS);
		  QMessageBox::warning(	0, "Too Many DLCIs", s);
		  break;
	  case 2:
		  QMessageBox::warning(	0, "", "This DLCI already added.");
		  break;
	  }
  }
  
  
  int SetFrConfigImpl::adddlci(WORD dlci)
  {
	  int i;
	  i=0;
	  while (configured_dlcis[i] != 0 && configured_dlcis[i] != dlci) i++;
	  if (i < MAX_DLCIS) {
		  if (configured_dlcis[i] == dlci) return(2);	// already there
		  configured_dlcis[i] = dlci;
		  configured_dlcis[i+1] = 0;
		  return(1);
	  }
	  return(0);
  }
  
  void SetFrConfigImpl::OnRemoveClicked()
  {
	  s_tmp = ListBox_DLCI_List_150->text(ListBox_DLCI_List_150->currentItem());
	  int i = s_tmp.toUShort(&ok, 10);
	  
	  ListBox_DLCI_List_150->removeItem(ListBox_DLCI_List_150->currentItem());
	  deletedlci((WORD)i);
  }
  
  /** No descriptions */
  void SetFrConfigImpl::deletedlci(WORD dlci)
  {
	  int i, j;
	  i=0;
	  while (configured_dlcis[i] != dlci && configured_dlcis[i] != 0) i++;
	  if (configured_dlcis[i] == dlci) {
		  for (j=i; j < MAX_DLCIS-1; j++)
			  configured_dlcis[j] = configured_dlcis[j+1];
		  configured_dlcis[j] = 0;
	  }
  }

unsigned short get_edit_box_value(QLineEdit * ed, bool * ok)
{
	* ok = false;
	QString s_tmp;
	
	s_tmp = ed->text();
	return s_tmp.toUShort(ok, 10);
}

unsigned int get_int_hex_value_from_line_edit_box(QLineEdit * ed, bool * ok)
{
	* ok = false;
	QString s_tmp;
	
	s_tmp = ed->text();
	return s_tmp.toUInt(ok, 16);
}
