/***************************************************************************
                          TesterDefines.h  -  description
                             -------------------
    begin                : Thu Sep 5 2002
    copyright            : (C) 2002 by David Rokhvarg
    email                : drokhvarg@sangoma.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TESTER_DEFINES_H
#define TESTER_DEFINES_H

#define _DEBUG 1

//Debug macros
#if defined(_DEBUG)
  #define DbgPrint1(DBG, s1)                  if(DBG)   qDebug(s1);
  #define DbgPrint2(DBG, s1, s2)              if(DBG)   qDebug(s1, s2);
  #define DbgPrint3(DBG, s1, s2, s3)          if(DBG)   qDebug(s1, s2, s3);
  #define DbgPrint4(DBG, s1, s2, s3, s4)      if(DBG)   qDebug(s1, s2, s3, s4);
  #define DbgPrint5(DBG, s1, s2, s3, s4, s5)  if(DBG)   qDebug(s1, s2, s3, s4, s5);
#else
  #define DbgPrint1(DBG, s1)
  #define DbgPrint2(DBG, s1, s2)
  #define DbgPrint3(DBG, s1, s2, s3)
  #define DbgPrint4(DBG, s1, s2, s3, s4)
  #define DbgPrint5(DBG, s1, s2, s3, s4, s5)
#endif

/*
//Debug macros
//This version is nicer, but MS compilers won't like it. No problem for gcc.
#if defined(_DEBUG)
  #define DbgPrint(DBG, format, msg...)   if(DBG)   qDebug(format, ## msg)
#else
  #define DbgPrint(DBG, format, msg...)
#endif
*/


//
//bitmapping defines
//
#define BIT0_SET	0x0001
#define BIT1_SET	0x0002
#define BIT2_SET	0x0004
#define BIT3_SET	0x0008
#define BIT4_SET	0x0010
#define BIT5_SET	0x0020
#define BIT6_SET	0x0040
#define BIT7_SET	0x0080
#define BIT8_SET	0x0100
#define BIT9_SET	0x0200
#define BIT10_SET	0x0400
#define BIT11_SET	0x0800
#define BIT12_SET	0x1000
#define BIT13_SET	0x2000
#define BIT14_SET	0x4000
#define BIT15_SET	0x8000


#endif //TESTER_DEFINES_H
