/***************************************************************************
                          X25_CCITT_Facil_Impl.cpp  -  description
                             -------------------
    begin                : Wed Oct 10 2001
    copyright            : (C) 2001 by DavidR
    email                : drokhvarg@sangoma.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "MainWizardImpl.h"


X25_CCITT_Facil_Impl::X25_CCITT_Facil_Impl(
																	QWidget* parent,
																	const char* name,
																	bool modal, WFlags fl ):X25_CCITT_Facil(
																																		parent,
																																		name,
																																		modal,
																																		fl)
{
  set_widget_caption(this);
}

X25_CCITT_Facil_Impl::~X25_CCITT_Facil_Impl(){
}

void X25_CCITT_Facil_Impl::showEvent(QShowEvent * ev)
{
  set_widget_position_on_screen(this);

	//CCITT_facilities_supported
	if(global_x25cfg_struct->CCITT_facilities_supported & 0x0001)
		CCITT_BIT0->setChecked(true);

	if(global_x25cfg_struct->CCITT_facilities_supported & 0x0002)
		CCITT_BIT1->setChecked(true);

	if(global_x25cfg_struct->CCITT_facilities_supported & 0x0004)
		CCITT_BIT2->setChecked(true);

	if(global_x25cfg_struct->CCITT_facilities_supported & 0x0008)
		CCITT_BIT3->setChecked(true);

	if(global_x25cfg_struct->CCITT_facilities_supported & 0x0010)
		CCITT_BIT4->setChecked(true);

	if(global_x25cfg_struct->CCITT_facilities_supported & 0x0020)
		CCITT_BIT5->setChecked(true);

	if(global_x25cfg_struct->CCITT_facilities_supported & 0x0040)
		CCITT_BIT6->setChecked(true);

	//CCITT_compatibility
	switch(global_x25cfg_struct->CCITT_compatibility)
	{
	case 1980:	CCITT_1980->setChecked(true);	break;
	case 1984:	CCITT_1984->setChecked(true);	break;
	case 1988:	CCITT_1988->setChecked(true);	break;
	}
	
}

void X25_CCITT_Facil_Impl::on_Cancel_clicked()
{
	done(IDCANCEL);
}

void X25_CCITT_Facil_Impl::on_OK_clicked()
{
	//unset the first 7 bits and set the ones that checked.
	global_x25cfg_struct->CCITT_facilities_supported &= 0xff80;

	if(CCITT_BIT0->isChecked() == true)
		global_x25cfg_struct->CCITT_facilities_supported |= 0x0001;

	if(CCITT_BIT1->isChecked() == true)
		global_x25cfg_struct->CCITT_facilities_supported |= 0x0002;

	if(CCITT_BIT2->isChecked() == true)
		global_x25cfg_struct->CCITT_facilities_supported |= 0x0004;

	if(CCITT_BIT3->isChecked() == true)
		global_x25cfg_struct->CCITT_facilities_supported |= 0x0008;

	if(CCITT_BIT4->isChecked() == true)
		global_x25cfg_struct->CCITT_facilities_supported |= 0x0010;

	if(CCITT_BIT5->isChecked() == true)
		global_x25cfg_struct->CCITT_facilities_supported |= 0x0020;

	if(CCITT_BIT6->isChecked() == true)
		global_x25cfg_struct->CCITT_facilities_supported |= 0x0040;

	//check buttons
	if(CCITT_1980->isChecked() == true)	
		global_x25cfg_struct->CCITT_compatibility = 1980;
	if(CCITT_1984->isChecked() == true)	
		global_x25cfg_struct->CCITT_compatibility = 1984;
	if(CCITT_1988->isChecked() == true)	
		global_x25cfg_struct->CCITT_compatibility = 1988;

	done(IDOK);
}

