/***************************************************************************
                          X25_HDLC_FunctionsImpl.cpp  -  description
                             -------------------
    begin                : Fri Oct 5 2001
    copyright            : (C) 2001 by DavidR
    email                : drokhvarg@sangoma.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "MainWizardImpl.h"

extern TesterWizardImpl * globalTesterWizPtr;


X25_HDLC_FunctionsImpl::X25_HDLC_FunctionsImpl(
																	QWidget* parent,
																	const char* name,
																	bool modal, WFlags fl ):X25_HDLC_Functions(
																																		parent,
																																		name,
																																		modal,
																																		fl)
{
  set_widget_caption(this);
}

X25_HDLC_FunctionsImpl::~X25_HDLC_FunctionsImpl(){
}

void X25_HDLC_FunctionsImpl::showEvent(QShowEvent * ev)
{
  set_widget_position_on_screen(this);

	globalTesterWizPtr->xcb.buffer_length = 0;
	globalTesterWizPtr->xcb.logical_channel = 0;
}

void X25_HDLC_FunctionsImpl::on_exit_clicked()
{
	done(0);
}

void X25_HDLC_FunctionsImpl::on_close_link_clicked()
{
	globalTesterWizPtr->xcb.command = HDLC_CLOSE;
	DoIt();
}

void X25_HDLC_FunctionsImpl::on_dce_clicked()
{
	globalTesterWizPtr->xcb.command = CONFIGURE_LINK;
	globalTesterWizPtr->xcb.data[0] = 0x02;
	globalTesterWizPtr->xcb.buffer_length = 1;
	DoIt();
}

void X25_HDLC_FunctionsImpl::on_dte_clicked()
{
	globalTesterWizPtr->xcb.command = CONFIGURE_LINK;
	globalTesterWizPtr->xcb.data[0] = 0x01;
	globalTesterWizPtr->xcb.buffer_length = 1;
	DoIt();
}

void X25_HDLC_FunctionsImpl::on_dtr_hi_clicked()
{
	globalTesterWizPtr->xcb.command = SET_GLOBAL_VARIABLES;
	globalTesterWizPtr->xcb.data[0] = 0x00;
	globalTesterWizPtr->xcb.data[1] = 0x02;
	globalTesterWizPtr->xcb.data[2] = 0x00;
	globalTesterWizPtr->xcb.buffer_length = 3;
	DoIt();
}

void X25_HDLC_FunctionsImpl::on_dtr_lo_clicked()
{
	globalTesterWizPtr->xcb.command = SET_GLOBAL_VARIABLES;
	globalTesterWizPtr->xcb.data[0] = 0x00;
	globalTesterWizPtr->xcb.data[1] = 0x01;
	globalTesterWizPtr->xcb.data[2] = 0x00;
	globalTesterWizPtr->xcb.buffer_length = 3;
	DoIt();
}

void X25_HDLC_FunctionsImpl::on_link_disconnect_clicked()
{
	globalTesterWizPtr->xcb.command = LINK_DISCONNECT;
	DoIt();
}

void X25_HDLC_FunctionsImpl::on_link_setup_clicked()
{
	globalTesterWizPtr->xcb.command = LINK_SETUP;
	DoIt();
}

void X25_HDLC_FunctionsImpl::on_open_link_clicked()
{
	globalTesterWizPtr->xcb.command = HDLC_OPEN;
	DoIt();
}

void X25_HDLC_FunctionsImpl::DoIt()
{
	globalTesterWizPtr->X25_DoCommand();
	done(0);
}

