/***************************************************************************
                          X25_LogicalChannelCfg_Impl.cpp  -  description
                             -------------------
    begin                : Tue Oct 9 2001
    copyright            : (C) 2001 by DavidR
    email                : drokhvarg@sangoma.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "MainWizardImpl.h"

X25_LogicalChannelCfg_Impl::X25_LogicalChannelCfg_Impl(
																	QWidget* parent,
																	const char* name,
																	bool modal, WFlags fl ):X25_LogicalChannelCfg(
																																		parent,
																																		name,
																																		modal,
																																		fl)
{
  set_widget_caption(this);
}

X25_LogicalChannelCfg_Impl::~X25_LogicalChannelCfg_Impl(){
}

void X25_LogicalChannelCfg_Impl::showEvent(QShowEvent * ev)
{
	char s[100];

  set_widget_position_on_screen(this);

	//Set LCNs to values x25cfg_struct
	sprintf(s, "%d", global_x25cfg_struct->lowest_PVC);
	QString tmp_low_PVC(s);
	edit_lowest_PVC->setText(tmp_low_PVC);

	sprintf(s, "%d", global_x25cfg_struct->highest_PVC);
	QString tmp_high_PVC(s);
	edit_highest_PVC->setText(tmp_high_PVC);

	sprintf(s, "%d", global_x25cfg_struct->lowest_two_way_channel);
	QString tmp_two_way_low(s);
	edit_lowest_SVC->setText(tmp_two_way_low);

	sprintf(s, "%d", global_x25cfg_struct->highest_two_way_channel);
	QString tmp_two_way_hi(s);
	edit_highest_SVC->setText(tmp_two_way_hi);

}

void X25_LogicalChannelCfg_Impl::on_Cancel_clicked()
{
	done(1);
}

void X25_LogicalChannelCfg_Impl::on_OK_clicked()
{
	bool ok = false;
	int 		i_tmp;
	QString s_tmp;
	
	s_tmp = edit_lowest_PVC->text();
	i_tmp = s_tmp.toUShort(&ok, 10);
	global_x25cfg_struct->lowest_PVC = i_tmp;

	s_tmp = edit_highest_PVC->text();
	i_tmp = s_tmp.toUShort(&ok, 10);
	global_x25cfg_struct->highest_PVC = i_tmp;

	s_tmp = edit_lowest_SVC->text();
	i_tmp = s_tmp.toUShort(&ok, 10);
	global_x25cfg_struct->lowest_two_way_channel = i_tmp;

	s_tmp = edit_highest_SVC->text();
	i_tmp = s_tmp.toUShort(&ok, 10);
	global_x25cfg_struct->highest_two_way_channel = i_tmp;

	done(0);
}

