/***************************************************************************
                          X25_PacketCfg_Impl.cpp  -  description
                             -------------------
    begin                : Tue Oct 9 2001
    copyright            : (C) 2001 by DavidR
    email                : drokhvarg@sangoma.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "MainWizardImpl.h"

static const char * packet_size_list[] = {"16", "32", "64", "128",
																						"256", "512",	"1024",  0 };


X25_PacketCfg_Impl::X25_PacketCfg_Impl(
																	QWidget* parent,
																	const char* name,
																	bool modal, WFlags fl ):X25_PacketCfg(
																																		parent,
																																		name,
																																		modal,
																																		fl)
{
	default_packet_size_in_bytes->insertStrList(packet_size_list, 7, -1);
	maximum_packet_size_in_bytes->insertStrList(packet_size_list, 7, -1);
  set_widget_caption(this);
}

X25_PacketCfg_Impl::~X25_PacketCfg_Impl()
{

}

void X25_PacketCfg_Impl::showEvent(QShowEvent * ev)
{
	char s[100];
	short index = 0;

  set_widget_position_on_screen(this);

	//
	//Set to values in x25cfg_struct
	//
	sprintf(s, "%d", global_x25cfg_struct->packet_window);
	QString tmp(s);
	default_packet_window->setText(tmp);

	switch(global_x25cfg_struct->default_packet_size)
	{
	case 16: 		index = 0;	break;
	case 32: 		index = 1;  break;
	case 64: 		index = 2;  break;
	case 128: 	index = 3;  break;
	case 256: 	index = 4;  break;
	case 512: 	index = 5;  break;
	case 1024: 	index = 6;  break;
	}
	default_packet_size_in_bytes->setCurrentItem(index);

	switch(global_x25cfg_struct->maximum_packet_size)
	{
	case 16: 		index = 0;	break;
	case 32: 		index = 1;  break;
	case 64: 		index = 2;  break;
	case 128: 	index = 3;  break;
	case 256: 	index = 4;  break;
	case 512: 	index = 5;  break;
	case 1024: 	index = 6;  break;
	}
	maximum_packet_size_in_bytes->setCurrentItem(index);
	
}

void X25_PacketCfg_Impl::on_Cancel_clicked()
{
	done(IDCANCEL);
}

void X25_PacketCfg_Impl::on_OK_clicked()
{
	bool ok = false;
	int 		i_tmp;
	QString s_tmp;
	
	s_tmp = default_packet_window->text();
	i_tmp = s_tmp.toUShort(&ok, 10);
	global_x25cfg_struct->packet_window = i_tmp;

	switch(default_packet_size_in_bytes->currentItem())
	{
	case 0:		i_tmp = 16;	break;
	case 1:		i_tmp = 32;  break;
	case 2:		i_tmp = 64;  break;
	case 3: 	i_tmp = 128;  break;
	case 4: 	i_tmp = 256;  break;
	case 5: 	i_tmp = 512;  break;
	case 6: 	i_tmp = 1024;  break;
	}
	global_x25cfg_struct->default_packet_size = i_tmp;

	switch(maximum_packet_size_in_bytes->currentItem())
	{
	case 0:		i_tmp = 16;	break;
	case 1:		i_tmp = 32;  break;
	case 2:		i_tmp = 64;  break;
	case 3: 	i_tmp = 128;  break;
	case 4: 	i_tmp = 256;  break;
	case 5: 	i_tmp = 512;  break;
	case 6: 	i_tmp = 1024;  break;
	}
	global_x25cfg_struct->maximum_packet_size = i_tmp;

/*
	printf("on_OK_clicked():default_packet_size : %d\n",
														global_x25cfg_struct->default_packet_size );

	printf("on_OK_clicked():maximum_packet_size : %d\n",
														global_x25cfg_struct->maximum_packet_size);
*/

	done(IDOK);
}

