/***************************************************************************
                          X25_Stats_Impl.cpp  -  description
                             -------------------
    begin                : Tue Oct 16 2001
    copyright            : (C) 2001 by DavidR
    email                : drokhvarg@sangoma.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "MainWizardImpl.h"

extern TesterWizardImpl * globalTesterWizPtr;

#define NUM_X25_STATS_ITEMS	32

X25_Stats_Impl::X25_Stats_Impl( QWidget* parent,
																const char* name,
																WFlags fl):X25_Stats(parent, name, fl)
{
  set_widget_caption(this);

	//RX
	x25_stats_data[0] = T0;
	x25_stats_data[1] = T1;
	x25_stats_data[2] = T2;
	x25_stats_data[3] = T3;

	x25_stats_data[4] = T4;
	x25_stats_data[5] = T5;
	x25_stats_data[6] = T6;
	x25_stats_data[7] = T7;

	x25_stats_data[8] = T8;
	x25_stats_data[9] = T9;
	x25_stats_data[10] = T10;
	x25_stats_data[11] = T11;

	x25_stats_data[12] = T12;
	x25_stats_data[13] = T13;
	x25_stats_data[14] = T14;
	x25_stats_data[15] = T15;

	//TX
	x25_stats_data[16] = T16;
	x25_stats_data[17] = T17;
	x25_stats_data[18] = T18;
	x25_stats_data[19] = T19;

	x25_stats_data[20] = T20;
	x25_stats_data[21] = T21;
	x25_stats_data[22] = T22;
	x25_stats_data[23] = T23;

	x25_stats_data[24] = T24;
	x25_stats_data[25] = T25;
	x25_stats_data[26] = T26;
	x25_stats_data[27] = T27;

	x25_stats_data[28] = T28;
	x25_stats_data[29] = T29;
	x25_stats_data[30] = T30;
	x25_stats_data[31] = T31;
}

X25_Stats_Impl::~X25_Stats_Impl(){
}


void X25_Stats_Impl::on_Close_clicked()
{
	close();
}

void X25_Stats_Impl::showEvent(QShowEvent * ev)
{
  set_widget_position_on_screen(this);
}

void X25_Stats_Impl::closeEvent(QCloseEvent * e)
{
  globalTesterWizPtr->x25_menu_monitor->
    setItemChecked (globalTesterWizPtr->x25_menu_monitor->idAt(0), FALSE );
	e->accept();
}

void X25_Stats_Impl::on_Flush_clicked()
{
	globalTesterWizPtr->xcb.command = X25_FLUSH_X25_STATISTICS;
	globalTesterWizPtr->xcb.buffer_length = 0;
  globalTesterWizPtr->xcb.logical_channel = 0;
  globalTesterWizPtr->wait_for_poll_to_finish(X25_FLUSH_X25_STATISTICS);
}

//this is over ride of QObject's timer function
void X25_Stats_Impl::timerEvent(QTimerEvent * e)
{
		globalTesterWizPtr->ResetCB(&cb);
		globalTesterWizPtr->xcb.command = X25_READ_X25_STATISTICS;
		globalTesterWizPtr->xcb.buffer_length = 0;
		globalTesterWizPtr->xcb.logical_channel = 0;	// for supervisor display
		globalTesterWizPtr->X25_DoCommand();

    memcpy(&cb, &globalTesterWizPtr->xcb, sizeof(cb));

		if (!globalTesterWizPtr->CompCB(&lastcb, &cb))
		{
			if (cb.return_code == 0)
			{
				globalTesterWizPtr->SaveCB(&lastcb, &cb);
				/* x25_stats_data[] is the array of ptrs to TextLabels */
				for (int c = 0; c < NUM_X25_STATS_ITEMS; c++)
				{
					//SetDlgItemInt(hDlg, 200+c, GetDUI((BYTE *)(cb.data+(c*2))), FALSE);
					sprintf(tmp, "%d", globalTesterWizPtr->GetDUI((BYTE *)(cb.data+(c*2))) );
					x25_stats_data[c]->setText(tmp);
				}
			}
		}
}

