/***************************************************************************
                          X25_Timers_Impl.cpp  -  description
                             -------------------
    begin                : Wed Oct 10 2001
    copyright            : (C) 2001 by DavidR
    email                : drokhvarg@sangoma.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "MainWizardImpl.h"

X25_Timers_Impl::X25_Timers_Impl(
																	QWidget* parent,
																	const char* name,
																	bool modal, WFlags fl ):X25_Timers(
																																		parent,
																																		name,
																																		modal,
																																		fl)
{
  set_widget_caption(this);
}


X25_Timers_Impl::~X25_Timers_Impl(){
}

void X25_Timers_Impl::showEvent(QShowEvent * ev)
{
  set_widget_position_on_screen(this);

	//Set to values x25cfg_struct
	set_edit_box_value(TC_T10, global_x25cfg_struct->T10_T20);
	set_edit_box_value(TC_T11, global_x25cfg_struct->T11_T21);
	set_edit_box_value(TC_T12, global_x25cfg_struct->T12_T22);

	set_edit_box_value(TC_T13, global_x25cfg_struct->T13_T23);
	set_edit_box_value(TC_T16, global_x25cfg_struct->T16_T26);
	set_edit_box_value(TC_T28, global_x25cfg_struct->T28);

	set_edit_box_value(TC_R10, global_x25cfg_struct->R10_R20);
	set_edit_box_value(TC_R12, global_x25cfg_struct->R12_R22);
	set_edit_box_value(TC_R13, global_x25cfg_struct->R13_R23);
}


void X25_Timers_Impl::on_OK_clicked()
{
	global_x25cfg_struct->T10_T20 = get_edit_box_value(TC_T10);
	global_x25cfg_struct->T11_T21 = get_edit_box_value(TC_T11);
	global_x25cfg_struct->T12_T22 = get_edit_box_value(TC_T12);

	global_x25cfg_struct->T13_T23 = get_edit_box_value(TC_T13);
	global_x25cfg_struct->T16_T26 = get_edit_box_value(TC_T16);
	global_x25cfg_struct->T28 = get_edit_box_value(TC_T28);

	global_x25cfg_struct->R10_R20 = get_edit_box_value(TC_R10);
	global_x25cfg_struct->R12_R22 = get_edit_box_value(TC_R12);
	global_x25cfg_struct->R13_R23 = get_edit_box_value(TC_R13);

	done(IDOK);

}

void X25_Timers_Impl::on_Cancel_clicked()
{
	done(IDCANCEL);
}

void X25_Timers_Impl::set_edit_box_value(QLineEdit * ed, int value)
{
	char s[100];

	sprintf(s, "%d", value);
	QString tmp(s);
	ed->setText(tmp);
}

unsigned short X25_Timers_Impl::get_edit_box_value(QLineEdit * ed)
{
	bool ok = false;
	QString s_tmp;

	
	s_tmp = ed->text();
	return s_tmp.toUShort(&ok, 10);
}
