#ifndef API_MACROS_H
#define API_MACROS_H

///////////////////////////////////////////////////////////////////////////////
//macro definitions common for Windows and UNIX

///////////////////////////////////////////////////////////////////////////////
//Frame Relay API
#define FAPISETUP(a)				fapi_obj.API_BASE_Setup(a)

#define FAPICLEANUP()				fapi_obj.API_BASE_Cleanup()

#define FAPIGETCARDS()				fapi_obj.API_BASE_GetCards()

#define FAPIREGISTERCARD(a)			fapi_obj.API_BASE_RegisterCard(a)

#define FAPIDEREGISTERCARD(a)		fapi_obj.API_BASE_DeregisterCard(a)

#define FAPIPREPAREFORLOADING(a)	fapi_obj.API_BASE_PrepareForLoading(a)

#define FAPILOADFIRMWARE(a, b)		fapi_obj.API_BASE_LoadFirmware(a, b)

#define FAPILOADCOMPLETE(a)			fapi_obj.API_BASE_LoadComplete(a)

#define FAPICONTROL(a, b)			fapi_obj.FAPIControl(&fcb)

///////////////////////////////////////////////////////////////////////////////
//X.25 API
#define XAPISETUP(a)				xapi_obj.API_BASE_Setup(a)

#define XAPICLEANUP()				xapi_obj.API_BASE_Cleanup()

#define XAPIGETCARDS()				xapi_obj.API_BASE_GetCards()

#define XAPIREGISTERCARD(a)			xapi_obj.API_BASE_RegisterCard(a);

#define XAPIDEREGISTERCARD(a)		xapi_obj.API_BASE_DeregisterCard(a)

#define XAPIPREPAREFORLOADING(a)	xapi_obj.API_BASE_PrepareForLoading(a)

#define XAPILOADFIRMWARE(a, b)		xapi_obj.API_BASE_LoadFirmware(a, b)

#define XAPILOADCOMPLETE(a)			xapi_obj.API_BASE_LoadComplete(a)

#define XAPICONTROL(a, b)			xapi_obj.XAPIControl(&xcb)

#define XAPIQNOTIFICATION(a)		xapi_obj.XAPIqNotification()

#define XAPIQLINKINABM(a)			xapi_obj.XAPIqLinkInABM()

#define XAPIQDATATOREAD(a, b)		xapi_obj.XAPIqDataToRead(b)

///////////////////////////////////////////////////////////////////////////////
//ATM API
#define ATMAPISETUP(a)				atm_api_obj.API_BASE_Setup(a)

#define ATMAPICLEANUP()				atm_api_obj.API_BASE_Cleanup()

#define ATMAPIGETCARDS()			atm_api_obj.API_BASE_GetCards()

#define ATMAPIREGISTERCARD(a)		atm_api_obj.API_BASE_RegisterCard(a)

#define ATMAPIDEREGISTERCARD(a)		atm_api_obj.API_BASE_DeregisterCard(a)

#define ATMAPIPREPAREFORLOADING(a)	atm_api_obj.API_BASE_PrepareForLoading(a)

#define ATMAPILOADFIRMWARE(a, b)	atm_api_obj.API_BASE_LoadFirmware(a, b)

#define	ATMAPILOADCOMPLETE(a)		atm_api_obj.API_BASE_LoadComplete(a)

#define ATMAPICONTROL(a, b)			atm_api_obj.ATMAPIControl(a, b)

#endif //API_MACROS_H
