// atm_add_vpi_vci_impl.cpp: implementation of the atm_add_vpi_vci_impl class.
//
//////////////////////////////////////////////////////////////////////

#include "TesterDefines.h"					//debug macros

#include "MainWizardImpl.h"		//for declarations of global functions

#define DBG_ATM_ADD_VPI_VCI 1

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

atm_add_vpi_vci_impl::atm_add_vpi_vci_impl(
									QWidget* parent,
									const char* name,
									bool modal, WFlags fl
									):atm_add_vpi_vci(
														parent,
														name,
														modal,
														fl)
{
	GFC_VPI = 0;
	VCI = 35;

	add_pvc_struct.VC_options = 0x0000;
	add_pvc_struct.OAM_CC_Tx_timer = 500;//100;
	add_pvc_struct.OAM_CC_Rx_timer = 550;//150;
	add_pvc_struct.OAM_CC_Rx_timeout_counter = 3;
	add_pvc_struct.OAM_Loopback_Tx_timer = 00;
	add_pvc_struct.OAM_Loopback_Rx_timeout = 50;
	add_pvc_struct.OAM_Loopback_Rx_timeout_counter = 2;

	add_pvc_struct.OAM_AIS_Tx_timer = 100;
	add_pvc_struct.OAM_AIS_state_Rx_timeout = 300;
}

atm_add_vpi_vci_impl::~atm_add_vpi_vci_impl()
{

}

void atm_add_vpi_vci_impl::closeEvent(QCloseEvent * e)
{
	setResult(1);
	e->accept();
}

void atm_add_vpi_vci_impl::showEvent(QShowEvent * e)
{
	set_widget_position_on_screen(this);

	//
	// copy values from cfg structure to visual controls
	//
	//
	//
	qsr_tmp.sprintf("%u", GFC_VPI);
	lineEdit_VPI->setText(qsr_tmp);

	qsr_tmp.sprintf("%u", VCI);
	lineEdit_VCI->setText(qsr_tmp);

	if(add_pvc_struct.VC_options & VC_OPT_STATE_INDEP_CONT_CHECK)
	{	checkBox_VC_OPT_STATE_INDEP_CONT_CHECK->setChecked(true);
	}else
	{	checkBox_VC_OPT_STATE_INDEP_CONT_CHECK->setChecked(false);
	}

	if(add_pvc_struct.VC_options & VC_OPT_STATE_INDEP_LPBK_RESP)
	{	checkBox_VC_OPT_STATE_INDEP_LPBK_RESP->setChecked(true);
	}else
	{	checkBox_VC_OPT_STATE_INDEP_LPBK_RESP->setChecked(false);
	}

	qsr_tmp.sprintf("%u", add_pvc_struct.OAM_CC_Tx_timer);
	lineEdit_OAM_CC_Tx_timer->setText(qsr_tmp);

	qsr_tmp.sprintf("%u", add_pvc_struct.OAM_CC_Rx_timer);
	lineEdit_OAM_CC_Rx_timer->setText(qsr_tmp);

	qsr_tmp.sprintf("%u", add_pvc_struct.OAM_CC_Rx_timeout_counter);
	lineEdit_OAM_CC_Rx_timeout_counter->setText(qsr_tmp);

	qsr_tmp.sprintf("%u", add_pvc_struct.OAM_Loopback_Tx_timer);
	lineEdit_OAM_Loopback_Tx_timer->setText(qsr_tmp);

	qsr_tmp.sprintf("%u", add_pvc_struct.OAM_Loopback_Rx_timeout);
	lineEdit_OAM_Loopback_Rx_timeout->setText(qsr_tmp);

	qsr_tmp.sprintf("%u", add_pvc_struct.OAM_Loopback_Rx_timeout_counter);
	lineEdit_OAM_Loopback_Rx_timeout_counter->setText(qsr_tmp);

	qsr_tmp.sprintf("%u", add_pvc_struct.OAM_AIS_Tx_timer);
	lineEdit_OAM_AIS_Tx_timer->setText(qsr_tmp);

	qsr_tmp.sprintf("%u", add_pvc_struct.OAM_AIS_state_Rx_timeout);
	lineEdit_OAM_AIS_state_Rx_timeout->setText(qsr_tmp);
}

void atm_add_vpi_vci_impl::OnOkClicked()
{
	ATMAL_ADD_PVC_STRUCT add_pvc_struct_back;
	unsigned short tmp_GFC_VPI;
	unsigned short tmp_VCI;

	unsigned short i_temp;
	bool ok;

	//create a backup copy and do all the temporary changes in it.
	//if all checks passed, copy the new configuration into
	//the real congig structure.
	memcpy(&add_pvc_struct_back, &add_pvc_struct, sizeof(ATMAL_ADD_PVC_STRUCT));

	//
	// copy values from visual controls to cfg structure
	//

	/////////////////////////////////////////////////////////////
	i_temp = (unsigned short)get_edit_box_value(lineEdit_VPI, &ok);

	if(	ok == false ||	i_temp < MIN_VPI_NUMBER || i_temp > MAX_VPI_NUMBER)
	{	
		qsr_tmp.sprintf("VPI number should be between %u and %u.",
			0,
			500
			);
		QMessageBox::warning(0,	"Invalid Configuration Parameter", qsr_tmp.latin1());
		return;
	}else
		tmp_GFC_VPI = i_temp;

	/////////////////////////////////////////////////////////////
	i_temp = (unsigned short)get_edit_box_value(lineEdit_VCI, &ok);

	if(	ok == false ||	i_temp < MIN_VCI_NUMBER || i_temp > MAX_VCI_NUMBER)
	{	
		qsr_tmp.sprintf("VCI number should be between %u and %u.",
			0,
			MAX_VCI_NUMBER
			);
		QMessageBox::warning(0,	"Invalid Configuration Parameter", qsr_tmp.latin1());
		return;
	}else
		tmp_VCI = i_temp;

	//////////////////////////////////////////////////////////////
	if(checkBox_VC_OPT_STATE_INDEP_CONT_CHECK->isChecked() == true)
	{	add_pvc_struct_back.VC_options |= VC_OPT_STATE_INDEP_CONT_CHECK;
	}else
	{	add_pvc_struct_back.VC_options &= (~VC_OPT_STATE_INDEP_CONT_CHECK);
	}

	if(checkBox_VC_OPT_STATE_INDEP_LPBK_RESP->isChecked() == true)
	{	add_pvc_struct_back.VC_options |= VC_OPT_STATE_INDEP_LPBK_RESP;
	}else
	{	add_pvc_struct_back.VC_options &= (~VC_OPT_STATE_INDEP_LPBK_RESP);
	}
	//////////////////////////////////////////////////////////////
	i_temp = (unsigned short)get_edit_box_value(lineEdit_OAM_CC_Tx_timer, &ok);

	if(	ok == false ||	i_temp < MIN_OAM_CC_TIMER || i_temp > MAX_OAM_CC_TIMER)
	{	
		qsr_tmp.sprintf(
			"The 'OAM Continuity Check transmit timer' should be between %u and %u.",
			MIN_OAM_CC_TIMER,
			MAX_OAM_CC_TIMER
			);
		QMessageBox::warning(0,	"Invalid Configuration Parameter", qsr_tmp.latin1());
		return;
	}else
		add_pvc_struct_back.OAM_CC_Tx_timer = i_temp;
	//////////////////////////////////////////////////////////////

	i_temp = (unsigned short)get_edit_box_value(lineEdit_OAM_CC_Rx_timer, &ok);

	if(	ok == false ||	i_temp < MIN_OAM_CC_TIMER || i_temp > MAX_OAM_CC_TIMER)
	{	
		qsr_tmp.sprintf(
			"The 'OAM Continuity Check receive timer' should be between %u and %u.",
			MIN_OAM_CC_TIMER,
			MAX_OAM_CC_TIMER
			);
		QMessageBox::warning(0,	"Invalid Configuration Parameter", qsr_tmp.latin1());
		return;
	}else
		add_pvc_struct_back.OAM_CC_Rx_timer = i_temp;
	//////////////////////////////////////////////////////////////

	i_temp = (unsigned short)get_edit_box_value(lineEdit_OAM_CC_Rx_timeout_counter, &ok);

	if(	ok == false ||	i_temp < MIN_OAM_CC_TIMEOUT_COUNT || i_temp > MAX_OAM_CC_TIMEOUT_COUNT)
	{	
		qsr_tmp.sprintf(
			"The 'OAM Continuity Check receive disconnection counter' should be between %u and %u.",
			MIN_OAM_CC_TIMEOUT_COUNT,
			MAX_OAM_CC_TIMEOUT_COUNT
			);
		QMessageBox::warning(0,	"Invalid Configuration Parameter", qsr_tmp.latin1());
		return;
	}else
		add_pvc_struct_back.OAM_CC_Rx_timeout_counter = i_temp;
	//////////////////////////////////////////////////////////////

	i_temp = (unsigned short)get_edit_box_value(lineEdit_OAM_Loopback_Tx_timer, &ok);

	if(	ok == false ||	i_temp < MIN_OAM_LPBK_TIMER || i_temp > MAX_OAM_LPBK_TIMER)
	{	
		qsr_tmp.sprintf(
			"The 'OAM Loopback transmit timer' should be between %u and %u.",
			MIN_OAM_LPBK_TIMER,
			MAX_OAM_LPBK_TIMER
			);
		QMessageBox::warning(0,	"Invalid Configuration Parameter", qsr_tmp.latin1());
		return;
	}else
		add_pvc_struct_back.OAM_Loopback_Tx_timer = i_temp;
	//////////////////////////////////////////////////////////////

	i_temp = (unsigned short)get_edit_box_value(lineEdit_OAM_Loopback_Rx_timeout, &ok);

	if(	ok == false ||	i_temp < MIN_OAM_LPBK_TIMER || i_temp > MAX_OAM_LPBK_TIMER)
	{	
		qsr_tmp.sprintf(
			"The 'OAM Loopback receive timeout' should be between %u and %u.",
			MIN_OAM_LPBK_TIMEOUT,
			MAX_OAM_LPBK_TIMEOUT
			);
		QMessageBox::warning(0,	"Invalid Configuration Parameter", qsr_tmp.latin1());
		return;
	}else
		add_pvc_struct_back.OAM_Loopback_Rx_timeout = i_temp;

	//////////////////////////////////////////////////////////////

	i_temp = (unsigned short)get_edit_box_value(
								lineEdit_OAM_Loopback_Rx_timeout_counter, &ok);

	if(	ok == false ||	i_temp < MIN_OAM_LPBK_TIMER || i_temp > MAX_OAM_LPBK_TIMER)
	{	
		qsr_tmp.sprintf(
			"The 'OAM Loopback timeout counter' should be between %u and %u.",
			MIN_OAM_LPBK_TIMEOUT_COUNT,
			MAX_OAM_LPBK_TIMEOUT_COUNT
			);
		QMessageBox::warning(0,	"Invalid Configuration Parameter", qsr_tmp.latin1());
		return;
	}else
		add_pvc_struct_back.OAM_Loopback_Rx_timeout_counter = i_temp;

	//////////////////////////////////////////////////////////////

	i_temp = (unsigned short)get_edit_box_value(
								lineEdit_OAM_AIS_Tx_timer, &ok);

	if(	ok == false ||	i_temp < MIN_OAM_AIS_TIMER || i_temp > MAX_OAM_AIS_TIMER)
	{	
		qsr_tmp.sprintf(
			"The 'OAM Alarm Indication Signal transmit timer' should be between %u and %u.",
			MIN_OAM_AIS_TIMER,
			MAX_OAM_AIS_TIMER
			);
		QMessageBox::warning(0,	"Invalid Configuration Parameter", qsr_tmp.latin1());
		return;
	}else
		add_pvc_struct_back.OAM_AIS_Tx_timer = i_temp;


	//////////////////////////////////////////////////////////////
	
	i_temp = (unsigned short)get_edit_box_value(
								lineEdit_OAM_AIS_state_Rx_timeout, &ok);

	if(	ok == false ||	i_temp < MIN_OAM_AIS_STATE_RX_TIMEOUT || i_temp > MAX_OAM_AIS_STATE_RX_TIMEOUT)
	{	
		qsr_tmp.sprintf(
			"The 'OAM Alarm Indication Signal transmit timer' should be between %u and %u.",
			MIN_OAM_AIS_STATE_RX_TIMEOUT,
			MAX_OAM_AIS_STATE_RX_TIMEOUT
			);
		QMessageBox::warning(0,	"Invalid Configuration Parameter", qsr_tmp.latin1());
		return;
	}else
		add_pvc_struct_back.OAM_AIS_state_Rx_timeout = i_temp;

	//////////////////////////////////////////////////////////////

	GFC_VPI = tmp_GFC_VPI;
	VCI = tmp_VCI;

	memcpy( &add_pvc_struct, &add_pvc_struct_back, sizeof(ATMAL_ADD_PVC_STRUCT));
	done(0);
}

void atm_add_vpi_vci_impl::OnCancelClicked()
{
	close();
}

