// atm_comms_err_stats_impl.cpp: implementation of the atm_comms_err_stats_impl class.
//
//////////////////////////////////////////////////////////////////////

#include "MainWizardImpl.h"

extern TesterWizardImpl * globalTesterWizPtr;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

atm_comms_err_stats_impl::atm_comms_err_stats_impl()
{
	window_closed = true;
	set_widget_caption(this);
}

atm_comms_err_stats_impl::~atm_comms_err_stats_impl()
{

}

void atm_comms_err_stats_impl::timerEvent(QTimerEvent * e)
{
	COMMS_ERROR_STATS_STRUCT * ptr_comms_err_struct =
		(COMMS_ERROR_STATS_STRUCT *)globalTesterWizPtr->atm_api_obj.atm_cb.data;

	if(window_closed == true)
	{	return;
	}

	globalTesterWizPtr->atm_api_obj.atm_cb.command = READ_COMMS_ERROR_STATS;
	globalTesterWizPtr->atm_api_obj.atm_cb.buffer_length = 0;
	globalTesterWizPtr->atm_api_obj.atm_cb.return_code = Z80_TIMEOUT_ERROR;

	globalTesterWizPtr->atm_do_command(
		&globalTesterWizPtr->atm_api_obj.atm_cb, globalTesterWizPtr->m_cCard
		);
/*	
	if(globalTesterWizPtr->atm_api_obj.atm_cb.return_code)
	{	
		qstr_err_message.sprintf("READ_COMMS_ERROR_STATS failed!!. Return code 0x%02X",
			globalTesterWizPtr->atm_api_obj.atm_cb.return_code );
		QMessageBox::warning(this, "Command Error", qstr_err_message );

		window_closed = true;
		return;
	}
*/
	qstr_rcvr_overrun.sprintf("%u", ptr_comms_err_struct->Rx_overrun_err_count);
	qstr_dcd_change.sprintf("%u", ptr_comms_err_struct->DCD_state_change_count);
	qstr_cts_change.sprintf("%u", ptr_comms_err_struct->CTS_state_change_count);

	FLD_OVR->setText(qstr_rcvr_overrun);
	FLD_DCD->setText(qstr_dcd_change);
	FLD_CTS->setText(qstr_cts_change);
}

void atm_comms_err_stats_impl::showEvent(QShowEvent * ev)
{
	set_widget_position_on_screen(this);
}

bool atm_comms_err_stats_impl::initialize()
{
	window_closed = false;
	return TRUE;
}

void atm_comms_err_stats_impl::closeEvent(QCloseEvent * e)
{
	window_closed = true;

	globalTesterWizPtr->atm_phy_level_stats_menu->
		setItemChecked (
			globalTesterWizPtr->atm_phy_level_stats_menu->idAt(1), FALSE );
	
	e->accept();
}

void atm_comms_err_stats_impl::on_Flush_clicked()
{
	globalTesterWizPtr->atm_api_obj.atm_cb.command = FLUSH_COMMS_ERROR_STATS;
	globalTesterWizPtr->atm_api_obj.atm_cb.buffer_length = 0;
	globalTesterWizPtr->atm_api_obj.atm_cb.return_code = Z80_TIMEOUT_ERROR;

	globalTesterWizPtr->atm_do_command(
		&globalTesterWizPtr->atm_api_obj.atm_cb, globalTesterWizPtr->m_cCard
		);
}
