// atm_delete_vpi_vci_impl.cpp: implementation of the atm_delete_vpi_vci_impl class.
//
//////////////////////////////////////////////////////////////////////

#include "MainWizardImpl.h"

extern TesterWizardImpl * globalTesterWizPtr;

#define DBG_ATM_DELETE_PVC	1

#define VPI_COL		0
#define VCI_COL		1

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

atm_delete_vpi_vci_impl::atm_delete_vpi_vci_impl()
{
	window_closed = true;

	textLabel2->setText("you want to delete.");

	qstr_err_message = "Delete PVC";
	setCaption(qstr_err_message);

	set_widget_caption(this);

	//remove all columns
	for(int i = listView_VPI_VCI->columns() - 1; i >= 0; i--)
	{	listView_VPI_VCI->removeColumn(i);
	}

	//add needed columns
	listView_VPI_VCI->setSorting(-1);
	listView_VPI_VCI->addColumn("         VPI         ");		//0
	listView_VPI_VCI->setColumnAlignment(VPI_COL, Qt::AlignHCenter);
	listView_VPI_VCI->addColumn("         VCI         ");		//1
	listView_VPI_VCI->setColumnAlignment(VCI_COL, Qt::AlignHCenter);
}

atm_delete_vpi_vci_impl::~atm_delete_vpi_vci_impl()
{

}

void atm_delete_vpi_vci_impl::timerEvent(QTimerEvent * e)
{
	if(window_closed == true)
	{	return;
	}

	globalTesterWizPtr->atm_api_obj.atm_cb.command = ATMAL_LIST_ADDED_PVCS;
	globalTesterWizPtr->atm_api_obj.atm_cb.buffer_length = 0;
	globalTesterWizPtr->atm_api_obj.atm_cb.return_code = Z80_TIMEOUT_ERROR;

	globalTesterWizPtr->atm_do_command(
		&globalTesterWizPtr->atm_api_obj.atm_cb, globalTesterWizPtr->m_cCard
		);
/*	
	if(globalTesterWizPtr->atm_api_obj.atm_cb.return_code)
	{	
		qstr_err_message.sprintf("ATMAL_LIST_ADDED_PVC_STRUCT failed!!. Return code 0x%02X",
			globalTesterWizPtr->atm_api_obj.atm_cb.return_code );
		QMessageBox::warning(this, "Command Error", qstr_err_message );

		window_closed = true;
		return;
	}
*/
/*
	DbgPrint2(DBG_ATM_DELETE_PVC, "ATMAL_LIST_ADDED_PVCS : buffer_length : %u\n",
		globalTesterWizPtr->atm_api_obj.atm_cb.buffer_length
		);
*/
	int buffer_len_backup = globalTesterWizPtr->atm_api_obj.atm_cb.buffer_length;

	if(buffer_len_backup)
	{
		//the list is not empty
		memcpy(
			new_list_of_added_pvcs,
			globalTesterWizPtr->atm_api_obj.atm_cb.data,
			globalTesterWizPtr->atm_api_obj.atm_cb.buffer_length
			);
	}else
	{	memset(new_list_of_added_pvcs, 0x00, SIZEOF_MB_DATA_BFR);
	}

	if(memcmp(	new_list_of_added_pvcs,
				old_list_of_added_pvcs,
				sizeof(new_list_of_added_pvcs)
				)
	  )
	{
		//update the list only if it is different from what it was
		memcpy(
				old_list_of_added_pvcs,
				globalTesterWizPtr->atm_api_obj.atm_cb.data,
				globalTesterWizPtr->atm_api_obj.atm_cb.buffer_length
				);

		listView_VPI_VCI->clear();

		for(int i=0; i < buffer_len_backup;	i += sizeof(ATMAL_LIST_ADDED_PVC_STRUCT))
		{
			update_status_list(i);
		}
	}

	if(!buffer_len_backup)
	{
		initialize();
	}
}

void atm_delete_vpi_vci_impl::showEvent(QShowEvent * ev)
{
	set_widget_position_on_screen(this);
}

bool atm_delete_vpi_vci_impl::initialize()
{
	memset(old_list_of_added_pvcs, 0x00, SIZEOF_MB_DATA_BFR);
	memset(new_list_of_added_pvcs, 0x00, SIZEOF_MB_DATA_BFR);

	window_closed = false;

	listView_VPI_VCI->clear();

	return TRUE;
}

void atm_delete_vpi_vci_impl::closeEvent(QCloseEvent * e)
{
	window_closed = true;

	e->accept();
}

void atm_delete_vpi_vci_impl::update_status_list(int i)
{
	//DbgPrint2(DBG_ATM_DELETE_PVC, "update_status_list() i : %u\n", i);

	ATMAL_LIST_ADDED_PVC_STRUCT * pvc_struct_ptr =
		(ATMAL_LIST_ADDED_PVC_STRUCT *)&new_list_of_added_pvcs[i];


	qstr_vpi.sprintf("%u", pvc_struct_ptr->VPI);
	qstr_vci.sprintf("%u", pvc_struct_ptr->VCI);

	list_view_item = 
		new QListViewItem(	listView_VPI_VCI,
							listView_VPI_VCI->lastItem()
							);

	list_view_item->setText(VPI_COL, qstr_vpi);
	list_view_item->setText(VCI_COL, qstr_vci);
}

void atm_delete_vpi_vci_impl::on_vpi_vci_list_double_clicked()
{
	bool ok;
	QString tmp;
	int vpi, vci;
	QListViewItem * selected_item = listView_VPI_VCI->selectedItem();

	DbgPrint1(DBG_ATM_DELETE_PVC, "on_vpi_vci_list_double_clicked()\n");

	if(selected_item == 0)
	{	//nothing was selected
		QMessageBox::information(	(QWidget *)this,
			"",
			"Please select PVC from the list.",
			QMessageBox::Ok
			);
		return;
	}

	tmp = selected_item->text(VPI_COL);
	vpi = tmp.toUShort(&ok, 10);

	tmp = selected_item->text(VCI_COL);
	vci = tmp.toUShort(&ok, 10);

	DbgPrint3(DBG_ATM_DELETE_PVC, "vpi : %u, vci : %u\n", vpi, vci);

	globalTesterWizPtr->atm_api_obj.atm_cb.command = ATMAL_DELETE_PVC;
	globalTesterWizPtr->atm_api_obj.atm_cb.GFC_VPI = vpi;
	globalTesterWizPtr->atm_api_obj.atm_cb.VCI = vci;
	globalTesterWizPtr->atm_api_obj.atm_cb.buffer_length = 0;
	globalTesterWizPtr->atm_api_obj.atm_cb.return_code = Z80_TIMEOUT_ERROR;

	globalTesterWizPtr->atm_do_command(
		&globalTesterWizPtr->atm_api_obj.atm_cb, globalTesterWizPtr->m_cCard
		);

}
