// atm_line_trace_impl.h: interface for the atm_line_trace_impl class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(ATM_LINE_TRACE_IMPL_H)
#define ATM_LINE_TRACE_IMPL_H

#include "atm_line_trace.h"

class atm_line_trace_impl : public ATM_LineTrace  
{
public:
	atm_line_trace_impl();
	~atm_line_trace_impl();

	bool window_closed;

	QListViewItem * list_view_item_phy_level;
	QListViewItem * list_view_item_aal_level;
	
	bool initialize();
	
	void timerEvent(QTimerEvent * e);
	void showEvent(QShowEvent * ev);
	void closeEvent(QCloseEvent * e);
	
	void Stop_Trace_To_File();
	void on_Close_Trace_Window();
	void on_Flush_Trace_Window();
	void on_Start_Trace_To_File();
	void on_ShowRawTrace();
	void on_ShowInterpretedTrace();
	
	void ShowRawTrace();
	void ShowInterpretedTrace();
	
	bool EnableTracing();
	BOOL DisableTracing(void);
	
	BOOL show_interpreted;

	int read_trace_config(void);
	int set_trc_config(unsigned char config);
	int	read_trace_data(void);
	int get_cell_type();
	void display_phy_level_cell(int cell_type);
	void display_atmal_level_cell(int cell_type);

	void decode_oam_cell();
	void decode_user_data_cell();

	QString qstr_OAM_Cell_Type;
	QString qstr_OAM_Function_Type;

	void form_continuity_check_payload_sring();
	void form_ais_rdi_payload_sring();
	void form_loop_back_payload_sring();
	void form_act_deact_continuity_check_payload_sring();

	bool show_atmal_cell;
	bool show_phy_cell;

	int set_show_flags(int cell_type);

	unsigned short GFC_VPI;
	unsigned short VCI;
	unsigned char PTI;
	unsigned char CLP;
	unsigned char HEC;

	unsigned char trc_data_bfr[5000];
	bool trace_to_file_flag;
	void trace_to_file_atmal_level_cell();
	void trace_to_file_phy_level_cell();

	QString widget_caption;

	QString qstr_tmp;
	QString qstr_err_message;

	QString qstr_direction;
	QString qstr_length;
	QString qstr_time_stamp;
	QString qstr_atmal_level_data, qstr_phy_level_data, qstr_trace_file_data;

	QString qstr_cell_type;
	QString qstr_gfc;
	QString qstr_vpi;
	QString qstr_vci;

	QString qstr_pt;
	QString qstr_clp;
	QString qstr_hec;

};

#endif // !defined(ATM_LINE_TRACE_IMPL_H)
