// atm_phy_level_status_impl.cpp: implementation of the atm_phy_level_status_impl class.
//
//////////////////////////////////////////////////////////////////////

#include "MainWizardImpl.h"

extern TesterWizardImpl * globalTesterWizPtr;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

atm_phy_level_status_impl::atm_phy_level_status_impl()
{
	window_closed = true;
	set_widget_caption(this);

	qstr_tmp = "0";

}

atm_phy_level_status_impl::~atm_phy_level_status_impl()
{

}

void atm_phy_level_status_impl::timerEvent(QTimerEvent * e)
{

	PHY_STATUS_STRUCT * ptr_phy_status_struct =
		(PHY_STATUS_STRUCT *)globalTesterWizPtr->atm_api_obj.atm_cb.data;

	if(window_closed == true)
	{	return;
	}

	globalTesterWizPtr->atm_api_obj.atm_cb.command = PHY_READ_STATUS;
	globalTesterWizPtr->atm_api_obj.atm_cb.buffer_length = 0;
	globalTesterWizPtr->atm_api_obj.atm_cb.return_code = Z80_TIMEOUT_ERROR;

	globalTesterWizPtr->atm_show_command_result = false;

	globalTesterWizPtr->atm_do_command(
		&globalTesterWizPtr->atm_api_obj.atm_cb, globalTesterWizPtr->m_cCard
		);

	globalTesterWizPtr->atm_show_command_result = true;

/*	
	if(globalTesterWizPtr->atm_api_obj.atm_cb.return_code)
	{	
		qstr_err_message.sprintf("PHY_READ_OPERATIONAL_STATS failed!!. Return code 0x%02X",
			globalTesterWizPtr->atm_api_obj.atm_cb.return_code );
		QMessageBox::warning(this, "Command Error", qstr_err_message );

		window_closed = true;
		return;
	}
*/
	switch(ptr_phy_status_struct->Rx_sync_status)
	{
	case PHY_RX_SYNC_LOST:
		qstr_tmp = "Synch lost";
		break;

	case PHY_RX_HUNT:
		qstr_tmp = "In hunt state";
		break;

	case PHY_RX_PRESYNC:
		qstr_tmp = "Presync state";
		break;

	case PHY_RX_SYNCHRONIZED:
		qstr_tmp = "Synchronized";
		break;
	}

	textLabel_Rx_sync_status->setText(qstr_tmp);

	qstr_tmp.sprintf("%u", ptr_phy_status_struct->Rx_sync_time);
	textLabel_Rx_sync_time->setText(qstr_tmp);

	qstr_tmp.sprintf("0x%04X", ptr_phy_status_struct->Rx_sync_bytes);
	textLabel_Rx_sync_bytes->setText(qstr_tmp);

	qstr_tmp.sprintf("%u", ptr_phy_status_struct->Rx_sync_offset);
	textLabel_Rx_sync_offset->setText(qstr_tmp);
}

void atm_phy_level_status_impl::showEvent(QShowEvent * ev)
{
	set_widget_position_on_screen(this);
}

bool atm_phy_level_status_impl::initialize()
{
	window_closed = false;
	return TRUE;
}

void atm_phy_level_status_impl::closeEvent(QCloseEvent * e)
{
	window_closed = true;

	globalTesterWizPtr->atm_phy_level_stats_menu->
		setItemChecked (
			globalTesterWizPtr->atm_phy_level_stats_menu->idAt(0), FALSE );
	
	e->accept();
}

