// atm_phy_oper_stats_impl.cpp: implementation of the atm_phy_oper_stats_impl class.
//
//////////////////////////////////////////////////////////////////////

#include "MainWizardImpl.h"

extern TesterWizardImpl * globalTesterWizPtr;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

atm_phy_oper_stats_impl::atm_phy_oper_stats_impl()
{
	window_closed = true;
	set_widget_caption(this);

	qstr_tmp = "0";

    Rx_throughput->setText(qstr_tmp);
    bytes_Rx_count->setText(qstr_tmp);
    Rx_Idle_Cell_discard_count->setText(qstr_tmp);
    no_ms_for_Rx_thruput_comp->setText(qstr_tmp);

    Rx_Phys_Lyr_Cell_discard_count->setText(qstr_tmp);
    blocks_Rx_count->setText(qstr_tmp);

    Rx_resync_bad_HEC_count->setText(qstr_tmp);
    Rx_resync_reception_loss_count->setText(qstr_tmp);
    Rx_resync_overrun_count->setText(qstr_tmp);

    Rx_sync_attempt_count->setText(qstr_tmp);
    Rx_sync_achieved_count->setText(qstr_tmp);
    Rx_sync_failure_count->setText(qstr_tmp);

    Rx_presync_achieved_count->setText(qstr_tmp);
    Rx_presync_failure_count->setText(qstr_tmp);
    Rx_presync_attempt_count->setText(qstr_tmp);

    Rx_hunt_failure_count->setText(qstr_tmp);
    Rx_hunt_attempt_count->setText(qstr_tmp);
    Rx_hunt_char_sync_count->setText(qstr_tmp);

    Rx_hunt_achieved_count->setText(qstr_tmp);
    Rx_hunt_timeout_count->setText(qstr_tmp);
    Rx_bad_HEC_count->setText(qstr_tmp);

	Rx_Unas_Cell_discard_count->setText(qstr_tmp);
    Rx_blocks_discard_count->setText(qstr_tmp);

    no_ms_for_Tx_thruput_comp->setText(qstr_tmp);
    blocks_Tx_count->setText(qstr_tmp);
    bytes_Tx_count->setText(qstr_tmp);
    Tx_underrun_cell_count->setText(qstr_tmp);

    Tx_length_error_count->setText(qstr_tmp);
    Tx_throughput->setText(qstr_tmp);

}

atm_phy_oper_stats_impl::~atm_phy_oper_stats_impl()
{

}

void atm_phy_oper_stats_impl::timerEvent(QTimerEvent * e)
{
	PHY_OPERATIONAL_STATS_STRUCT * ptr_op_stats_struct =
		(PHY_OPERATIONAL_STATS_STRUCT *)globalTesterWizPtr->atm_api_obj.atm_cb.data;

	if(window_closed == true)
	{	return;
	}

	globalTesterWizPtr->atm_api_obj.atm_cb.command = PHY_READ_OPERATIONAL_STATS;
	globalTesterWizPtr->atm_api_obj.atm_cb.buffer_length = 0;
	globalTesterWizPtr->atm_api_obj.atm_cb.return_code = Z80_TIMEOUT_ERROR;

	globalTesterWizPtr->atm_do_command(
		&globalTesterWizPtr->atm_api_obj.atm_cb, globalTesterWizPtr->m_cCard
		);
/*	
	if(globalTesterWizPtr->atm_api_obj.atm_cb.return_code)
	{	
		qstr_err_message.sprintf("PHY_READ_OPERATIONAL_STATS failed!!. Return code 0x%02X",
			globalTesterWizPtr->atm_api_obj.atm_cb.return_code );
		QMessageBox::warning(this, "Command Error", qstr_err_message );

		window_closed = true;
		return;
	}
*/
	qstr_tmp.sprintf("%u", ptr_op_stats_struct->Rx_throughput);
    Rx_throughput->setText(qstr_tmp);

	qstr_tmp.sprintf("%u", ptr_op_stats_struct->bytes_Rx_count);    
	bytes_Rx_count->setText(qstr_tmp);

	qstr_tmp.sprintf("%u", ptr_op_stats_struct->Rx_Idle_Cell_discard_count);
    Rx_Idle_Cell_discard_count->setText(qstr_tmp);

	qstr_tmp.sprintf("%u", ptr_op_stats_struct->no_ms_for_Rx_thruput_comp);
    no_ms_for_Rx_thruput_comp->setText(qstr_tmp);

	qstr_tmp.sprintf("%u", ptr_op_stats_struct->Rx_Phys_Lyr_Cell_discard_count);
    Rx_Phys_Lyr_Cell_discard_count->setText(qstr_tmp);

	qstr_tmp.sprintf("%u", ptr_op_stats_struct->blocks_Rx_count);
    blocks_Rx_count->setText(qstr_tmp);

	qstr_tmp.sprintf("%u", ptr_op_stats_struct->Rx_resync_bad_HEC_count);
    Rx_resync_bad_HEC_count->setText(qstr_tmp);

	qstr_tmp.sprintf("%u", ptr_op_stats_struct->Rx_resync_reception_loss_count);
    Rx_resync_reception_loss_count->setText(qstr_tmp);

	qstr_tmp.sprintf("%u", ptr_op_stats_struct->Rx_resync_overrun_count);
    Rx_resync_overrun_count->setText(qstr_tmp);

	qstr_tmp.sprintf("%u", ptr_op_stats_struct->Rx_sync_attempt_count);
    Rx_sync_attempt_count->setText(qstr_tmp);

	qstr_tmp.sprintf("%u", ptr_op_stats_struct->Rx_sync_achieved_count);
    Rx_sync_achieved_count->setText(qstr_tmp);

	qstr_tmp.sprintf("%u", ptr_op_stats_struct->Rx_sync_failure_count);
    Rx_sync_failure_count->setText(qstr_tmp);

	qstr_tmp.sprintf("%u", ptr_op_stats_struct->Rx_presync_achieved_count);
    Rx_presync_achieved_count->setText(qstr_tmp);

	qstr_tmp.sprintf("%u", ptr_op_stats_struct->Rx_presync_failure_count);
    Rx_presync_failure_count->setText(qstr_tmp);

	qstr_tmp.sprintf("%u", ptr_op_stats_struct->Rx_presync_attempt_count);
    Rx_presync_attempt_count->setText(qstr_tmp);

	qstr_tmp.sprintf("%u", ptr_op_stats_struct->Rx_hunt_failure_count);
    Rx_hunt_failure_count->setText(qstr_tmp);

	qstr_tmp.sprintf("%u", ptr_op_stats_struct->Rx_hunt_attempt_count);
    Rx_hunt_attempt_count->setText(qstr_tmp);

	qstr_tmp.sprintf("%u", ptr_op_stats_struct->Rx_hunt_char_sync_count);
    Rx_hunt_char_sync_count->setText(qstr_tmp);

	qstr_tmp.sprintf("%u", ptr_op_stats_struct->Rx_hunt_achieved_count);
    Rx_hunt_achieved_count->setText(qstr_tmp);

	qstr_tmp.sprintf("%u", ptr_op_stats_struct->Rx_hunt_timeout_count);
    Rx_hunt_timeout_count->setText(qstr_tmp);

	qstr_tmp.sprintf("%u", ptr_op_stats_struct->Rx_bad_HEC_count);
    Rx_bad_HEC_count->setText(qstr_tmp);

	qstr_tmp.sprintf("%u", ptr_op_stats_struct->Rx_Unas_Cell_discard_count);
	Rx_Unas_Cell_discard_count->setText(qstr_tmp);

	qstr_tmp.sprintf("%u", ptr_op_stats_struct->Rx_blocks_discard_count);
    Rx_blocks_discard_count->setText(qstr_tmp);

	qstr_tmp.sprintf("%u", ptr_op_stats_struct->no_ms_for_Tx_thruput_comp);
    no_ms_for_Tx_thruput_comp->setText(qstr_tmp);

	qstr_tmp.sprintf("%u", ptr_op_stats_struct->blocks_Tx_count);
    blocks_Tx_count->setText(qstr_tmp);

	qstr_tmp.sprintf("%u", ptr_op_stats_struct->bytes_Tx_count);
    bytes_Tx_count->setText(qstr_tmp);

	qstr_tmp.sprintf("%u", ptr_op_stats_struct->Tx_underrun_cell_count);
    Tx_underrun_cell_count->setText(qstr_tmp);

	qstr_tmp.sprintf("%u", ptr_op_stats_struct->Tx_length_error_count);
    Tx_length_error_count->setText(qstr_tmp);

	qstr_tmp.sprintf("%u", ptr_op_stats_struct->Tx_throughput);
    Tx_throughput->setText(qstr_tmp);
}

void atm_phy_oper_stats_impl::showEvent(QShowEvent * ev)
{
	set_widget_position_on_screen(this);
}

bool atm_phy_oper_stats_impl::initialize()
{
	window_closed = false;
	return TRUE;
}

void atm_phy_oper_stats_impl::closeEvent(QCloseEvent * e)
{
	window_closed = true;

	globalTesterWizPtr->atm_phy_level_stats_menu->
		setItemChecked (
			globalTesterWizPtr->atm_phy_level_stats_menu->idAt(2), FALSE );
	
	e->accept();
}

void atm_phy_oper_stats_impl::on_Flush_clicked()
{
	globalTesterWizPtr->atm_api_obj.atm_cb.command = PHY_FLUSH_OPERATIONAL_STATS;
	globalTesterWizPtr->atm_api_obj.atm_cb.buffer_length = 0;
	globalTesterWizPtr->atm_api_obj.atm_cb.return_code = Z80_TIMEOUT_ERROR;

	globalTesterWizPtr->atm_do_command(
		&globalTesterWizPtr->atm_api_obj.atm_cb, globalTesterWizPtr->m_cCard
		);
}
