// atm_pvc_stats_impl.cpp: implementation of the atm_pvc_stats_impl class.
//
//////////////////////////////////////////////////////////////////////

#include "atm_vpi_vci_list.h"

#include "atm_pvc_stats_impl.h"

#include "MainWizardImpl.h"

extern TesterWizardImpl * globalTesterWizPtr;

#define DBG_ATMM_PVC_OPER_STATS	1

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

atm_pvc_stats_impl::atm_pvc_stats_impl(
				void * parent, unsigned short vpi, unsigned short vci)
{
	initialize();

	next_element = NULL;
	previouse_element = NULL;

	this->parent = parent;
	this->vpi = vpi;
	this->vci = vci;

	QString caption;

	caption.sprintf("PVC Statistics. VPI: %u, VCI: %u. Station", vpi, vci);

	setCaption( caption );

	set_widget_caption(this);


	qstr_tmp = "";
	User_Information_blocks_Tx_Rx->setText(qstr_tmp);
	User_Information_bytes_Tx_Rx->setText(qstr_tmp);
	SAR_PDUs_Tx_Rx->setText(qstr_tmp);
	User_Information_blocks_of_invalid_length_Tx_Rx->setText(qstr_tmp);
	incoming_User_Information_blocks_discarded->setText(qstr_tmp);
	User_Information_blocks_received_with_a_bad_CRC->setText(qstr_tmp);
	number_of_Rx_PDU_timeouts->setText(qstr_tmp);

	OAM_Continuity_Check_counter_Tx_Rx->setText(qstr_tmp);
	OAM_Continuity_Check_receive_timeout_counter->setText(qstr_tmp);
	Continuity_Check_activation_request_counter_Tx_Rx->setText(qstr_tmp);
	OAM_Continuity_Check_activation_confirmation_counter_Tx_Rx->setText(qstr_tmp);
	OAM_Continuity_Check_activation_request_denied_counter_Tx_Rx->setText(qstr_tmp);
	OAM_Continuity_Check_deactivation_request_counter_Tx_Rx->setText(qstr_tmp);
	OAM_Continuity_Check_deactivation_confirmation_counter_Tx_Rx->setText(qstr_tmp);
	OAM_Continuity_Check_deactivation_request_denied_counter_Tx_Rx->setText(qstr_tmp);
	OAM_Loopback__LI0__counter_Tx_Rx->setText(qstr_tmp);
	OAM_Loopback__LI1__counter_Tx_Rx->setText(qstr_tmp);
	OAM_Loopback_receive_timeout_counter->setText(qstr_tmp);

	textLabel_OAM_Alarm_Indication_Signal_counter_Tx_Rx->setText(qstr_tmp);
	textLabel_OAM_Remote_Defect_Indication_counter_Tx_RX->setText(qstr_tmp);

}

atm_pvc_stats_impl::~atm_pvc_stats_impl()
{
	DbgPrint3(DBG_ATMM_PVC_OPER_STATS, "~atm_pvc_stats_impl() : VPI: %u, VCI: %u\n", 
		vpi, vci);

	DbgPrint3(DBG_ATMM_PVC_OPER_STATS,
		"~atm_pvc_stats_impl() : next_element: 0x%X, previouse_element: 0x%X\n", 
		next_element, previouse_element
		);

}

void atm_pvc_stats_impl::timerEvent(QTimerEvent * e)
{
/*
	DbgPrint2(DBG_ATMM_PVC_OPER_STATS,
		"atm_pvc_stats_impl::timerEvent() : window_closed: %d\n", 
		window_closed
		);
*/
	if(window_closed == true)
	{	return;
	}

	globalTesterWizPtr->atm_api_obj.atm_cb.command = ATMAL_READ_OPERATIONAL_STATS;
	globalTesterWizPtr->atm_api_obj.atm_cb.GFC_VPI = vpi;
	globalTesterWizPtr->atm_api_obj.atm_cb.VCI = vci;
	globalTesterWizPtr->atm_api_obj.atm_cb.buffer_length = 0;
	globalTesterWizPtr->atm_api_obj.atm_cb.return_code = Z80_TIMEOUT_ERROR;
	globalTesterWizPtr->atm_api_obj.atm_cb.command_qualifier = CMD_QUAL_PVC_OP_STATS;

	globalTesterWizPtr->atm_do_command(
		&globalTesterWizPtr->atm_api_obj.atm_cb, globalTesterWizPtr->m_cCard
		);
	
/*
	if(globalTesterWizPtr->atm_api_obj.atm_cb.return_code)
	{	
		close();
	}
*/
/*
	DbgPrint2(DBG_ATMM_VPI_VCI_LIST, "ATMAL_LIST_ADDED_PVCS : buffer_length : %u\n",
		globalTesterWizPtr->atm_api_obj.atm_cb.buffer_length
		);
*/

	if(globalTesterWizPtr->atm_api_obj.atm_cb.buffer_length)
	{	
		ATMAL_OPERATIONAL_STATS_STRUCT * oper_stats_struct = 
			(ATMAL_OPERATIONAL_STATS_STRUCT *)globalTesterWizPtr->atm_api_obj.atm_cb.data;

		ATMAL_PVC_OP_STATS_STRUCT * pvc_op_stats_ptr = &oper_stats_struct->OP_STATS.PVC;

		update_statistics(pvc_op_stats_ptr);
	}
/*	
#if DBG_ATMM_VPI_VCI_LIST
	qstr_tmp.sprintf("VPI: %u, VCI: %u return_code : %u, buffer_len : %u",
			vpi,
			vci,
			globalTesterWizPtr->atm_api_obj.atm_cb.return_code,
			globalTesterWizPtr->atm_api_obj.atm_cb.buffer_length
			); 

	setCaption( qstr_tmp );
#endif
*/

}

void atm_pvc_stats_impl::showEvent(QShowEvent * ev)
{
	set_widget_position_on_screen(this);
}

bool atm_pvc_stats_impl::initialize()
{
	//atm_pvc_stats_impl * tmp;

	window_closed = false;
	return TRUE;
}

void atm_pvc_stats_impl::closeEvent(QCloseEvent * e)
{
	window_closed = true;
	QCustomEvent *event = new QCustomEvent(ATM_DELETE_STATS_ELEMENT);

	event->setData(this);

	//post the selfdestruction event.
	QApplication::postEvent((QObject *)parent, event);					                      \
}

void atm_pvc_stats_impl::update_statistics(ATMAL_PVC_OP_STATS_STRUCT * PVC_op_stats)
{
	//DbgPrint2(DBG_ATMM_PVC_OPER_STATS, "update_status_list() i : %u\n", i);

	//////////////////////////////////////////////////////////////////////////////
	// Transmission / Reception statistics
	//
	qstr_tmp.sprintf("%-8lu / %-8lu", 
		PVC_op_stats->user_info_Tx_count, PVC_op_stats->user_info_Rx_count);
	User_Information_blocks_Tx_Rx->setText(qstr_tmp);

	qstr_tmp.sprintf("%-8lu / %-8lu", 
		PVC_op_stats->user_info_bytes_Tx_count, PVC_op_stats->user_info_bytes_Rx_count);
	User_Information_bytes_Tx_Rx->setText(qstr_tmp);

	qstr_tmp.sprintf("%-8lu / %-8lu", 
		PVC_op_stats->SAR_PDU_Tx_count, PVC_op_stats->SAR_PDU_Rx_count);
	SAR_PDUs_Tx_Rx->setText(qstr_tmp);

	qstr_tmp.sprintf("%-8lu / %-8lu", 
		PVC_op_stats->Tx_length_error_discard_count, PVC_op_stats->Rx_length_error_count);
	User_Information_blocks_of_invalid_length_Tx_Rx->setText(qstr_tmp);

	qstr_tmp.sprintf("%-8lu",
		PVC_op_stats->Rx_user_info_discard_count);
	incoming_User_Information_blocks_discarded->setText(qstr_tmp);

	qstr_tmp.sprintf("%-8lu",
		PVC_op_stats->Rx_bad_CRC_count);
	User_Information_blocks_received_with_a_bad_CRC->setText(qstr_tmp);

	qstr_tmp.sprintf("%-8lu",
		PVC_op_stats->Rx_PDU_timeout_count);
	number_of_Rx_PDU_timeouts->setText(qstr_tmp);


	//////////////////////////////////////////////////////////////////////////////
	// OAM statistics
	//
	qstr_tmp.sprintf("%-5u / %-5u", 
		PVC_op_stats->OAM_CC_Tx_count, PVC_op_stats->OAM_CC_Rx_count);
	OAM_Continuity_Check_counter_Tx_Rx->setText(qstr_tmp);

	qstr_tmp.sprintf("%-5u", 
		PVC_op_stats->OAM_CC_Rx_timeout_count);
	OAM_Continuity_Check_receive_timeout_counter->setText(qstr_tmp);
	
	qstr_tmp.sprintf("%-5u / %-5u", 
		PVC_op_stats->OAM_CC_act_req_Tx_count, PVC_op_stats->OAM_CC_act_req_Rx_count);
	Continuity_Check_activation_request_counter_Tx_Rx->setText(qstr_tmp);

	qstr_tmp.sprintf("%-5u / %-5u", 
		PVC_op_stats->OAM_CC_act_conf_Tx_count, PVC_op_stats->OAM_CC_act_conf_Rx_count);
	OAM_Continuity_Check_activation_confirmation_counter_Tx_Rx->setText(qstr_tmp);

	qstr_tmp.sprintf("%-5u / %-5u", 
		PVC_op_stats->OAM_CC_act_req_deny_Tx_count, PVC_op_stats->OAM_CC_act_req_deny_Rx_count);
	OAM_Continuity_Check_activation_request_denied_counter_Tx_Rx->setText(qstr_tmp);

	qstr_tmp.sprintf("%-5u / %-5u", 
		PVC_op_stats->OAM_CC_deact_req_Tx_count, PVC_op_stats->OAM_CC_deact_req_Rx_count);
	OAM_Continuity_Check_deactivation_request_counter_Tx_Rx->setText(qstr_tmp);

	qstr_tmp.sprintf("%-5u / %-5u", 
		PVC_op_stats->OAM_CC_deact_conf_Tx_count, PVC_op_stats->OAM_CC_deact_conf_Rx_count);
	OAM_Continuity_Check_deactivation_confirmation_counter_Tx_Rx->setText(qstr_tmp);

	qstr_tmp.sprintf("%-5u / %-5u", 
		PVC_op_stats->OAM_CC_deact_req_deny_Tx_count, PVC_op_stats->OAM_CC_deact_req_deny_Rx_count);
	OAM_Continuity_Check_deactivation_request_denied_counter_Tx_Rx->setText(qstr_tmp);

	qstr_tmp.sprintf("%-5u / %-5u",
		PVC_op_stats->OAM_Loopback_LI0_Tx_count, PVC_op_stats->OAM_Loopback_LI0_Rx_count);
	OAM_Loopback__LI0__counter_Tx_Rx->setText(qstr_tmp);
		
	qstr_tmp.sprintf("%-5u / %-5u",
		PVC_op_stats->OAM_Loopback_LI1_Tx_count, PVC_op_stats->OAM_Loopback_LI1_Rx_count);
	OAM_Loopback__LI1__counter_Tx_Rx->setText(qstr_tmp);

	qstr_tmp.sprintf("%-5u",
		PVC_op_stats->OAM_Loopback_Rx_timeout_count);
	OAM_Loopback_receive_timeout_counter->setText(qstr_tmp);

	qstr_tmp.sprintf("%-5u / %-5u",
		PVC_op_stats->OAM_AIS_Tx_count, PVC_op_stats->OAM_AIS_Rx_count);
	textLabel_OAM_Alarm_Indication_Signal_counter_Tx_Rx->setText(qstr_tmp);

	qstr_tmp.sprintf("%-5u / %-5u",
		PVC_op_stats->OAM_RDI_Tx_count, PVC_op_stats->OAM_RDI_Rx_count);
	textLabel_OAM_Remote_Defect_Indication_counter_Tx_RX->setText(qstr_tmp);

}

void atm_pvc_stats_impl::on_Flush_clicked()
{
	globalTesterWizPtr->atm_api_obj.atm_cb.command = ATMAL_FLUSH_OPERATIONAL_STATS;
	globalTesterWizPtr->atm_api_obj.atm_cb.GFC_VPI = vpi;
	globalTesterWizPtr->atm_api_obj.atm_cb.VCI = vci;
	globalTesterWizPtr->atm_api_obj.atm_cb.buffer_length = 0;
	globalTesterWizPtr->atm_api_obj.atm_cb.return_code = Z80_TIMEOUT_ERROR;
	globalTesterWizPtr->atm_api_obj.atm_cb.command_qualifier = CMD_QUAL_PVC_OP_STATS;

	globalTesterWizPtr->atm_do_command(
		&globalTesterWizPtr->atm_api_obj.atm_cb, globalTesterWizPtr->m_cCard
		);
/*	
	if(globalTesterWizPtr->atm_api_obj.atm_cb.return_code)
	{	window_closed = true;
		return;
	}
*/
}
