// atm_vpi_vci_list_impl.cpp: implementation of the atm_vpi_vci_list_impl class.
//
//////////////////////////////////////////////////////////////////////

#include "MainWizardImpl.h"

extern TesterWizardImpl * globalTesterWizPtr;

#define DBG_ATMM_VPI_VCI_LIST	1

#define VPI_COL		0
#define VCI_COL		1

#define MAX_VPI_VCI_LIST_SIZE 100

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

atm_vpi_vci_list_impl::atm_vpi_vci_list_impl()
{
	//window_closed = true;

	qstr_err_message = "PVC Oper. Stats.";
	setCaption(qstr_err_message);

	set_widget_caption(this);

	//remove all columns
	for(int i = listView_VPI_VCI->columns() - 1; i >= 0; i--)
	{	listView_VPI_VCI->removeColumn(i);
	}

	//add needed columns
	listView_VPI_VCI->setSorting(-1);
	listView_VPI_VCI->addColumn("         VPI         ");		//0
	listView_VPI_VCI->setColumnAlignment(VPI_COL, Qt::AlignHCenter);
	listView_VPI_VCI->addColumn("         VCI         ");		//1
	listView_VPI_VCI->setColumnAlignment(VCI_COL, Qt::AlignHCenter);

	atm_pvc_stats_tail = NULL;
	list_size = 0;
}

atm_vpi_vci_list_impl::~atm_vpi_vci_list_impl()
{

}

void atm_vpi_vci_list_impl::timerEvent(QTimerEvent * e)
{
	/*
	if(window_closed == true)
	{	return;
	}
	*/

	globalTesterWizPtr->atm_api_obj.atm_cb.command = ATMAL_LIST_ADDED_PVCS;
	globalTesterWizPtr->atm_api_obj.atm_cb.buffer_length = 0;
	globalTesterWizPtr->atm_api_obj.atm_cb.return_code = Z80_TIMEOUT_ERROR;

	globalTesterWizPtr->atm_do_command(
		&globalTesterWizPtr->atm_api_obj.atm_cb, globalTesterWizPtr->m_cCard
		);
/*	
	if(globalTesterWizPtr->atm_api_obj.atm_cb.return_code)
	{	
		qstr_err_message.sprintf("ATMAL_LIST_ADDED_PVC_STRUCT failed!!. Return code 0x%02X",
			globalTesterWizPtr->atm_api_obj.atm_cb.return_code );
		QMessageBox::warning(this, "Command Error", qstr_err_message );

		window_closed = true;
		return;
	}
*/
/*
	DbgPrint2(DBG_ATMM_VPI_VCI_LIST, "ATMAL_LIST_ADDED_PVCS : buffer_length : %u\n",
		globalTesterWizPtr->atm_api_obj.atm_cb.buffer_length
		);
*/
	int buffer_len_backup = globalTesterWizPtr->atm_api_obj.atm_cb.buffer_length;

	if(buffer_len_backup)
	{
		//the list is not empty
		memcpy(
			new_list_of_added_pvcs,
			globalTesterWizPtr->atm_api_obj.atm_cb.data,
			globalTesterWizPtr->atm_api_obj.atm_cb.buffer_length
			);
	}else
	{	memset(new_list_of_added_pvcs, 0x00, SIZEOF_MB_DATA_BFR);
	}

	if(memcmp(	new_list_of_added_pvcs,
				old_list_of_added_pvcs,
				sizeof(new_list_of_added_pvcs)
				)
	  )
	{
		//update the list only if it is different from what it was
		memcpy(
				old_list_of_added_pvcs,
				globalTesterWizPtr->atm_api_obj.atm_cb.data,
				globalTesterWizPtr->atm_api_obj.atm_cb.buffer_length
				);

		listView_VPI_VCI->clear();

		for(int i=0; i < buffer_len_backup;	i += sizeof(ATMAL_LIST_ADDED_PVC_STRUCT))
		{
			update_status_list(i);
		}
	}

	if(!buffer_len_backup)
	{
		initialize();
	}

	//even if the list is empty poll the open windows,
	//this will allow automatic destruction of windows for PVCs which were deleted.
	//update_status_windows();
	
	QCustomEvent *event = new QCustomEvent(ATM_UPDATE_STATS_WINDOWS);
	//post the update event.
	QApplication::postEvent(this, event);					                      \
	
}

void atm_vpi_vci_list_impl::showEvent(QShowEvent * ev)
{
	set_widget_position_on_screen(this);
}

bool atm_vpi_vci_list_impl::initialize()
{
	memset(old_list_of_added_pvcs, 0x00, SIZEOF_MB_DATA_BFR);
	memset(new_list_of_added_pvcs, 0x00, SIZEOF_MB_DATA_BFR);

	//window_closed = false;
	return TRUE;
}

void atm_vpi_vci_list_impl::closeEvent(QCloseEvent * e)
{
	//window_closed = true;

	globalTesterWizPtr->atm_atmal_level_status_and_stats_menu->
		setItemChecked (
			globalTesterWizPtr->atm_atmal_level_status_and_stats_menu->idAt(1), FALSE );
	
	e->accept();
}

void atm_vpi_vci_list_impl::update_status_list(int i)
{
	//DbgPrint2(DBG_ATMM_VPI_VCI_LIST, "update_status_list() i : %u\n", i);

	ATMAL_LIST_ADDED_PVC_STRUCT * pvc_struct_ptr =
		(ATMAL_LIST_ADDED_PVC_STRUCT *)&new_list_of_added_pvcs[i];


	qstr_vpi.sprintf("%u", pvc_struct_ptr->VPI);
	qstr_vci.sprintf("%u", pvc_struct_ptr->VCI);

	list_view_item = 
		new QListViewItem(	listView_VPI_VCI,
							listView_VPI_VCI->lastItem()
							);

	list_view_item->setText(VPI_COL, qstr_vpi);
	list_view_item->setText(VCI_COL, qstr_vci);
}

void atm_vpi_vci_list_impl::on_vpi_vci_list_double_clicked()
{
	bool ok;
	QString tmp;
	unsigned short vpi, vci;
	QListViewItem * selected_item = listView_VPI_VCI->selectedItem();

	DbgPrint1(DBG_ATMM_VPI_VCI_LIST, "on_vpi_vci_list_double_clicked()\n");

	if(selected_item == 0)
	{	//nothing was selected
		QMessageBox::information(	(QWidget *)this,
			"",
			"Please select PVC from the list.",
			QMessageBox::Ok
			);
		return;
	}

	tmp = selected_item->text(VPI_COL);
	vpi = tmp.toUShort(&ok, 10);

	tmp = selected_item->text(VCI_COL);
	vci = tmp.toUShort(&ok, 10);

	DbgPrint3(DBG_ATMM_VPI_VCI_LIST, "vpi : %u, vci : %u\n", vpi, vci);

	if(find_vpi_vci_combination_in_list(vpi, vci) == NULL)
	{
		atm_pvc_stats_impl * new_el = new atm_pvc_stats_impl(this, vpi, vci);

		DbgPrint2(DBG_ATMM_VPI_VCI_LIST, "new_el : 0x%X\n", new_el);

		insert_element_into_vpi_vci_list(new_el);

		new_el->show();
	}
}

//go through the list and check that this VPI/VCI combination
//exist in one of the elements.
//return:
// pointer to the element, if found
// NULL returned, if not found
atm_pvc_stats_impl * atm_vpi_vci_list_impl::find_vpi_vci_combination_in_list(
															unsigned short vpi,
															unsigned short vci
															)
{
	if(list_size == 0)
		return NULL;

	atm_pvc_stats_impl * tmp = atm_pvc_stats_tail;

	while(tmp != NULL)
	{
		if(tmp->vpi == vpi && tmp->vci == vci)
		{
			DbgPrint3(DBG_ATMM_VPI_VCI_LIST,
				"find() : found element : vpi : %u, vci : %u .\n",
				vpi, vci
				);
			return tmp;
		}

		tmp = (atm_pvc_stats_impl *)tmp->next_element;
	}

	//if got here, not in the list
	DbgPrint3(DBG_ATMM_VPI_VCI_LIST,
			"find() : vpi : %u, vci : %u not in the list.\n",
			vpi, vci
			);

	return NULL;
}

//return:
// 0 - was successfully inserted
// 1 - already in the list
// 2 - maximum list size reached
//
// insertion done at Tail only
int atm_vpi_vci_list_impl::insert_element_into_vpi_vci_list(
											atm_pvc_stats_impl * new_element)
{

	if(find_vpi_vci_combination_in_list(new_element->vpi,
										new_element->vci) != NULL)
	{
		DbgPrint3(DBG_ATMM_VPI_VCI_LIST,
			"insert_element() vpi : %u, vci : %u already in list !!\n",
			new_element->vpi, new_element->vci
			);
		return 1;
	}

	if(list_size == MAX_VPI_VCI_LIST_SIZE)
	{
		DbgPrint1(DBG_ATMM_VPI_VCI_LIST,
			"insert_element() : Maximum list size reached!!\n");
		return 2;
	}

	DbgPrint3(DBG_ATMM_VPI_VCI_LIST,"inserting : vpi : %u, vci : %u \n",
		new_element->vpi, new_element->vci
		);

	//inserting at the tail
	new_element->next_element = atm_pvc_stats_tail;
	new_element->previouse_element = NULL;
	if(list_size)
	{
		atm_pvc_stats_tail->previouse_element = new_element;
	}
	atm_pvc_stats_tail = new_element;
	list_size++;

	return 0;
}

//return:
// 0 - was successfully removed
// 1 - not found in the list
int atm_vpi_vci_list_impl::remove_element_from_vpi_vci_list(
											atm_pvc_stats_impl * element)
{
	atm_pvc_stats_impl * tmp = find_vpi_vci_combination_in_list(
										element->vpi,
										element->vci
										);

	if(tmp == NULL)
	{
		DbgPrint3(DBG_ATMM_VPI_VCI_LIST,
			"remove_element() vpi : %u, vci : %u NOT found in list !!\n",
			element->vpi, element->vci
			);
		return 1;
	}

	DbgPrint3(DBG_ATMM_VPI_VCI_LIST,"removing : vpi : %u, vci : %u \n",
		element->vpi, element->vci
		);


	atm_pvc_stats_impl * tmp_next = (atm_pvc_stats_impl *)tmp->next_element;
	atm_pvc_stats_impl * tmp_previouse = (atm_pvc_stats_impl *)tmp->previouse_element;

	DbgPrint3(DBG_ATMM_VPI_VCI_LIST,
		"removing : tmp_next : 0x%X, tmp_previouse : 0x%X \n",
		tmp_next,
		tmp_previouse
		);

	//update the "next" of previouse element
	if(tmp_previouse != NULL)
	{	
		DbgPrint1(DBG_ATMM_VPI_VCI_LIST, "tmp_previouse != NULL\n");
		
		tmp_previouse->next_element = tmp_next;

	}else
	{
		DbgPrint1(DBG_ATMM_VPI_VCI_LIST, "tmp_previouse == NULL\n");
	}

	if(tmp_next != NULL)
	{	
		DbgPrint1(DBG_ATMM_VPI_VCI_LIST, "tmp_next != NULL\n");
		
		//update the "previouse" of the next element
		tmp_next->previouse_element = tmp_previouse;

	}else
	{	
		DbgPrint1(DBG_ATMM_VPI_VCI_LIST, "tmp_next == NULL\n");

		if(tmp_previouse != NULL)
		{	tmp_previouse->next_element = tmp_next;
		}
	}

	//special case - item being deleted is at the 'tail'
	//(may be the last element in the queue)
	if(atm_pvc_stats_tail == tmp)
	{	
		DbgPrint1(DBG_ATMM_VPI_VCI_LIST, "atm_pvc_stats_tail == tmp\n");
		
		atm_pvc_stats_tail = tmp_next;

		if(atm_pvc_stats_tail != NULL)
		{	
			atm_pvc_stats_tail->previouse_element = NULL;
		}
	}

	delete tmp;

	list_size--;

	if(list_size == 0)
	{
		atm_pvc_stats_tail = NULL;
	}

	return 0;
}

//event for deleting elements from the list
void atm_vpi_vci_list_impl::customEvent(QCustomEvent *event)
{
	//DbgPrint1(DBG_ATMM_VPI_VCI_LIST, "customEvent()\n");

    switch (event->type())
    {
    case ATM_DELETE_STATS_ELEMENT:
		{
			atm_pvc_stats_impl * element = (atm_pvc_stats_impl *) event->data();

			DbgPrint2(DBG_ATMM_VPI_VCI_LIST, "delete element : 0x%X\n", element);

			remove_element_from_vpi_vci_list(element);

			break;
		}

	case ATM_UPDATE_STATS_WINDOWS:
		update_status_windows();
		break;

    default:
		  qWarning("Unknown custom event type: %d", event->type());
	  	
    }
}

void atm_vpi_vci_list_impl::update_status_windows()
{
	//DbgPrint1(DBG_ATMM_VPI_VCI_LIST, "update_status_windows()\n");

	//
	//traverse the list and poll each element
	//
	
	if(list_size == 0)
	{	//DbgPrint1(DBG_ATMM_VPI_VCI_LIST, "update_status_windows(): list_size == 0\n");
		return;
	}

	atm_pvc_stats_impl * tmp = atm_pvc_stats_tail;

	while(tmp != NULL)
	{
		tmp->timerEvent(NULL);
		tmp = (atm_pvc_stats_impl *)tmp->next_element;
	}
}
