// atm_vpi_vci_list_impl.h: interface for the atm_vpi_vci_list_impl class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(ATM_VPI_VCI_LIST_IMPL_H)
#define ATM_VPI_VCI_LIST_IMPL_H

#define ATM_DELETE_STATS_ELEMENT	12345
#define ATM_UPDATE_STATS_WINDOWS	12346

#include "atm_vpi_vci_list.h"

#include "atm_pvc_stats_impl.h"

class atm_vpi_vci_list_impl : public atm_vpi_vci_list  
{
public:
	atm_vpi_vci_list_impl();
	~atm_vpi_vci_list_impl();

	//bool window_closed;
	bool initialize();
	
	void timerEvent(QTimerEvent * e);
	void showEvent(QShowEvent * ev);
	void closeEvent(QCloseEvent * e);

    void on_vpi_vci_list_double_clicked();

	void update_status_list(int i);

	unsigned char old_list_of_added_pvcs[SIZEOF_MB_DATA_BFR];
	unsigned char new_list_of_added_pvcs[SIZEOF_MB_DATA_BFR];

	QString qstr_vpi;
	QString qstr_vci;
	QString qstr_err_message;

	QListViewItem * list_view_item;

	atm_pvc_stats_impl * atm_pvc_stats_tail;
	unsigned int list_size;

	atm_pvc_stats_impl * find_vpi_vci_combination_in_list(	unsigned short vpi,
															unsigned short vci);

	//return:
	// 0 - was successfully inserted
	// 1 - already in the list
	// 2 - maximum list size reached
	//
	// insertion done at Tail only
	int insert_element_into_vpi_vci_list(	atm_pvc_stats_impl * new_element);

	//return:
	// 0 - was successfully removed
	// 1 - not found in the list
	int remove_element_from_vpi_vci_list(	atm_pvc_stats_impl * element);

	//events for printing to the main List and ListView boxes
	void customEvent(QCustomEvent * event);
	void update_status_windows();
};

#endif // !defined(ATM_VPI_VCI_LIST_IMPL_H)
