#ifndef ATMUTILS_H
#define ATMUTILS_H

#pragma pack(1)

// for displaying ATM operational statistics
#define SHOW_TX_DATA_FRM_STATS				0x01
#define SHOW_RX_DATA_FRM_STATS			 	0x02
#define SHOW_ALL_STATS							0xFF


// decision and result constants */
#define RESET 										0x00
#define SET 										0x01
#define NO 											0x00
#define YES 										0x01
#define ZERO 										0x00


// definition for using both comms ports in application programs
#define BOTH_PORTS 								0x10


// structure used for receiving data frame in applications
typedef struct {
	unsigned short number_Rx_stat_els;
	PHY_RX_STATUS_EL_STRUCT  *base_addr_Rx_stat_el_list;
	PHY_RX_STATUS_EL_STRUCT  *end_addr_Rx_stat_el_list;
	PHY_RX_STATUS_EL_STRUCT  *ptr_next_Rx_stat_el_to_use;
} RX_DATA_INFO_STRUCT;


// structure used for transmitting data frame in applications
typedef struct {
	unsigned short number_Tx_stat_els;
	PHY_TX_STATUS_EL_STRUCT *base_addr_Tx_stat_el_list;
	PHY_TX_STATUS_EL_STRUCT *end_addr_Tx_stat_el_list;
	PHY_TX_STATUS_EL_STRUCT *ptr_next_Tx_stat_el_to_use;
} TX_DATA_INFO_STRUCT;


#define SIZEOF_MB_HDR		0x10
#define MAX_LGTH_FILE_PATHNAME 50

#define OP_MODE_NONE				0x00
#define OP_MODE_LOOPBACK			0x01
#define OP_MODE_RX_TO_FILE		0x02
#define OP_MODE_TX_FROM_FILE	0x04


#define HEC_GENERATOR   0x107               /* x^8 + x^2 +  x  + 1  */
#define COSET_LEADER    0x055               /* x^6 + x^4 + x^2 + 1  */



#define LENGTH_ATM_CELL					53
#define LENGTH_PAYLOAD_ATM_CELL 		48

typedef struct {
	unsigned char GFC_VPI;
	unsigned char VPI_VCI;
	unsigned char VCI;
	unsigned char VCI_PT_CLP;
	unsigned char HEC;
} ATM_HEADER_STRUCT;

typedef struct {
	ATM_HEADER_STRUCT ATM_header;
	unsigned char ATM_payload[LENGTH_PAYLOAD_ATM_CELL];
} ATM_CELL_STRUCT;

#pragma pack()

#endif //ATMUTILS_H
