/***************************************************************************
main.cpp  -  description
------------------------
begin                	: Thu Sep  6 10:01:47 EDT 2001
by										:  David Rokhvarg		<drokhvarg@sangoma.com>

***************************************************************************/

/***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
***************************************************************************/

#include "MainWizardImpl.h"

#define DBG_MAIN_MAIN_FILE      0

int app_command_line_empty = TRUE;
int card_number = INVAL_CARD;
int protocol = PROTOCOL_OPTION_NO_PROTOCOL;

int main(int argc,char **argv)
{
	QApplication a(argc,argv);
	QString message;
	bool ok = false;
	
	DbgPrint2(DBG_MAIN_MAIN_FILE, "argc : %d\n", argc);
	for(int i=0; i<argc; i++)
	{
		DbgPrint3(DBG_MAIN_MAIN_FILE, "argv[%d] = %s\n", i, argv[i]);
	}
	
	if(argc == 3)
	{
		QString qstr_card(argv[1]);
		
		card_number = qstr_card.toUShort(&ok, 10);
		
		if(ok == false)
		{	message.sprintf("Failed to parse command line arguments. (argv[1]: %s)", argv[1]);
			QMessageBox::warning(NULL, "Parse Error", message);
			card_number = INVAL_CARD;
			return 1;
		}else
		{	if(card_number != CARD_DCE && card_number != CARD_DTE)
			{	message.sprintf("Invalid card number passed as command line argument. (card number : %d)", card_number);
				QMessageBox::warning(NULL, "Invalid Command Line argument", message);
				card_number = INVAL_CARD;
				return 1;
			}
		}
		
		//////////////////////////////////////////////////////////////////////////
		
		QString qstr_protocol(argv[2]);
		
		protocol = qstr_protocol.toUShort(&ok, 10);
		
		if(ok == false)
		{	message.sprintf("Failed to parse command line arguments. (argv[2]: %s)",
				argv[2]);
			QMessageBox::warning(NULL, "Parse Error", message);
			protocol = PROTOCOL_OPTION_NO_PROTOCOL;
			return 1;
		}else
		{	if( protocol != PROTOCOL_OPTION_X25 &&
				protocol != PROTOCOL_OPTION_FR	&&
				protocol != PROTOCOL_OPTION_ATM
			  )
			{	message.sprintf(
					"Invalid protocol passed as command line argument. (protocol : %d)",
					protocol);
				QMessageBox::warning(NULL, "Invalid Command Line argument", message);
				protocol = PROTOCOL_OPTION_NO_PROTOCOL;
				return 1;
			}
		}

		app_command_line_empty = FALSE;
	}else
	{	app_command_line_empty = TRUE;
	}
	
	TesterWizardImpl wizard;
  wizard.show();
  return a.exec();
}
