/***************************************************************************
                          x25config_impl.h  -  description
                             -------------------
    begin                : Tue Oct 2 2001
    copyright            : (C) 2001 by DavidR
    email                : drokhvarg@sangoma.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef X25CONFIG_IMPL_H
#define X25CONFIG_IMPL_H

#include "tester.h"
#include "X25Config.h"
#include "X25_LogicalChannelCfg_Impl.h"
#include "X25_PacketCfg_Impl.h"
#include "X25_Config_and_Response_Options_Impl.h"
#include "X25_GeneralFacilities_Impl.h"
#include "X25_CCITT_Facil_Impl.h"
#include "X25_Timers_Impl.h"

/**
  *@author DavidR
  */

class X25Config_Impl : public Form_X25_Config  {
public: 
	
	X25Config_Impl(QWidget* parent = 0,
								 const char* name = 0,
								 bool modal = TRUE,
								 WFlags fl = 0);

  void setDefaultX25CfgValues();

	~X25Config_Impl();

	X25_CONFIG_STRUCT m_X25_cfg_structOld, m_X25_cfg_structNew;

	X25_LogicalChannelCfg_Impl logical_chann_cfg;
	X25_PacketCfg_Impl packet_cfg;
	X25_Config_and_Response_Options_Impl cfg_and_response_options;
	X25_GeneralFacilities_Impl general_facilities;
	X25_CCITT_Facil_Impl ccitt_facil;
	X25_Timers_Impl timeouts_and_counters;

  void on_Cancel_clicked();
  void on_OK_clicked();

  void on_timeouts_and_counters_clicked();
  void on_CCITT_facilities_clicked();
  void on_configuration_options_clicked();
  void on_general_facilities_clicked();
  void on_logical_channels_clicked();
  void on_packet_configuration_clicked();

	void showEvent(QShowEvent * ev);

	void set_edit_box_value(QLineEdit * ed, int value);
	unsigned short get_edit_box_value(QLineEdit * ed);

	bool PassedChecks(X25_CONFIG_STRUCT cfg_block);
	bool total_channels_check(WORD *start);
	bool overlap_check(WORD low, WORD hi, char *item1, char *item2);
	bool bounds_check(WORD low, WORD hi, char *item);
	void ReportError(char * message);

};

#endif
